SystemOrganization addCategory: #'Java-ClassDefLoader'!
SystemOrganization addCategory: #'Java-ClassDefLoader-Attributes'!
SystemOrganization addCategory: #'Java-ClassDefLoader-ByteCode'!
SystemOrganization addCategory: #'Java-ClassDefLoader-ConstantPool'!
SystemOrganization addCategory: #'Java-ClassDefLoader-Tests'!
SystemOrganization addCategory: #'Java-Core'!
SystemOrganization addCategory: #'Java-Core-Type'!
SystemOrganization addCategory: #'Java-Serialization-Core'!
SystemOrganization addCategory: #'Java-Serialization-Inspector'!
SystemOrganization addCategory: #'Java-Serialization-Tests'!

!ByteArray methodsFor: '*Java-Core' stamp: 'btb 8/24/2004 22:24'!
asJavaSignedValue

	| result first |
	first := self first.
	result := self asJavaUnsignedValue.
	(first allMask: 16r80)
		ifTrue: [result := ((result bitXor: ((256 raisedTo: self size) - 1)) + 1) negated].
	^result! !

!ByteArray methodsFor: '*Java-Core' stamp: 'btb 8/24/2004 22:23'!
asJavaUnsignedValue

	| result |
	result := 0.
	self do: [:each |
		result := result << 8.
		result := result + each].
	^result! !

!Character methodsFor: '*Java' stamp: 'btb 10/27/2003 19:40'!
asJavaUTF8Character
	^JavaUTF8Character onCharacter: self! !

Magnitude subclass: #JavaUTF8Character
	instanceVariableNames: 'value'
	classVariableNames: 'Cache'
	poolDictionaries: ''
	category: 'Java-Core'!

!JavaUTF8Character commentStamp: 'btb 9/18/2003 19:47' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaUTF8Character class methodsFor: 'as yet unclassified' stamp: 'btb 5/24/2002 12:07'!
onCharacter: aCharacter

	^self value: aCharacter asciiValue! !

!JavaUTF8Character methodsFor: 'as yet unclassified' stamp: 'btb 2/15/2004 18:37'!
hash

	^self value hash! !

!JavaUTF8Character methodsFor: 'copying' stamp: 'btb 5/16/2002 21:32'!
copy! !

!JavaUTF8Character methodsFor: 'copying' stamp: 'btb 5/16/2002 21:32'!
deepCopy! !

!JavaUTF8Character methodsFor: 'converting' stamp: 'btb 5/16/2002 21:38'!
asAsciiCharacter

	"To be honest, I have no clue what to do here...Simply return a value between 0 and 16rFF"

	^(self value bitAnd: 16rFF) asCharacter! !

!JavaUTF8Character methodsFor: 'copying' stamp: 'btb 5/16/2002 21:32'!
veryDeepCopyWith: deepCopier

	! !

!JavaUTF8Character methodsFor: 'public' stamp: 'btb 5/16/2002 21:53'!
printOn: aStream

	aStream nextPutAll: 'UTF-8: $'.
	self isAscii
		ifTrue: [aStream nextPut: self asAsciiCharacter]
		ifFalse: [aStream nextPutAll: self value hex].! !

!JavaUTF8Character methodsFor: 'testing' stamp: 'btb 5/16/2002 21:50'!
isAscii

	^self value < 256! !

!JavaUTF8Character methodsFor: 'converting' stamp: 'btb 5/16/2002 22:15'!
asCharacter

	^self asAsciiCharacter! !

!JavaUTF8Character methodsFor: 'copying' stamp: 'btb 5/16/2002 21:32'!
clone! !

!JavaUTF8Character methodsFor: 'as yet unclassified' stamp: 'btb 2/15/2004 18:37'!
= aJavaUTF8Character

	^self value = aJavaUTF8Character value! !

!JavaUTF8Character methodsFor: 'converting' stamp: 'btb 5/16/2002 21:58'!
asAsciiString
	^ self asAsciiCharacter asString! !

!JavaUTF8Character methodsFor: 'private' stamp: 'btb 5/16/2002 21:29'!
value: anInteger

	value:=anInteger! !

!JavaUTF8Character class methodsFor: 'as yet unclassified' stamp: 'btb 5/16/2002 21:46'!
cache

	Cache ifNil: [Cache:=IdentityDictionary new].
	^Cache! !

!JavaUTF8Character class methodsFor: 'as yet unclassified' stamp: 'btb 3/4/2004 21:55'!
value: anInteger

	^self cache at: anInteger ifAbsentPut: [self basicNew value: anInteger]! !

!JavaUTF8Character methodsFor: 'converting' stamp: 'btb 10/27/2003 20:02'!
asJavaUTF8Character

	^self! !

!JavaUTF8Character methodsFor: 'converting' stamp: 'btb 5/16/2002 21:57'!
asString

	^self asAsciiString! !

!JavaUTF8Character methodsFor: 'public' stamp: 'btb 5/16/2002 21:30'!
value

	^value! !

Object subclass: #JavaClass
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Core'!

!JavaClass commentStamp: 'btb 9/18/2003 19:47' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

Object subclass: #JavaLocalVariableInfo
	instanceVariableNames: 'startPC length variableName index descriptor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader-Attributes'!

!JavaLocalVariableInfo commentStamp: 'btb 9/18/2003 19:46' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaLocalVariableInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 19:04'!
index
	^index! !

!JavaLocalVariableInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 19:03'!
startPC
	^startPC! !

!JavaLocalVariableInfo class methodsFor: 'reading' stamp: 'btb 8/16/2004 11:06'!
readFromClassDefLoader: aClassDefLoader

	^self new readFromClassDefLoader: aClassDefLoader! !

!JavaLocalVariableInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 19:04'!
length: anObject
	length := anObject! !

!JavaLocalVariableInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 19:06'!
variableName: anObject
	variableName := anObject! !

!JavaLocalVariableInfo methodsFor: 'reading' stamp: 'btb 8/16/2004 11:00'!
readFromClassDefLoader: aClassDefLoader

	self
		startPC: (aClassDefLoader nextUnsignedShort);
		length: (aClassDefLoader nextUnsignedShort);
		variableName: (aClassDefLoader nextClassPoolInfo asString);
		descriptor: (aClassDefLoader nextClassPoolInfo asString);
		index: (aClassDefLoader nextUnsignedShort)! !

!JavaLocalVariableInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 19:16'!
descriptor
	^descriptor! !

!JavaLocalVariableInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 19:03'!
length
	^length! !

!JavaLocalVariableInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 19:16'!
descriptor: anObject
	descriptor := anObject! !

!JavaLocalVariableInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 19:03'!
startPC: anObject
	startPC := anObject! !

!JavaLocalVariableInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 19:06'!
variableName
	^variableName! !

!JavaLocalVariableInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 19:04'!
index: anObject
	index := anObject! !

Object subclass: #JavaSerField
	instanceVariableNames: 'type name'
	classVariableNames: 'ClassMapping'
	poolDictionaries: ''
	category: 'Java-Serialization-Core'!

!JavaSerField commentStamp: '<historical>' prior: 0!
I represent a field in a java object. I know how to write the contents of myself when loading in objects from the stream. I also the name of my field and am part of the class description

Copyright (c) 2002 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 5/6/2002 12:17!

!JavaSerField methodsFor: 'reading' stamp: 'btb 4/28/2002 20:39'!
readContentsFrom: aJavaReadStream

	^self type readContentsFrom: aJavaReadStream! !

!JavaSerField class methodsFor: 'as yet unclassified' stamp: 'btb 2/25/2004 21:46'!
newFor: typeCode 
	| asciiTypeCode |
	asciiTypeCode := typeCode asCharacter.
	^(asciiTypeCode == $L or: [asciiTypeCode == $[]) 
		ifTrue: [JavaSerObjectField new]
		ifFalse: 
			[(JavaSerPrimitiveField new)
				type: (JavaType instanceFromString: asciiTypeCode asString);
				yourself]! !

!JavaSerField methodsFor: 'accessors-setters' stamp: 'btb 4/18/2002 19:12'!
name

	^name! !

!JavaSerField methodsFor: 'convience' stamp: 'btb 4/26/2002 17:08'!
asJavaSource

	^String streamContents: [:s | self printJavaSourceOn: s]! !

!JavaSerField methodsFor: 'writing' stamp: 'btb 2/28/2004 21:55'!
writeToJavaStream: aJavaWriteStream

	aJavaWriteStream nextPutChar: self type code.
	aJavaWriteStream nextPutJavaUTFString: self name asString! !

!JavaSerField methodsFor: 'convience' stamp: 'btb 4/26/2002 17:07'!
printJavaSourceOn: aStream

	aStream
		nextPutAll: (self typeName);
		nextPutAll: ' ';
		nextPutAll: (self name);
		nextPutAll: ';'! !

!JavaSerField methodsFor: 'convience' stamp: 'btb 4/28/2002 20:30'!
typeName

	^self type asJavaSource! !

!JavaSerField methodsFor: 'reading' stamp: 'btb 3/5/2004 10:57'!
readFrom: aJavaReadStream

	self name: aJavaReadStream nextJavaUTFString asAsciiString! !

!JavaSerField methodsFor: 'accessors-setters' stamp: 'btb 4/28/2002 20:33'!
type: aJavaType

	type:=aJavaType! !

JavaSerField subclass: #JavaSerObjectField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Serialization-Core'!

!JavaSerObjectField commentStamp: '<historical>' prior: 0!
I represent a java field that loads in a java object (first class or array). I simply have an additional to parameter to load in to know my type.

Copyright (c) 2002 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 5/6/2002 12:17!

!JavaSerObjectField methodsFor: 'as yet unclassified' stamp: 'btb 2/25/2004 21:45'!
readFrom: aJavaReadStream 
	super readFrom: aJavaReadStream.
	self type: (JavaType instanceFromString: aJavaReadStream readContent asString)! !

!JavaSerObjectField methodsFor: 'as yet unclassified' stamp: 'btb 2/28/2004 21:57'!
writeToJavaStream: aJavaWriteStream
	super writeToJavaStream: aJavaWriteStream.
	aJavaWriteStream writeContent: self type asTypeInfoString asJavaUTF8String! !

!JavaSerField methodsFor: 'accessors-setters' stamp: 'btb 2/27/2004 21:17'!
name: aString

	name:=aString asSymbol! !

!JavaSerField methodsFor: 'accessors-setters' stamp: 'btb 4/28/2002 20:33'!
type

	^type! !

JavaSerField subclass: #JavaSerPrimitiveField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Serialization-Core'!

!JavaSerPrimitiveField commentStamp: '<historical>' prior: 0!
I am simply a place holder for now. I will probably go away in the future.

Copyright (c) 2002 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 5/6/2002 12:16!

!JavaSerField methodsFor: 'convience' stamp: 'btb 4/26/2002 17:06'!
printOn: aStream

	self printJavaSourceOn: aStream! !

!JavaSerField methodsFor: 'writing' stamp: 'btb 2/15/2004 19:11'!
writeContents: anObject to: aJavaSerWriteStream

	^self type writeContents: anObject to: aJavaSerWriteStream! !

Object subclass: #JavaAbstractInfo
	instanceVariableNames: 'accessFlags nameInfo descriptorInfo attributesInfo descriptor classDefLoader'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader'!

!JavaAbstractInfo commentStamp: 'btb 9/18/2003 19:45' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaAbstractInfo methodsFor: 'access info' stamp: 'btb 8/14/2004 17:33'!
isFinal

	^self accessFlags anyMask: JavaClassDefLoaderConstants accFinal! !

!JavaAbstractInfo methodsFor: 'access info' stamp: 'btb 8/14/2004 17:32'!
isStrict

	^self accessFlags anyMask: JavaClassDefLoaderConstants accStrict! !

!JavaAbstractInfo methodsFor: 'accessing' stamp: 'btb 2/25/2004 21:46'!
descriptor

	^descriptor
		ifNil: [descriptor:=JavaType instanceFromString: self descriptorInfo asString]! !

!JavaAbstractInfo methodsFor: 'access info' stamp: 'btb 8/14/2004 17:32'!
isNative

	^self accessFlags anyMask: JavaClassDefLoaderConstants accNative! !

!JavaAbstractInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 19:13'!
attributesInfo
	^attributesInfo! !

!JavaAbstractInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 19:13'!
descriptorInfo
	^descriptorInfo! !

!JavaAbstractInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 19:13'!
attributesInfo: anObject
	attributesInfo := anObject! !

!JavaAbstractInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 19:13'!
descriptorInfo: anObject
	descriptorInfo := anObject! !

!JavaAbstractInfo methodsFor: 'accessing' stamp: 'btb 8/16/2004 10:27'!
classDefLoader
	^classDefLoader! !

!JavaAbstractInfo methodsFor: 'access info' stamp: 'btb 8/14/2004 17:32'!
isVolatile

	^self accessFlags anyMask: JavaClassDefLoaderConstants accVolatile! !

!JavaAbstractInfo methodsFor: 'as yet unclassified' stamp: 'btb 8/15/2004 20:19'!
attributeNamed: aString ifAbsent: aBlock

	^self attributesInfo at: aString ifAbsent: aBlock! !

JavaAbstractInfo subclass: #JavaMethodInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader'!

!JavaMethodInfo commentStamp: 'btb 9/18/2003 19:45' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaMethodInfo methodsFor: 'as yet unclassified' stamp: 'btb 8/16/2004 19:21'!
disassemblyString
	| result |
	result := String new writeStream.
	self disassembleOn: result.
	^result contents! !

!JavaMethodInfo methodsFor: 'as yet unclassified' stamp: 'btb 8/16/2004 19:01'!
printOn: aStream

	self printAccessFlagsOn: aStream.
	aStream 
		nextPutAll: (self descriptor asJavaSource: self nameInfo asString);
		nextPutAll: ' {'; cr.
	self disassembleOn: aStream.
	aStream nextPut: $}! !

!JavaMethodInfo methodsFor: 'as yet unclassified' stamp: 'btb 8/15/2004 20:18'!
code

	^self attributeNamed: JavaCodeAttributeInfo attributeName ifAbsent: [nil]! !

!JavaMethodInfo methodsFor: 'as yet unclassified' stamp: 'btb 8/16/2004 19:00'!
disassembleOn: aStream

	self isNative
		ifTrue: [aStream nextPutAll: '//native'; cr]
		ifFalse: [self code disassembleOn: aStream].! !

!JavaAbstractInfo methodsFor: 'as yet unclassified' stamp: 'btb 8/16/2004 10:40'!
readFromClassDefLoader: aClassDefLoader

	| count attributes |
	self classDefLoader: aClassDefLoader.
	self accessFlags: aClassDefLoader nextUnsignedShort.
	self nameInfo: aClassDefLoader nextConstantPoolInfo.
	self descriptorInfo: aClassDefLoader nextConstantPoolInfo.
	count:=aClassDefLoader nextUnsignedShort.
	attributes:=Dictionary new.
	self attributesInfo: attributes.
	count timesRepeat: [self addAttribute: aClassDefLoader loadAttributeInfo].! !

!JavaAbstractInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 19:12'!
nameInfo
	^nameInfo! !

!JavaAbstractInfo methodsFor: 'as yet unclassified' stamp: 'btb 8/11/2004 21:42'!
attributeNamed: aString

	^self attributesInfo at: aString! !

!JavaAbstractInfo methodsFor: 'access info' stamp: 'btb 8/14/2004 17:32'!
isTransient

	^self accessFlags anyMask: JavaClassDefLoaderConstants accTransient! !

!JavaAbstractInfo methodsFor: 'as yet unclassified' stamp: 'btb 4/29/2003 21:07'!
printAccessFlagsOn: aStream

	self isAbstract ifTrue: [aStream nextPutAll: 'abstract '].
	self isFinal ifTrue: [aStream nextPutAll: 'final '].
	self isPrivate ifTrue: [aStream nextPutAll: 'private '].
	self isProtected ifTrue: [aStream nextPutAll: 'protected '].
	self isPublic ifTrue: [aStream nextPutAll: 'public '].
	self isStatic ifTrue: [aStream nextPutAll: 'static '].
	self isStrict ifTrue: [aStream nextPutAll: 'strict '].
	self isSynchronized ifTrue: [aStream nextPutAll: 'synchronized '].
	self isTransient ifTrue: [aStream nextPutAll: 'transient '].
	self isVolatile ifTrue: [aStream nextPutAll: 'volatile '].! !

!JavaAbstractInfo methodsFor: 'access info' stamp: 'btb 8/14/2004 17:32'!
isAbstract

	^self accessFlags anyMask: JavaClassDefLoaderConstants accAbstract! !

!JavaAbstractInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 19:12'!
nameInfo: anObject
	nameInfo := anObject! !

!JavaAbstractInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 19:12'!
accessFlags: anObject
	accessFlags := anObject! !

!JavaAbstractInfo methodsFor: 'accessing' stamp: 'btb 8/16/2004 10:28'!
classDefLoader: anObject 
	classDefLoader := anObject! !

!JavaAbstractInfo methodsFor: 'access info' stamp: 'btb 8/14/2004 17:32'!
isProtected

	^self accessFlags anyMask: JavaClassDefLoaderConstants accProtected! !

!JavaAbstractInfo methodsFor: 'access info' stamp: 'btb 8/14/2004 17:32'!
isPrivate

	^self accessFlags anyMask: JavaClassDefLoaderConstants accPrivate! !

!JavaAbstractInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 19:12'!
accessFlags
	^accessFlags! !

!JavaAbstractInfo methodsFor: 'access info' stamp: 'btb 8/14/2004 17:31'!
isStatic

	^self accessFlags anyMask: JavaClassDefLoaderConstants accStatic! !

!JavaAbstractInfo methodsFor: 'as yet unclassified' stamp: 'btb 8/11/2004 21:42'!
addAttribute:  anAttributeInfo

	self attributesInfo at: anAttributeInfo nameInfo asString put: anAttributeInfo! !

JavaAbstractInfo subclass: #JavaFieldInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader'!

!JavaFieldInfo commentStamp: 'btb 9/18/2003 19:45' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaFieldInfo methodsFor: 'as yet unclassified' stamp: 'btb 4/29/2003 21:23'!
printOn: aStream

	self printAccessFlagsOn: aStream.
	aStream 
		nextPutAll: (self descriptor asJavaSource);
		nextPut: (Character space);
		nextPutAll: self nameInfo asString! !

!JavaAbstractInfo methodsFor: 'access info' stamp: 'btb 8/14/2004 17:32'!
isSynchronized

	^self accessFlags anyMask: JavaClassDefLoaderConstants accSynchronized! !

!JavaAbstractInfo methodsFor: 'access info' stamp: 'btb 8/14/2004 17:31'!
isPublic

	^self accessFlags anyMask: JavaClassDefLoaderConstants accPublic! !

Object subclass: #JavaInnerClassInfo
	instanceVariableNames: 'classInfo outerClassInfo innerName accessFlags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader-Attributes'!

!JavaInnerClassInfo commentStamp: 'btb 9/18/2003 19:46' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaInnerClassInfo methodsFor: 'flags' stamp: 'btb 8/14/2004 17:31'!
isInterface

	^self accessFlags anyMask: JavaClassDefLoaderConstants accInterface! !

!JavaInnerClassInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 19:29'!
outerClassInfo: anObject
	outerClassInfo := anObject! !

!JavaInnerClassInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 19:29'!
classInfo: anObject
	classInfo := anObject! !

!JavaInnerClassInfo methodsFor: 'flags' stamp: 'btb 8/14/2004 17:31'!
isFinal

	^self accessFlags anyMask: JavaClassDefLoaderConstants accFinal! !

!JavaInnerClassInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 19:30'!
accessFlags
	^accessFlags! !

!JavaInnerClassInfo methodsFor: 'flags' stamp: 'btb 8/14/2004 17:31'!
isAbstract

	^self accessFlags anyMask: JavaClassDefLoaderConstants accAbstract! !

!JavaInnerClassInfo methodsFor: 'flags' stamp: 'btb 8/14/2004 17:31'!
isPublic

	^self accessFlags anyMask: JavaClassDefLoaderConstants accPublic! !

!JavaInnerClassInfo methodsFor: 'reading' stamp: 'btb 8/16/2004 10:57'!
readFromClassDefLoader: aClassDefLoader

	self
		classInfo: (aClassDefLoader nextClassPoolInfo);
		outerClassInfo: (aClassDefLoader nextClassPoolInfo);
		innerName: (aClassDefLoader nextClassPoolInfo asString);
		accessFlags: (aClassDefLoader nextUnsignedShort)! !

!JavaInnerClassInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 19:30'!
accessFlags: anObject
	accessFlags := anObject! !

!JavaInnerClassInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 19:29'!
innerName: anObject
	innerName := anObject! !

!JavaInnerClassInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 19:29'!
outerClassInfo
	^outerClassInfo! !

!JavaInnerClassInfo methodsFor: 'flags' stamp: 'btb 8/14/2004 17:31'!
isPrivate

	^self accessFlags anyMask: JavaClassDefLoaderConstants accPrivate! !

!JavaInnerClassInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 19:29'!
innerName
	^innerName! !

!JavaInnerClassInfo methodsFor: 'flags' stamp: 'btb 8/14/2004 17:30'!
isProtected

	^self accessFlags anyMask: JavaClassDefLoaderConstants accProtected! !

!JavaInnerClassInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 19:29'!
classInfo
	^classInfo! !

!JavaInnerClassInfo class methodsFor: 'reading' stamp: 'btb 8/16/2004 11:08'!
readFromClassDefLoader: aClassDefLoader

	^self new readFromClassDefLoader: aClassDefLoader! !

!JavaInnerClassInfo methodsFor: 'flags' stamp: 'btb 8/14/2004 17:30'!
isStatic

	^self accessFlags anyMask: JavaClassDefLoaderConstants accStatic! !

Object subclass: #JavaAttributeInfo
	instanceVariableNames: 'nameInfo classDefLoader'
	classVariableNames: 'ClassMapping'
	poolDictionaries: ''
	category: 'Java-ClassDefLoader-Attributes'!

!JavaAttributeInfo commentStamp: 'btb 9/18/2003 19:45' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaAttributeInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 20:41'!
nameInfo: anObject
	nameInfo := anObject! !

!JavaAttributeInfo class methodsFor: 'as yet unclassified' stamp: 'btb 8/16/2004 11:03'!
readFromClassDefLoader: aClassDefLoader

	| attributeName newInstance |
	attributeName:=aClassDefLoader nextConstantPoolInfo asString.
	newInstance:=self newWithName: attributeName.
	newInstance readFromClassDefLoader: aClassDefLoader.
	^newInstance! !

!JavaAttributeInfo class methodsFor: 'as yet unclassified' stamp: 'btb 3/23/2003 20:44'!
newWithName: aName

	| newInstance aClass |
	aClass := self classMapping at: aName ifAbsentPut: [self findMappingFor: aName].
	newInstance:=aClass new.
	newInstance nameInfo: aName.
	^newInstance! !

!JavaAttributeInfo methodsFor: 'accessing' stamp: 'btb 8/16/2004 10:24'!
classDefLoader
	^classDefLoader! !

!JavaAttributeInfo methodsFor: 'reading' stamp: 'btb 8/16/2004 10:40'!
readFromClassDefLoader: aClassDefLoader

	self classDefLoader: aClassDefLoader! !

JavaAttributeInfo subclass: #JavaDeprecatedAttributeInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader-Attributes'!

!JavaDeprecatedAttributeInfo commentStamp: 'btb 9/18/2003 19:45' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaDeprecatedAttributeInfo class methodsFor: 'as yet unclassified' stamp: 'btb 5/11/2003 16:11'!
attributeName

	^'Deprecated'! !

!JavaDeprecatedAttributeInfo methodsFor: 'as yet unclassified' stamp: 'btb 8/16/2004 10:55'!
readFromClassDefLoader: aClassDefLoader

	super readFromClassDefLoader: aClassDefLoader.
	self readLength: aClassDefLoader.! !

!JavaAttributeInfo class methodsFor: 'as yet unclassified' stamp: 'btb 3/23/2003 20:59'!
findMappingFor: aName 
	^self allSubclasses
		detect: [:each | each attributeName = aName]
		ifNone: [aName
					ifNil: [JavaAttributeInfoError signal: 'Bad Attribute']
					ifNotNil: [self findMappingFor: nil]]! !

JavaAttributeInfo subclass: #JavaSourceFileAttributeInfo
	instanceVariableNames: 'sourceFileName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader-Attributes'!

!JavaSourceFileAttributeInfo commentStamp: 'btb 9/18/2003 19:46' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaSourceFileAttributeInfo class methodsFor: 'as yet unclassified' stamp: 'btb 5/11/2003 16:01'!
attributeName

	^'SourceFile'! !

!JavaSourceFileAttributeInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 18:57'!
sourceFileName: anObject
	sourceFileName := anObject! !

!JavaSourceFileAttributeInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 18:57'!
sourceFileName
	^sourceFileName! !

!JavaSourceFileAttributeInfo methodsFor: 'reading' stamp: 'btb 8/16/2004 11:01'!
readFromClassDefLoader: aClassDefLoader

	super readFromClassDefLoader: aClassDefLoader.
	self readLength: aClassDefLoader.
	self sourceFileName: (aClassDefLoader nextClassPoolInfo) asString.! !

JavaAttributeInfo subclass: #JavaLineNumberTableAttributeInfo
	instanceVariableNames: 'lineNumberTable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader-Attributes'!

!JavaLineNumberTableAttributeInfo commentStamp: 'btb 9/18/2003 19:46' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaLineNumberTableAttributeInfo methodsFor: 'reading' stamp: 'btb 8/16/2004 10:59'!
readFromClassDefLoader: aClassDefLoader

	|  tableLength |
	super readFromClassDefLoader: aClassDefLoader.
	self readLength: aClassDefLoader.
	tableLength:=aClassDefLoader nextUnsignedShort.
	self lineNumberTable: (OrderedCollection new: tableLength).
	tableLength timesRepeat: [self lineNumberTable add: (JavaLineNumberInfo readFromClassDefLoader: aClassDefLoader)]! !

!JavaLineNumberTableAttributeInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 17:45'!
lineNumberTable
	^lineNumberTable! !

!JavaLineNumberTableAttributeInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 17:45'!
lineNumberTable: anObject
	lineNumberTable := anObject! !

!JavaLineNumberTableAttributeInfo class methodsFor: 'as yet unclassified' stamp: 'btb 5/11/2003 16:12'!
attributeName

	^'LineNumberTable'! !

JavaAttributeInfo subclass: #JavaConstantValueAttributeInfo
	instanceVariableNames: 'constantValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader-Attributes'!

!JavaConstantValueAttributeInfo commentStamp: 'btb 9/18/2003 19:45' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaConstantValueAttributeInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 19:41'!
constantValue
	^constantValue! !

!JavaConstantValueAttributeInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 19:41'!
constantValue: anObject
	constantValue := anObject! !

!JavaConstantValueAttributeInfo methodsFor: 'reading' stamp: 'btb 8/16/2004 11:05'!
readFromClassDefLoader: aClassDefLoader

	super readFromClassDefLoader: aClassDefLoader.
	self readLength: aClassDefLoader.
	self constantValue: aClassDefLoader nextClassPoolInfo! !

!JavaConstantValueAttributeInfo class methodsFor: 'as yet unclassified' stamp: 'btb 5/11/2003 15:57'!
attributeName

	^'ConstantValue'! !

JavaAttributeInfo subclass: #JavaLocalVariableTableAttributeInfo
	instanceVariableNames: 'localVariableTable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader-Attributes'!

!JavaLocalVariableTableAttributeInfo commentStamp: 'btb 9/18/2003 19:46' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaLocalVariableTableAttributeInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 19:00'!
localVariableTable
	^localVariableTable! !

!JavaLocalVariableTableAttributeInfo class methodsFor: 'as yet unclassified' stamp: 'btb 5/11/2003 16:12'!
attributeName

	^'LocalVariableTable'! !

!JavaLocalVariableTableAttributeInfo methodsFor: 'reading' stamp: 'btb 8/16/2004 11:00'!
readFromClassDefLoader: aClassDefLoader

	| length |
	super readFromClassDefLoader: aClassDefLoader.
	self readLength: aClassDefLoader.
	length := aClassDefLoader nextUnsignedShort.
	self localVariableTable: (OrderedCollection new: length).
	length timesRepeat: [self localVariableTable add: (JavaLocalVariableInfo readFromClassDefLoader: aClassDefLoader)]
	! !

!JavaLocalVariableTableAttributeInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 19:00'!
localVariableTable: anObject
	localVariableTable := anObject! !

JavaAttributeInfo subclass: #JavaInnerClassesAttributeInfo
	instanceVariableNames: 'classes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader-Attributes'!

!JavaInnerClassesAttributeInfo commentStamp: 'btb 9/18/2003 19:46' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaInnerClassesAttributeInfo methodsFor: 'reading' stamp: 'btb 8/16/2004 10:58'!
readFromClassDefLoader: aClassDefLoader

	| length |
	super readFromClassDefLoader: aClassDefLoader.
	self readLength: aClassDefLoader.
	length := aClassDefLoader nextUnsignedShort.
	self classes: (OrderedCollection new: length).
	length timesRepeat: [self classes add: (JavaInnerClassInfo readFromClassDefLoader: aClassDefLoader)]
	! !

!JavaInnerClassesAttributeInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 19:25'!
classes
	^classes! !

!JavaInnerClassesAttributeInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 19:25'!
classes: anObject
	classes := anObject! !

!JavaInnerClassesAttributeInfo class methodsFor: 'as yet unclassified' stamp: 'btb 5/11/2003 16:11'!
attributeName

	^'InnerClasses'! !

!JavaAttributeInfo class methodsFor: 'accessing' stamp: 'btb 3/23/2003 20:43'!
classMapping
	^ClassMapping ifNil: [ClassMapping := Dictionary new].! !

JavaAttributeInfo subclass: #JavaExceptionsAttributeInfo
	instanceVariableNames: 'exceptions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader-Attributes'!

!JavaExceptionsAttributeInfo commentStamp: 'btb 9/18/2003 19:45' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaExceptionsAttributeInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 17:51'!
exceptions
	^exceptions! !

!JavaExceptionsAttributeInfo class methodsFor: 'as yet unclassified' stamp: 'btb 5/11/2003 16:11'!
attributeName

	^'Exceptions'! !

!JavaExceptionsAttributeInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 17:51'!
exceptions: anObject
	exceptions := anObject! !

!JavaExceptionsAttributeInfo methodsFor: 'reading' stamp: 'btb 8/16/2004 10:56'!
readFromClassDefLoader: aClassDefLoader

	| length |
	super readFromClassDefLoader: aClassDefLoader.
	self readLength: aClassDefLoader.
	length := aClassDefLoader nextUnsignedShort.
	self exceptions: (OrderedCollection new: length).
	length timesRepeat: [self exceptions add: (aClassDefLoader nextClassPoolInfo)]! !

!JavaAttributeInfo methodsFor: 'reading' stamp: 'btb 5/11/2003 15:51'!
readLength: aClassLoader

	^aClassLoader nextUnsignedInt! !

!JavaAttributeInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 20:41'!
nameInfo
	^nameInfo! !

!JavaAttributeInfo class methodsFor: 'as yet unclassified' stamp: 'btb 3/23/2003 20:56'!
initialize

	ClassMapping := nil.! !

JavaAttributeInfo subclass: #JavaCodeAttributeInfo
	instanceVariableNames: 'maxStack maxLocals byteCodes exceptionTables attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader-Attributes'!

!JavaCodeAttributeInfo commentStamp: 'btb 9/18/2003 19:45' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaCodeAttributeInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 16:19'!
byteCodes
	^byteCodes! !

!JavaCodeAttributeInfo class methodsFor: 'as yet unclassified' stamp: 'btb 5/11/2003 16:03'!
attributeName

	^'Code'! !

!JavaCodeAttributeInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 16:19'!
maxLocals
	^maxLocals! !

!JavaCodeAttributeInfo methodsFor: 'reading' stamp: 'btb 8/24/2004 20:06'!
disassembleOn: aStream

	| disassembler |
	disassembler := JavaByteCodeDisassembler on: aStream.
	disassembler 
		execute: (JavaReadStream onStream: self byteCodes readStream) 
		for: self classDefLoader.! !

!JavaCodeAttributeInfo methodsFor: 'reading' stamp: 'btb 8/16/2004 10:46'!
readFromClassDefLoader: aClassDefLoader 
	| byteCodeLength exceptionTableLength attributesLength |
	super readFromClassDefLoader: aClassDefLoader.
	"read the length...ignore it...we don't need it!!"
	self readLength: aClassDefLoader.
	self maxStack: aClassDefLoader nextUnsignedShort.
	self maxLocals: aClassDefLoader nextUnsignedShort.
	byteCodeLength := aClassDefLoader nextUnsignedInt.
	self byteCodes: (ByteArray new: byteCodeLength).
	1 to: byteCodeLength
		do: [:index | self byteCodes at: index put: aClassDefLoader nextUnsignedByte].
	exceptionTableLength := aClassDefLoader nextUnsignedShort.
	self exceptionTables: (OrderedCollection new: exceptionTableLength).
	exceptionTableLength timesRepeat: 
			[self exceptionTables 
				add: (JavaCodeExceptionInfo readFromClassDefLoader: aClassDefLoader)].
	attributesLength := aClassDefLoader nextUnsignedShort.
	self attributes: (OrderedCollection new: attributesLength).
	attributesLength timesRepeat: 
			[self attributes add: (JavaAttributeInfo readFromClassDefLoader: aClassDefLoader)]! !

!JavaCodeAttributeInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 16:19'!
maxLocals: anObject
	maxLocals := anObject! !

!JavaCodeAttributeInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 17:02'!
exceptionTables
	^exceptionTables! !

!JavaCodeAttributeInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 16:19'!
byteCodes: anObject
	byteCodes := anObject! !

!JavaCodeAttributeInfo methodsFor: 'reading' stamp: 'btb 8/15/2004 18:52'!
printOn: aStream

	super printOn: aStream.
	aStream nextPut: ${; cr.
	self disassembleOn: aStream.
	aStream nextPut: $}.! !

!JavaCodeAttributeInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 16:20'!
attributes
	^attributes! !

!JavaCodeAttributeInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 16:19'!
maxStack: anObject
	maxStack := anObject! !

!JavaCodeAttributeInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 17:01'!
exceptionTables: anObject
	exceptionTables := anObject! !

!JavaCodeAttributeInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 16:19'!
maxStack
	^maxStack! !

!JavaCodeAttributeInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 16:20'!
attributes: anObject
	attributes := anObject! !

JavaAttributeInfo subclass: #JavaSyntheticAttributeInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader-Attributes'!

!JavaSyntheticAttributeInfo commentStamp: 'btb 9/18/2003 19:46' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaSyntheticAttributeInfo class methodsFor: 'as yet unclassified' stamp: 'btb 5/11/2003 16:13'!
attributeName

	^'Synthetic'! !

!JavaSyntheticAttributeInfo methodsFor: 'as yet unclassified' stamp: 'btb 8/16/2004 11:01'!
readFromClassDefLoader: aClassDefLoader

	super readFromClassDefLoader: aClassDefLoader.
	self readLength: aClassDefLoader.! !

JavaAttributeInfo subclass: #JavaUnknownAttributeInfo
	instanceVariableNames: 'info'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader-Attributes'!

!JavaUnknownAttributeInfo commentStamp: 'btb 9/18/2003 19:46' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaUnknownAttributeInfo methodsFor: 'as yet unclassified' stamp: 'btb 8/24/2004 20:21'!
readFromClassDefLoader: aClassDefLoader

	| length |
	super readFromClassDefLoader: aClassDefLoader.
	length := self readLength: aClassDefLoader.
	self info: (ByteArray new: length).
	1 to: length do: [:index | self info at: index put: aClassDefLoader nextUnsignedByte].! !

!JavaUnknownAttributeInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 19:55'!
info: anObject
	info := anObject! !

!JavaUnknownAttributeInfo class methodsFor: 'as yet unclassified' stamp: 'btb 3/23/2003 20:36'!
attributeName

	^nil! !

!JavaUnknownAttributeInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 19:55'!
info
	^info! !

!JavaAttributeInfo class methodsFor: 'as yet unclassified' stamp: 'btb 3/23/2003 20:40'!
attributeName

	^self subclassResponsibility! !

!JavaAttributeInfo methodsFor: 'accessing' stamp: 'btb 8/16/2004 10:24'!
classDefLoader: anObject 
	classDefLoader := anObject! !

Object subclass: #JavaConstantPoolInfo
	instanceVariableNames: 'classDefLoader'
	classVariableNames: 'ClassMapping'
	poolDictionaries: ''
	category: 'Java-ClassDefLoader-ConstantPool'!

!JavaConstantPoolInfo commentStamp: 'btb 9/18/2003 19:46' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaConstantPoolInfo methodsFor: 'convience' stamp: 'btb 8/16/2004 10:25'!
constantPoolInfoAt: index

	^self classDefLoader constantPoolInfoAt: index! !

JavaConstantPoolInfo subclass: #JavaConstantPoolDoubleInfo
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader-ConstantPool'!

!JavaConstantPoolDoubleInfo commentStamp: 'btb 9/18/2003 19:46' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaConstantPoolDoubleInfo methodsFor: 'printing' stamp: 'btb 3/23/2003 14:59'!
printOn: aStream
	aStream nextPutAll: self name.
	aStream nextPut: $:.
	self value printOn: aStream.! !

!JavaConstantPoolDoubleInfo methodsFor: 'public' stamp: 'btb 8/16/2004 17:51'!
shouldSkipNext

	^true! !

!JavaConstantPoolDoubleInfo class methodsFor: 'as yet unclassified' stamp: 'btb 3/22/2003 18:31'!
tag

	^6! !

!JavaConstantPoolDoubleInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 12:27'!
value
	^value! !

!JavaConstantPoolDoubleInfo methodsFor: 'as yet unclassified' stamp: 'btb 8/16/2004 10:49'!
readFromClassDefLoader: aJavaClassDefLoader

	super readFromClassDefLoader: aJavaClassDefLoader.
	self value: aJavaClassDefLoader nextDouble.! !

!JavaConstantPoolDoubleInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 12:25'!
value: anObject
	value := anObject! !

JavaConstantPoolInfo subclass: #JavaConstantPoolFloatInfo
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader-ConstantPool'!

!JavaConstantPoolFloatInfo commentStamp: 'btb 9/18/2003 19:46' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaConstantPoolFloatInfo class methodsFor: 'as yet unclassified' stamp: 'btb 3/22/2003 18:32'!
tag

	^4! !

!JavaConstantPoolFloatInfo methodsFor: 'reading' stamp: 'btb 8/16/2004 10:50'!
readFromClassDefLoader: aJavaClassDefLoader

	super readFromClassDefLoader: aJavaClassDefLoader.
	self value: aJavaClassDefLoader nextFloat.! !

!JavaConstantPoolFloatInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 12:50'!
value: anObject
	value := anObject! !

!JavaConstantPoolFloatInfo methodsFor: 'printing' stamp: 'btb 3/23/2003 15:00'!
printOn: aStream
	aStream nextPutAll: self name.
	aStream nextPut: $:.
	self value printOn: aStream.! !

!JavaConstantPoolFloatInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 12:50'!
value
	^value! !

!JavaConstantPoolInfo class methodsFor: 'private' stamp: 'btb 3/22/2003 18:18'!
tag

	^self subclassResponsibility! !

!JavaConstantPoolInfo methodsFor: 'reading' stamp: 'btb 8/16/2004 10:41'!
readFromClassDefLoader: aJavaClassDefLoader

	self classDefLoader: aJavaClassDefLoader! !

!JavaConstantPoolInfo methodsFor: 'public' stamp: 'btb 8/16/2004 19:00'!
disassembleOn: aStream

	self printOn: aStream! !

!JavaConstantPoolInfo methodsFor: 'accessing' stamp: 'btb 8/16/2004 10:30'!
classDefLoader: anObject 
	classDefLoader := anObject! !

JavaConstantPoolInfo subclass: #JavaConstantPoolStringInfo
	instanceVariableNames: 'utf8Index stringValue'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader-ConstantPool'!

!JavaConstantPoolStringInfo commentStamp: 'btb 9/18/2003 19:47' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaConstantPoolStringInfo methodsFor: 'printing' stamp: 'btb 4/29/2003 20:54'!
printOn: aStream

	aStream 
		nextPutAll: (self name);
		nextPut: $:;
		nextPut: $';
		nextPutAll: self asString;
		nextPut: $'! !

!JavaConstantPoolStringInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 12:36'!
utf8Index: anObject
	utf8Index := anObject! !

!JavaConstantPoolStringInfo methodsFor: 'reading' stamp: 'btb 8/16/2004 10:54'!
readFromClassDefLoader: aJavaClassDefLoader

	super readFromClassDefLoader: aJavaClassDefLoader.
	self utf8Index: aJavaClassDefLoader nextUnsignedShort.! !

!JavaConstantPoolStringInfo methodsFor: 'converting' stamp: 'btb 3/23/2003 14:37'!
asString

	^self stringValue
	! !

!JavaConstantPoolStringInfo class methodsFor: 'as yet unclassified' stamp: 'btb 3/22/2003 18:34'!
tag

	^8! !

!JavaConstantPoolStringInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 14:37'!
stringValue
	^stringValue ifNil: [stringValue:=(self constantPoolInfoAt: self utf8Index) asString]! !

!JavaConstantPoolStringInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 12:36'!
utf8Index
	^utf8Index! !

JavaConstantPoolInfo subclass: #JavaConstantPoolReferenceInfo
	instanceVariableNames: 'classIndex nameAndTypeIndex classValue nameAndTypeInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader-ConstantPool'!

!JavaConstantPoolReferenceInfo commentStamp: 'btb 9/18/2003 19:47' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaConstantPoolReferenceInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 12:32'!
classIndex: anObject
	classIndex := anObject! !

!JavaConstantPoolReferenceInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 18:13'!
nameValue
	^self nameAndTypeInfo nameValue! !

!JavaConstantPoolReferenceInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 12:32'!
classIndex
	^classIndex! !

!JavaConstantPoolReferenceInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 18:13'!
typeInfo
	^self nameAndTypeInfo typeInfo! !

!JavaConstantPoolReferenceInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 12:32'!
nameAndTypeIndex: anObject
	nameAndTypeIndex := anObject! !

JavaConstantPoolReferenceInfo subclass: #JavaConstantPoolMethodReferenceInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader-ConstantPool'!

!JavaConstantPoolMethodReferenceInfo commentStamp: 'btb 9/18/2003 19:47' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaConstantPoolMethodReferenceInfo class methodsFor: 'as yet unclassified' stamp: 'btb 3/22/2003 18:33'!
tag

	^10! !

!JavaConstantPoolMethodReferenceInfo methodsFor: 'as yet unclassified' stamp: 'btb 8/16/2004 19:06'!
javaInfoOn: aStream

	self classValue javaType printJavaSourceOn: aStream.
	aStream nextPutAll: '>>'.
	self typeInfo returnType printJavaSourceOn: aStream.
	aStream nextPutAll: ' '.
	aStream nextPutAll: self nameValue.
	aStream nextPut: $(.
	self typeInfo arguments do: [:each | each printJavaSourceOn: aStream] separatedBy: [aStream nextPutAll: ', '].
	aStream nextPut: $).! !

!JavaConstantPoolMethodReferenceInfo methodsFor: 'as yet unclassified' stamp: 'btb 8/16/2004 19:06'!
printOn: aStream
	aStream nextPutAll: self name.
	aStream nextPut: $:.
	self javaInfoOn: aStream! !

!JavaConstantPoolMethodReferenceInfo methodsFor: 'as yet unclassified' stamp: 'btb 8/16/2004 19:07'!
disassembleOn: aStream

	self javaInfoOn: aStream! !

JavaConstantPoolMethodReferenceInfo subclass: #JavaConstantPoolInterfaceMethodReferenceInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader-ConstantPool'!

!JavaConstantPoolInterfaceMethodReferenceInfo commentStamp: 'btb 9/18/2003 19:47' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaConstantPoolInterfaceMethodReferenceInfo class methodsFor: 'as yet unclassified' stamp: 'btb 3/22/2003 18:33'!
tag

	^11! !

!JavaConstantPoolReferenceInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 18:11'!
classValue
	^classValue ifNil: [classValue:=self constantPoolInfoAt: self classIndex]! !

!JavaConstantPoolReferenceInfo methodsFor: 'reading' stamp: 'btb 8/16/2004 10:53'!
readFromClassDefLoader: aJavaClassDefLoader

	super readFromClassDefLoader: aJavaClassDefLoader.
	self classIndex: aJavaClassDefLoader nextUnsignedShort.
	self nameAndTypeIndex: aJavaClassDefLoader nextUnsignedShort.! !

!JavaConstantPoolReferenceInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 12:32'!
nameAndTypeIndex
	^nameAndTypeIndex! !

!JavaConstantPoolReferenceInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 18:12'!
nameAndTypeInfo
	^nameAndTypeInfo ifNil: [nameAndTypeInfo:=self constantPoolInfoAt: self nameAndTypeIndex]! !

JavaConstantPoolReferenceInfo subclass: #JavaConstantPoolFieldReferenceInfo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader-ConstantPool'!

!JavaConstantPoolFieldReferenceInfo commentStamp: 'btb 9/18/2003 19:46' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaConstantPoolFieldReferenceInfo methodsFor: 'as yet unclassified' stamp: 'btb 8/16/2004 19:07'!
javaInfoOn: aStream

	self classValue javaType printJavaSourceOn: aStream.
	aStream nextPutAll: '>>'.
	self typeInfo printJavaSourceOn: aStream.
	aStream nextPutAll: ' '.
	aStream nextPutAll: self nameValue.! !

!JavaConstantPoolFieldReferenceInfo methodsFor: 'as yet unclassified' stamp: 'btb 8/16/2004 19:08'!
printOn: aStream
	aStream nextPutAll: self name.
	aStream nextPut: $:.
	self javaInfoOn: aStream! !

!JavaConstantPoolFieldReferenceInfo methodsFor: 'as yet unclassified' stamp: 'btb 8/16/2004 19:08'!
disassembleOn: aStream

	self javaInfoOn: aStream! !

!JavaConstantPoolFieldReferenceInfo class methodsFor: 'as yet unclassified' stamp: 'btb 3/22/2003 18:32'!
tag

	^9! !

!JavaConstantPoolInfo methodsFor: 'accessing' stamp: 'btb 8/16/2004 10:30'!
classDefLoader
	^classDefLoader! !

!JavaConstantPoolInfo methodsFor: 'convience' stamp: 'btb 3/23/2003 14:58'!
name

	| classNameStream |
	classNameStream:=self class name readStream.
	classNameStream skip: ('JavaConstantPool' size).
	^classNameStream upToEnd
	! !

!JavaConstantPoolInfo class methodsFor: 'accessing' stamp: 'btb 3/23/2003 17:30'!
newForTag: anInteger

	| aClass |
	aClass:=self classMapping at: anInteger ifAbsentPut: [self findMappingForTag: anInteger].
	^aClass new! !

JavaConstantPoolInfo subclass: #JavaConstantPoolIntegerInfo
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader-ConstantPool'!

!JavaConstantPoolIntegerInfo commentStamp: 'btb 9/18/2003 19:47' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaConstantPoolIntegerInfo methodsFor: 'printing' stamp: 'btb 3/23/2003 15:00'!
printOn: aStream
	aStream nextPutAll: self name.
	aStream nextPut: $:.
	self value printOn: aStream.! !

!JavaConstantPoolIntegerInfo class methodsFor: 'as yet unclassified' stamp: 'btb 3/22/2003 18:32'!
tag

	^3! !

!JavaConstantPoolIntegerInfo methodsFor: 'reading' stamp: 'btb 8/16/2004 10:51'!
readFromClassDefLoader: aJavaClassDefLoader

	super readFromClassDefLoader: aJavaClassDefLoader.
	self value: aJavaClassDefLoader nextInt.! !

!JavaConstantPoolIntegerInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 12:49'!
value: anObject
	value := anObject! !

!JavaConstantPoolIntegerInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 12:49'!
value
	^value! !

!JavaConstantPoolInfo class methodsFor: 'accessing' stamp: 'btb 3/22/2003 18:12'!
classMapping
	^ClassMapping ifNil: [ClassMapping:=IdentityDictionary new]! !

JavaConstantPoolInfo subclass: #JavaConstantPoolLongInfo
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader-ConstantPool'!

!JavaConstantPoolLongInfo commentStamp: 'btb 9/18/2003 19:47' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaConstantPoolLongInfo methodsFor: 'public' stamp: 'btb 8/16/2004 17:51'!
shouldSkipNext

	^true! !

!JavaConstantPoolLongInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 12:29'!
value
	^value! !

!JavaConstantPoolLongInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 12:28'!
value: anObject
	value := anObject! !

!JavaConstantPoolLongInfo class methodsFor: 'as yet unclassified' stamp: 'btb 3/22/2003 18:33'!
tag

	^5! !

!JavaConstantPoolLongInfo methodsFor: 'reading' stamp: 'btb 8/16/2004 17:52'!
readFromClassDefLoader: aJavaClassDefLoader

	super readFromClassDefLoader: aJavaClassDefLoader.
	self value: aJavaClassDefLoader nextLong.! !

!JavaConstantPoolLongInfo methodsFor: 'printing' stamp: 'btb 3/23/2003 15:00'!
printOn: aStream
	aStream nextPutAll: self name.
	aStream nextPut: $:.
	self value printOn: aStream.! !

JavaConstantPoolInfo subclass: #JavaConstantPoolUtf8Info
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader-ConstantPool'!

!JavaConstantPoolUtf8Info commentStamp: 'btb 9/18/2003 19:47' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaConstantPoolUtf8Info methodsFor: 'accessing' stamp: 'btb 3/23/2003 13:00'!
value: anObject
	value := anObject! !

!JavaConstantPoolUtf8Info methodsFor: 'reading' stamp: 'btb 8/16/2004 10:54'!
readFromClassDefLoader: aJavaClassDefLoader

	super readFromClassDefLoader: aJavaClassDefLoader.
	self value: aJavaClassDefLoader nextJavaUTFString! !

!JavaConstantPoolUtf8Info class methodsFor: 'as yet unclassified' stamp: 'btb 3/22/2003 18:34'!
tag

	^1! !

!JavaConstantPoolUtf8Info methodsFor: 'printing' stamp: 'btb 4/29/2003 20:53'!
printOn: aStream

	aStream 
		nextPutAll: (self name);
		nextPut: $:;
		nextPut: $';
		nextPutAll: self asString;
		nextPut: $'! !

!JavaConstantPoolUtf8Info methodsFor: 'converting' stamp: 'btb 3/23/2003 14:22'!
asString

	^self value asString! !

!JavaConstantPoolUtf8Info methodsFor: 'accessing' stamp: 'btb 3/23/2003 13:00'!
value
	^value! !

JavaConstantPoolInfo subclass: #JavaConstantPoolClassInfo
	instanceVariableNames: 'nameIndex javaType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader-ConstantPool'!

!JavaConstantPoolClassInfo commentStamp: 'btb 9/18/2003 19:46' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaConstantPoolClassInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 12:26'!
nameIndex: anObject
	nameIndex := anObject! !

!JavaConstantPoolClassInfo methodsFor: 'as yet unclassified' stamp: 'btb 8/16/2004 10:49'!
readFromClassDefLoader: aJavaClassDefLoader

	super readFromClassDefLoader: aJavaClassDefLoader.
	self nameIndex: aJavaClassDefLoader nextUnsignedShort.! !

!JavaConstantPoolClassInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 12:26'!
nameIndex
	^nameIndex! !

!JavaConstantPoolClassInfo class methodsFor: 'as yet unclassified' stamp: 'btb 3/22/2003 18:31'!
tag

	^7! !

!JavaConstantPoolClassInfo methodsFor: 'as yet unclassified' stamp: 'btb 2/25/2004 21:09'!
obtainJavaTypeFor: typeString

	"alright, this is a HACK because of the inconsistency in the java class info"
	^(typeString first = JavaArrayType code)
		ifTrue: [JavaType readFromStream: (ReadStream on: typeString)]
		ifFalse: [JavaType readFromStream: (ReadStream on: (JavaObjectType code asString, typeString))]! !

!JavaConstantPoolClassInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 17:24'!
javaType
	^javaType ifNil: [javaType:=self obtainJavaTypeFor: (self constantPoolInfoAt: self nameIndex) asString].! !

!JavaConstantPoolClassInfo methodsFor: 'printing' stamp: 'btb 3/23/2003 14:40'!
printOn: aStream
	aStream nextPutAll: self name.
	aStream nextPut: $:.
	self javaType printOn: aStream.! !

!JavaConstantPoolInfo class methodsFor: 'private' stamp: 'btb 3/23/2003 17:58'!
findMappingForTag: anInteger

	^JavaConstantPoolInfo allSubclasses detect: [:each | [each tag = anInteger] on: Error do: [false]] ifNone: [self error: 'Bad Tag: ', anInteger printString]! !

!JavaConstantPoolInfo methodsFor: 'public' stamp: 'btb 8/16/2004 17:51'!
shouldSkipNext

	^false! !

JavaConstantPoolInfo subclass: #JavaConstantPoolNameAndTypeInfo
	instanceVariableNames: 'nameIndex descriptorIndex nameValue typeInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader-ConstantPool'!

!JavaConstantPoolNameAndTypeInfo commentStamp: 'btb 9/18/2003 19:47' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaConstantPoolNameAndTypeInfo methodsFor: 'printing' stamp: 'btb 3/23/2003 17:51'!
printOn: aStream

	aStream nextPutAll: self name.
	aStream nextPut: $:.
	aStream nextPutAll: self nameValue.
	aStream nextPut: $,.
	aStream nextPutAll: self typeInfo asString! !

!JavaConstantPoolNameAndTypeInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 12:54'!
descriptorIndex
	^descriptorIndex! !

!JavaConstantPoolNameAndTypeInfo class methodsFor: 'as yet unclassified' stamp: 'btb 3/22/2003 18:33'!
tag

	^12! !

!JavaConstantPoolNameAndTypeInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 12:54'!
descriptorIndex: anObject
	descriptorIndex := anObject! !

!JavaConstantPoolNameAndTypeInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 15:06'!
nameValue
	^nameValue ifNil: [nameValue:=(self constantPoolInfoAt: self nameIndex) asString]! !

!JavaConstantPoolNameAndTypeInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 12:54'!
nameIndex: anObject
	nameIndex := anObject! !

!JavaConstantPoolNameAndTypeInfo methodsFor: 'reading' stamp: 'btb 8/16/2004 10:52'!
readFromClassDefLoader: aJavaClassDefLoader

	super readFromClassDefLoader: aJavaClassDefLoader.
	self nameIndex: aJavaClassDefLoader nextUnsignedShort.
	self descriptorIndex: aJavaClassDefLoader nextUnsignedShort.! !

!JavaConstantPoolNameAndTypeInfo methodsFor: 'accessing' stamp: 'btb 3/23/2003 12:54'!
nameIndex
	^nameIndex! !

!JavaConstantPoolNameAndTypeInfo methodsFor: 'accessing' stamp: 'btb 2/25/2004 21:46'!
typeInfo
	^typeInfo ifNil: [typeInfo := JavaType instanceFromString: (self constantPoolInfoAt: self descriptorIndex) asString]! !

Object subclass: #JavaType
	instanceVariableNames: 'typeInfoCache'
	classVariableNames: 'ClassMapping'
	poolDictionaries: ''
	category: 'Java-Core-Type'!

!JavaType commentStamp: '<historical>' prior: 0!
I represent any java type. I am an abstract superclass and must not be instatiated on my own. But,
given a type definition from the read stream, I know which type to instantiate.

Copyright (c) 2002 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 5/6/2002 12:22!

!JavaType methodsFor: 'private' stamp: 'btb 2/27/2004 19:43'!
code

	^self class code! !

!JavaType methodsFor: 'public' stamp: 'btb 2/16/2004 20:37'!
writeContents: anObject to: aJavaSerWriteStream 
	"Write an object out to the stream"
	^ self subclassResponsibility! !

!JavaType methodsFor: 'public' stamp: 'btb 2/28/2004 18:11'!
printOn: aStream 
	"Print myself on aStream 
	btb 5/6/2002 11:56 "
	self printJavaSourceOn: aStream! !

!JavaType class methodsFor: 'public' stamp: 'btb 2/25/2004 20:59'!
readFromStream: aStream

	^(self classFor: aStream next) readTypeInfo: aStream
	! !

!JavaType methodsFor: 'public' stamp: 'btb 5/6/2002 12:07'!
readContentsFrom: aJavaReadStream 
	"Read an object from aJavaReadStream of my type 
	btb 5/6/2002 12:06"
	^ self subclassResponsibility! !

!JavaType methodsFor: 'private' stamp: 'btb 2/27/2004 19:20'!
hash

	^self asTypeInfoString hash! !

JavaType subclass: #JavaArrayType
	instanceVariableNames: 'type'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Core-Type'!

!JavaArrayType commentStamp: '<historical>' prior: 0!
I represent a primitive array in java (type[])

Copyright (c) 2002 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 5/6/2002 12:19!

!JavaArrayType class methodsFor: 'as yet unclassified' stamp: 'btb 3/23/2003 15:17'!
code

	^$[! !

!JavaArrayType methodsFor: 'public' stamp: 'btb 4/28/2002 18:51'!
printJavaSourceOn: aStream

	self type printJavaSourceOn: aStream.
	aStream nextPutAll: '[]'! !

!JavaArrayType methodsFor: 'private' stamp: 'btb 4/28/2002 18:23'!
type

	^type! !

!JavaArrayType methodsFor: 'public' stamp: 'btb 2/16/2004 20:43'!
writeContents: anObject to: aJavaSerWriteStream 
	
	aJavaSerWriteStream writeContent: anObject! !

!JavaArrayType methodsFor: 'public' stamp: 'btb 10/27/2003 20:22'!
readContentsFrom: aJavaReadStream 
	"Make sure you are reading an Array by peeking into the stream"

	^aJavaReadStream peekIsArray 
		ifTrue: [aJavaReadStream readContent]
		ifFalse: [self error: 'Next Object In Stream Not Array']! !

!JavaArrayType methodsFor: 'public' stamp: 'btb 3/23/2003 15:38'!
readTypeInfo: typeStream

	self type: (self class readFromStream: typeStream)! !

!JavaArrayType methodsFor: 'public' stamp: 'btb 2/28/2004 16:18'!
writeTypeInfo: aStream 
	super writeTypeInfo: aStream.
	self type writeTypeInfo: aStream! !

!JavaArrayType methodsFor: 'private' stamp: 'btb 4/28/2002 18:23'!
type: aJavaType

	type:=aJavaType! !

!JavaType methodsFor: 'private' stamp: 'btb 5/6/2002 12:05'!
readTypeInfo: typeStream 
	"Read my type information from typeStream.
	default is do nothing  
	btb 5/6/2002 12:00"
	^ self! !

!JavaType methodsFor: 'private' stamp: 'btb 2/27/2004 19:20'!
= anotherJavaType

	^self asTypeInfoString= anotherJavaType asTypeInfoString! !

JavaType subclass: #JavaMethodType
	instanceVariableNames: 'arguments returnType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Core-Type'!

!JavaMethodType commentStamp: 'btb 9/18/2003 19:48' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaMethodType methodsFor: 'accessing' stamp: 'btb 3/23/2003 15:39'!
arguments
	^arguments! !

!JavaMethodType methodsFor: 'as yet unclassified' stamp: 'btb 3/23/2003 17:43'!
printJavaSourceOn: aStream

	self returnType printJavaSourceOn: aStream.
	aStream nextPutAll: ' ('.
	self arguments do: [:each | each printJavaSourceOn: aStream] separatedBy: [aStream nextPutAll: ', '].
	aStream nextPutAll: ')'.! !

!JavaMethodType methodsFor: 'as yet unclassified' stamp: 'btb 4/29/2003 21:30'!
asJavaSource: aName

	^ String streamContents: [:s | self printJavaSourceOn: s name: aName]! !

!JavaMethodType methodsFor: 'accessing' stamp: 'btb 3/23/2003 15:39'!
arguments: anObject
	arguments := anObject! !

!JavaMethodType methodsFor: 'accessing' stamp: 'btb 3/23/2003 15:39'!
returnType: anObject
	returnType := anObject! !

!JavaMethodType methodsFor: 'as yet unclassified' stamp: 'btb 2/25/2004 21:01'!
readTypeInfo: typeStream 

	[typeStream peek asCharacter = $)]
		whileFalse: [self arguments add: (self class readFromStream: typeStream)].
	typeStream next.
	self returnType: (self class readFromStream: typeStream).
	^self! !

!JavaMethodType methodsFor: 'accessing' stamp: 'btb 3/23/2003 15:39'!
returnType
	^returnType! !

!JavaMethodType methodsFor: 'as yet unclassified' stamp: 'btb 2/28/2004 21:30'!
writeTypeInfo: aStream 
	super writeTypeInfo: aStream.
	self arguments do: [:each |
		each writeTypeInfo: aStream].
	aStream nextPut: $).
	self returnType writeTypeInfo: aStream! !

!JavaMethodType methodsFor: 'as yet unclassified' stamp: 'btb 3/23/2003 15:30'!
initialize

	super initialize.
	self arguments: OrderedCollection new.! !

!JavaMethodType methodsFor: 'as yet unclassified' stamp: 'btb 4/29/2003 21:31'!
printJavaSourceOn: aStream name: aName

	self returnType printJavaSourceOn: aStream.
	aName ifNotNil: [
		aStream 
			nextPut: (Character space);
			nextPutAll: aName].
	aName ifNil: [aStream nextPut: (Character space)].
	aStream nextPut: $(.
	self arguments do: [:each | each printJavaSourceOn: aStream] separatedBy: [aStream nextPutAll: ', '].
	aStream nextPutAll: ')'.! !

!JavaMethodType class methodsFor: 'as yet unclassified' stamp: 'btb 3/23/2003 15:21'!
code

	^$(! !

!JavaType class methodsFor: 'private' stamp: 'btb 3/23/2003 17:25'!
classMapping
	"Define the mapping for which type corresponds to what character from 
	the stream 
	btb 5/6/2002 12:22"

	^ClassMapping ifNil:[ClassMapping := IdentityDictionary new]! !

!JavaType methodsFor: 'public' stamp: 'btb 5/6/2002 11:59'!
printJavaSourceOn: aStream 
	"Print myself out as java source on aStream. By default, put !!UNKNOWN!!
	btb 5/6/2002 11:59"
	aStream nextPutAll: '!!Unknown!!'! !

!JavaType methodsFor: 'public' stamp: 'btb 5/6/2002 11:58'!
asJavaSource
	"Return the type as java source code. Basically, it should print out as if  
	was part of an instance variable definition 
	btb 5/6/2002 11:56"
	^ String
		streamContents: [:s | self printJavaSourceOn: s]! !

!JavaType class methodsFor: 'private' stamp: 'btb 2/25/2004 20:34'!
instance

	"default is to create a new instance"
	^self basicNew initialize! !

!JavaType class methodsFor: 'public' stamp: 'btb 5/1/2002 23:02'!
initialize

	"JavaType initialize"

	ClassMapping:=nil.! !

!JavaType class methodsFor: 'private' stamp: 'btb 8/16/2004 16:14'!
classFor: typeChar 
	^ self classMapping
		at: typeChar asUppercase
		ifAbsentPut: [self obtainClassFor: typeChar]! !

!JavaType class methodsFor: 'public' stamp: 'btb 3/23/2003 15:15'!
code

	^self subclassResponsibility! !

JavaType subclass: #JavaSingletonType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Core-Type'!

JavaSingletonType class
	instanceVariableNames: 'Singleton'!

JavaSingletonType subclass: #JavaBooleanType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Core-Type'!

!JavaBooleanType commentStamp: '<historical>' prior: 0!
I represent the boolean type

Copyright (c) 2002 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 5/6/2002 12:19!

!JavaBooleanType methodsFor: 'public' stamp: 'btb 6/15/2003 20:34'!
readContentsFrom: aJavaReadStream

	^aJavaReadStream nextBoolean! !

!JavaBooleanType methodsFor: 'public' stamp: 'btb 4/28/2002 18:51'!
printJavaSourceOn: aStream

	aStream nextPutAll: 'boolean'! !

!JavaBooleanType methodsFor: 'public' stamp: 'btb 2/16/2004 20:43'!
writeContents: anObject to: aJavaSerWriteStream 

	aJavaSerWriteStream nextPutBoolean: anObject! !

!JavaBooleanType class methodsFor: 'as yet unclassified' stamp: 'btb 3/23/2003 15:18'!
code

	^$Z! !

JavaSingletonType subclass: #JavaIntType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Core-Type'!

!JavaIntType commentStamp: '<historical>' prior: 0!
I represent the int type

Copyright (c) 2002 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 5/6/2002 12:20!

!JavaIntType class methodsFor: 'as yet unclassified' stamp: 'btb 3/23/2003 15:19'!
code

	^$I! !

!JavaIntType methodsFor: 'public' stamp: 'btb 4/28/2002 18:53'!
printJavaSourceOn: aStream

	aStream nextPutAll: 'int'! !

!JavaIntType methodsFor: 'public' stamp: 'btb 6/15/2003 20:30'!
readContentsFrom: aJavaReadStream

	^aJavaReadStream nextInt! !

!JavaIntType methodsFor: 'public' stamp: 'btb 2/16/2004 20:41'!
writeContents: anObject to: aJavaSerWriteStream 

	aJavaSerWriteStream nextPutInt: anObject! !

JavaSingletonType subclass: #JavaVoidType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Core-Type'!

!JavaVoidType commentStamp: 'btb 9/18/2003 19:48' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaVoidType class methodsFor: 'as yet unclassified' stamp: 'btb 3/23/2003 17:45'!
code

	^$V! !

!JavaVoidType methodsFor: 'as yet unclassified' stamp: 'btb 3/23/2003 17:46'!
printJavaSourceOn: aStream 
	
	aStream nextPutAll: 'void'! !

JavaSingletonType subclass: #JavaLongType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Core-Type'!

!JavaLongType commentStamp: '<historical>' prior: 0!
I represent the long data type

Copyright (c) 2002 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 5/6/2002 12:20!

!JavaLongType class methodsFor: 'as yet unclassified' stamp: 'btb 3/23/2003 15:20'!
code

	^$J! !

!JavaLongType methodsFor: 'public' stamp: 'btb 4/28/2002 18:52'!
printJavaSourceOn: aStream

	aStream nextPutAll: 'long'! !

!JavaLongType methodsFor: 'public' stamp: 'btb 2/16/2004 20:39'!
writeContents: anObject to: aJavaSerWriteStream 

	aJavaSerWriteStream nextPutLong: anObject! !

!JavaLongType methodsFor: 'public' stamp: 'btb 6/15/2003 20:34'!
readContentsFrom: aJavaReadStream

	^aJavaReadStream nextLong! !

JavaSingletonType subclass: #JavaFloatType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Core-Type'!

!JavaFloatType commentStamp: '<historical>' prior: 0!
I represent the float type

Copyright (c) 2002 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 5/6/2002 12:20!

!JavaFloatType methodsFor: 'public' stamp: 'btb 6/15/2003 20:35'!
readContentsFrom: aJavaReadStream

	^aJavaReadStream nextFloat! !

!JavaFloatType methodsFor: 'public' stamp: 'btb 2/16/2004 20:41'!
writeContents: anObject to: aJavaSerWriteStream 

	aJavaSerWriteStream nextPutFloat: anObject! !

!JavaFloatType methodsFor: 'public' stamp: 'btb 4/28/2002 18:53'!
printJavaSourceOn: aStream

	aStream nextPutAll: 'float'! !

!JavaFloatType class methodsFor: 'as yet unclassified' stamp: 'btb 3/23/2003 15:19'!
code

	^$F! !

JavaSingletonType subclass: #JavaByteType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Core-Type'!

!JavaByteType commentStamp: '<historical>' prior: 0!
I represent the byte type

Copyright (c) 2002 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 5/6/2002 12:19!

!JavaByteType methodsFor: 'public' stamp: 'btb 4/28/2002 18:54'!
printJavaSourceOn: aStream

	aStream nextPutAll: 'byte'! !

!JavaByteType methodsFor: 'public' stamp: 'btb 8/24/2004 20:23'!
readContentsFrom: aJavaReadStream

	^aJavaReadStream nextUnsignedByte! !

!JavaByteType class methodsFor: 'as yet unclassified' stamp: 'btb 3/23/2003 15:19'!
code

	^$B! !

!JavaByteType methodsFor: 'public' stamp: 'btb 2/16/2004 20:42'!
writeContents: anObject to: aJavaSerWriteStream 

	aJavaSerWriteStream nextPutByte: anObject! !

JavaSingletonType subclass: #JavaDoubleType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Core-Type'!

!JavaDoubleType commentStamp: '<historical>' prior: 0!
I represent the double data type

Copyright (c) 2002 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 5/6/2002 12:20!

!JavaDoubleType methodsFor: 'public' stamp: 'btb 6/15/2003 20:49'!
readContentsFrom: aJavaReadStream

	^aJavaReadStream nextDouble! !

!JavaDoubleType methodsFor: 'public' stamp: 'btb 4/28/2002 18:53'!
printJavaSourceOn: aStream

	aStream nextPutAll: 'double'! !

!JavaDoubleType class methodsFor: 'as yet unclassified' stamp: 'btb 3/23/2003 15:19'!
code

	^$D! !

!JavaDoubleType methodsFor: 'public' stamp: 'btb 2/16/2004 20:41'!
writeContents: anObject to: aJavaSerWriteStream 

	aJavaSerWriteStream nextPutDouble: anObject! !

JavaSingletonType subclass: #JavaShortType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Core-Type'!

!JavaShortType commentStamp: '<historical>' prior: 0!
I represent  the java short type


Copyright (c) 2002 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
btb 5/6/2002 19:45!

!JavaShortType class methodsFor: 'as yet unclassified' stamp: 'btb 3/23/2003 15:21'!
code

	^$S! !

!JavaShortType methodsFor: 'public' stamp: 'btb 4/28/2002 18:52'!
printJavaSourceOn: aStream

	aStream nextPutAll: 'short'! !

!JavaShortType methodsFor: 'public' stamp: 'btb 6/15/2003 20:30'!
readContentsFrom: aJavaReadStream

	^aJavaReadStream nextShort! !

!JavaShortType methodsFor: 'public' stamp: 'btb 2/16/2004 20:38'!
writeContents: anObject to: aJavaSerWriteStream 

	aJavaSerWriteStream nextPutShort: anObject! !

JavaSingletonType subclass: #JavaCharType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Core-Type'!

!JavaCharType commentStamp: '<historical>' prior: 0!
I represent the char data type

Copyright (c) 2002 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 5/6/2002 12:19!

!JavaCharType methodsFor: 'public' stamp: 'btb 6/15/2003 20:32'!
readContentsFrom: aJavaReadStream

	^aJavaReadStream nextChar! !

!JavaCharType methodsFor: 'public' stamp: 'btb 2/16/2004 20:42'!
writeContents: anObject to: aJavaSerWriteStream 

	aJavaSerWriteStream nextPutChar: anObject! !

!JavaCharType class methodsFor: 'as yet unclassified' stamp: 'btb 3/23/2003 15:19'!
code

	^$C! !

!JavaCharType methodsFor: 'public' stamp: 'btb 4/28/2002 18:53'!
printJavaSourceOn: aStream

	aStream nextPutAll: 'char'! !

!JavaSingletonType class methodsFor: 'as yet unclassified' stamp: 'btb 2/25/2004 20:42'!
instance

	^Singleton ifNil: [Singleton:=super instance]! !

!JavaSingletonType class methodsFor: 'as yet unclassified' stamp: 'btb 2/25/2004 21:04'!
code

	^nil! !

JavaType subclass: #JavaObjectType
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Core-Type'!

!JavaObjectType commentStamp: '<historical>' prior: 0!
I represent all java object types

Copyright (c) 2002 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 5/6/2002 12:21!

!JavaObjectType methodsFor: 'public' stamp: 'btb 4/28/2002 20:33'!
printJavaSourceOn: aStream

	self name do: [:each |
		aStream nextPut: ((each == $/) ifTrue: [$.] ifFalse: [each])]
			! !

!JavaObjectType methodsFor: 'public' stamp: 'btb 2/28/2004 21:30'!
writeTypeInfo: aStream 

	super writeTypeInfo: aStream.
	aStream nextPutAll: self name; nextPut: $;! !

!JavaObjectType methodsFor: 'public' stamp: 'btb 2/25/2004 21:01'!
readTypeInfo: typeStream

	self name: (typeStream upTo: $;).
	^self! !

!JavaObjectType methodsFor: 'public' stamp: 'btb 2/28/2004 12:52'!
readContentsFrom: aJavaReadStream 
	"Read an object of my type from the stream. 
	In the future, I would like to do more type checking, but for now, I just 
	make sure it's an object by peeking in the read stream 
	btb 5/6/2002 12:10"

	^aJavaReadStream peekIsObject 
		ifTrue: [aJavaReadStream readContent]
		ifFalse: [ nil "self error: 'Next Object In Stream Not JavaObject'"]! !

!JavaObjectType methodsFor: 'private' stamp: 'btb 5/6/2002 12:04'!
name: aString 
	"Set my Java Object class name 
	It should be in the form: java/lang/Object instead of java.lang.Object
	btb 5/6/2002 12:03"
	name _ aString! !

!JavaObjectType methodsFor: 'private' stamp: 'btb 5/6/2002 12:03'!
name
	"Return my java object type name
	btb 5/6/2002 12:03"
	^ name! !

!JavaObjectType methodsFor: 'public' stamp: 'btb 2/16/2004 20:39'!
writeContents: anObject to: aJavaSerWriteStream 
	
	aJavaSerWriteStream writeContent: anObject! !

!JavaObjectType class methodsFor: 'as yet unclassified' stamp: 'btb 3/23/2003 15:20'!
code

	^$L! !

!JavaType methodsFor: 'public' stamp: 'btb 2/28/2004 18:32'!
asTypeInfoString
	^ typeInfoCache ifNil: [typeInfoCache := String
		streamContents: [:s | self writeTypeInfo: s]]! !

!JavaType methodsFor: 'private' stamp: 'btb 2/28/2004 16:12'!
writeTypeInfo: aStream 
	 aStream nextPut: self code! !

!JavaType class methodsFor: 'public' stamp: 'btb 2/25/2004 21:45'!
instanceFromString: aString
	| rs |
	rs := ReadStream on: aString.
	^self readFromStream: rs! !

!JavaType class methodsFor: 'public' stamp: 'btb 2/25/2004 20:30'!
new

	^self error: 'Should not call this directly. Use JavaType>>instance instead'! !

!JavaType class methodsFor: 'private' stamp: 'btb 3/23/2003 17:58'!
obtainClassFor: typeChar

	^JavaType allSubclasses detect: [:each | each code = typeChar] ifNone: [JavaTypeError signal: 'Unknown Type Character: ', typeChar asString].! !

!JavaType class methodsFor: 'private' stamp: 'btb 2/25/2004 21:00'!
readTypeInfo: aStream

	^self instance readTypeInfo: aStream! !

Object subclass: #JavaSerAbstractObject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Serialization-Core'!

!JavaSerAbstractObject commentStamp: '<historical>' prior: 0!
I am the root super class for all java objects. This class used to do a lot more, but it's been refactored. It might be removed soon. We'll see...

Copyright (c) 2002 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 5/6/2002 12:17!

!JavaSerAbstractObject methodsFor: 'inspect' stamp: 'btb 10/27/2003 20:52'!
inspectorVariableNames

	^Array with: 'this'! !

JavaSerAbstractObject subclass: #JavaSerClass
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Serialization-Core'!

!JavaSerClass commentStamp: '<historical>' prior: 0!
I represent a java class. I simply am an instance of the object java.lang.Class. I simply hold unto the class description and that's all.

Copyright (c) 2002 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 5/6/2002 12:17!

!JavaSerClass methodsFor: 'accessor-setters' stamp: 'btb 4/18/2002 20:44'!
description

	^description! !

!JavaSerClass methodsFor: 'accessor-setters' stamp: 'btb 4/18/2002 20:44'!
description: aJavaClassDescription

	description:=aJavaClassDescription! !

!JavaSerClass methodsFor: 'printing' stamp: 'btb 5/16/2002 22:12'!
printOn: aStream

	aStream nextPutAll: 'Java: ';
			nextPutAll: (self description name) asString;
			nextPutAll: ' class'! !

!JavaSerClass methodsFor: 'as yet unclassified' stamp: 'btb 2/28/2004 21:38'!
writeToJavaStream: aJavaWriteStream

	aJavaWriteStream writeClass: self! !

!JavaSerAbstractObject methodsFor: 'initialization' stamp: 'btb 4/28/2002 22:10'!
printOn: aStream

	aStream nextPutAll: 'Java: !!Unknown!!'! !

!JavaSerAbstractObject methodsFor: 'inspect' stamp: 'btb 10/27/2003 20:46'!
inspect
	JavaSerObjectInspector openOn: self withEvalPane: true! !

!JavaSerAbstractObject methodsFor: 'inspect' stamp: 'btb 10/27/2003 21:00'!
inspectorSelection: index

	index = 1 ifTrue: [^self].
	^nil! !

JavaSerAbstractObject subclass: #JavaSerObject
	instanceVariableNames: 'classDescription instanceVariables annotation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Serialization-Core'!

!JavaSerObject commentStamp: '<historical>' prior: 0!
I represent instances of first class java objects.

Copyright (c) 2002 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 5/6/2002 12:17!

!JavaSerObject methodsFor: 'accessor-setters' stamp: 'btb 4/26/2002 18:27'!
annotation: anAnnotation

	annotation:=anAnnotation! !

!JavaSerObject methodsFor: 'inspector' stamp: 'btb 10/27/2003 21:28'!
inspectorSelection: index

	| result |
	result := super inspectorSelection: index.
	result 
		ifNil:[
			index = 2 ifTrue: [^self classDescription].
			index = 3 ifTrue: [^self annotation].
			(index >= 4) ifTrue: [^self atField: (self fieldNames at: (index - 3)) ifAbsent: [nil]]]
		ifNotNil: [^result]
	! !

!JavaSerObject methodsFor: 'accessor-setters' stamp: 'btb 2/15/2004 18:53'!
annotationAt: aName

	^self annotation at: aName ifAbsent: [#()]! !

!JavaSerObject methodsFor: 'accessor-setters' stamp: 'btb 4/26/2002 18:27'!
annotation

	^annotation! !

!JavaSerObject methodsFor: 'inspector' stamp: 'btb 10/27/2003 21:29'!
inspectorReplaceSelection: index value: aNewObject

	super inspectorReplaceSelection: index value: aNewObject.
	index = 2 ifTrue: [^self classDescription: aNewObject].
	index = 3 ifFalse: [^self annotation: aNewObject].
	index >= 4 ifTrue: [^self atField: (self fieldNames at: (index - 3)) put: aNewObject].
	^aNewObject! !

!JavaSerObject methodsFor: 'accessor-setters' stamp: 'btb 4/22/2002 20:51'!
instanceVariables

	^instanceVariables! !

!JavaSerObject methodsFor: 'accessor-setters' stamp: 'btb 2/15/2004 18:31'!
addAnnotation: someAnnotation forName: aNameString

	someAnnotation ifNotNilDo: [:a | 
		self annotation 
			ifNil: [self annotation: Dictionary new].
		self annotation at: aNameString put: someAnnotation]! !

!JavaSerObject methodsFor: 'accessor-setters' stamp: 'btb 4/22/2002 20:50'!
classDescription

	^classDescription! !

!JavaSerObject methodsFor: 'accessor-setters' stamp: 'btb 4/22/2002 20:50'!
classDescription: aClassDescription

	classDescription:=aClassDescription! !

!JavaSerObject methodsFor: 'as yet unclassified' stamp: 'btb 4/30/2002 22:06'!
fieldNames

	^self classDescription fieldNames! !

!JavaSerObject methodsFor: 'accessor-setters' stamp: 'btb 4/26/2002 17:44'!
instanceVariables: aDictionary

	instanceVariables:=aDictionary! !

!JavaSerObject methodsFor: 'accessor-setters' stamp: 'btb 10/27/2003 20:11'!
atField: aSymbol

	^self instanceVariables at: aSymbol! !

!JavaSerObject methodsFor: 'as yet unclassified' stamp: 'btb 5/16/2002 22:13'!
printOn: aStream

	aStream nextPutAll: 'Java: ';
			nextPutAll: self classDescription name asString! !

!JavaSerObject methodsFor: 'as yet unclassified' stamp: 'btb 10/27/2003 20:11'!
initialize
	super initialize.
	self instanceVariables: IdentityDictionary new! !

!JavaSerObject methodsFor: 'accessor-setters' stamp: 'btb 10/27/2003 20:12'!
atField: aSymbol put: aValue

	^self instanceVariables at: aSymbol put: aValue! !

!JavaSerObject methodsFor: 'accessor-setters' stamp: 'btb 10/27/2003 20:11'!
atField: aSymbol ifAbsent: aBlock

	^self instanceVariables at: aSymbol ifAbsent: aBlock! !

!JavaSerObject methodsFor: 'writing' stamp: 'btb 2/27/2004 21:08'!
writeToJavaStream: aJavaSerWriteStream 
	
	aJavaSerWriteStream writeObject: self
	
	! !

!JavaSerObject methodsFor: 'inspector' stamp: 'btb 10/27/2003 21:20'!
inspectorVariableNames

	| result |
	result := OrderedCollection new.
	result 
		addAll: (super inspectorVariableNames);
		add: 'class';
		add: 'extra';
		addAll: self fieldNames.
	^result! !

!JavaSerAbstractObject class methodsFor: 'creation' stamp: 'btb 4/22/2002 20:51'!
new

	^super new initialize! !

JavaSerAbstractObject variableSubclass: #JavaSerArray
	instanceVariableNames: 'type internal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Serialization-Core'!

!JavaSerArray commentStamp: '<historical>' prior: 0!
I represent an instance of a Java Array (object []). I'm just a smalltalk array with type information tacked onto me.

Copyright (c) 2002 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 5/6/2002 12:17!

!JavaSerArray methodsFor: 'public' stamp: 'btb 10/28/2003 20:18'!
size

	^internal size! !

!JavaSerArray methodsFor: 'public' stamp: 'btb 10/28/2003 20:17'!
select: aBlock

	^internal select: aBlock! !

!JavaSerArray methodsFor: 'public' stamp: 'btb 2/17/2004 19:26'!
writeToJavaStream: aJavaWriteStream

	aJavaWriteStream writeArray: self! !

!JavaSerArray methodsFor: 'initialization' stamp: 'btb 10/27/2003 20:35'!
initializeWithType: aJavaType size: initialSize

	internal := Array new: initialSize.
	self type: aJavaType.! !

!JavaSerArray methodsFor: 'public' stamp: 'btb 4/28/2002 22:20'!
printOn: aStream

	aStream nextPutAll: 'Java: ';
			nextPutAll: self type asJavaSource! !

!JavaSerArray methodsFor: 'inspect' stamp: 'btb 10/27/2003 21:27'!
inspectorSelection: index

	| result |
	result := super inspectorSelection: index.
	result 
		ifNil: [	(index == 2) ifTrue: [^self type].
				(index >= 3) ifTrue: [^self at: (index - 2)]]
		ifNotNil: [^result]
	! !

!JavaSerArray methodsFor: 'public' stamp: 'btb 10/27/2003 20:36'!
at: anInteger put: aJavaSerAbstractObject

	^internal at: anInteger put: aJavaSerAbstractObject! !

!JavaSerArray methodsFor: 'public' stamp: 'btb 4/28/2002 22:17'!
type

	^type! !

!JavaSerArray methodsFor: 'public' stamp: 'btb 4/28/2002 22:17'!
type: aJavaType

	type:=aJavaType! !

!JavaSerArray methodsFor: 'public' stamp: 'btb 10/28/2003 20:17'!
collect: aBlock

	^internal collect: aBlock! !

!JavaSerArray methodsFor: 'inspect' stamp: 'btb 10/27/2003 21:24'!
inspectorVariableNames

	| index result |
	result:=OrderedCollection new.
	result addAll: (super inspectorVariableNames).
	result add: 'class'.
	index := 0.
	internal do: [:each | 
		index := index + 1. 
		result add: index printString].
	^result! !

!JavaSerArray class methodsFor: 'as yet unclassified' stamp: 'btb 10/27/2003 20:35'!
type: aJavaType size: initialSize

	^self basicNew 
		initializeWithType: aJavaType size: initialSize! !

!JavaSerArray methodsFor: 'public' stamp: 'btb 10/28/2003 20:17'!
do: aBlock

	internal do: aBlock! !

!JavaSerArray methodsFor: 'inspect' stamp: 'btb 10/27/2003 21:29'!
inspectorReplaceSelection: index value: aNewObject

	(index >= 3)
		ifTrue: [self at: (index - 2) put: aNewObject].
	^aNewObject
	! !

!JavaSerArray methodsFor: 'public' stamp: 'btb 10/27/2003 20:36'!
at: anInteger

	^internal at: anInteger! !

JavaSerAbstractObject subclass: #JavaSerAbstractClassDescription
	instanceVariableNames: 'superClassDescription classAnnotation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Serialization-Core'!

!JavaSerAbstractClassDescription commentStamp: '<historical>' prior: 0!
I am the abstract super class of all java class descriptions. Basically, I hold on to the super class description and any class annotations

Copyright (c) 2002 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 5/6/2002 12:18!

JavaSerAbstractClassDescription subclass: #JavaSerClassDescription
	instanceVariableNames: 'flags fields name serialVersionUID'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Serialization-Core'!

!JavaSerClassDescription commentStamp: '<historical>' prior: 0!
I am the heavy worker of the java serialization protocol. I know how to read in classes of my description and will know how to write them in the future.

Copyright (c) 2002 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 5/6/2002 12:17!

!JavaSerClassDescription methodsFor: 'convience' stamp: 'btb 5/1/2002 12:44'!
allFields

	| answer |
	answer:=OrderedCollection new.
	answer addAll: self fields.
	self superClassDescription ifNotNilDo: [:sdc | answer addAll: sdc allFields].
	^answer! !

!JavaSerClassDescription methodsFor: 'accessors' stamp: 'btb 2/27/2004 20:07'!
type
	| nameString |
	nameString := self name asString.
	^self isArray
		ifTrue: [JavaType instanceFromString: nameString]
		ifFalse: [JavaType instanceFromString: JavaObjectType code asString , nameString]! !

!JavaSerClassDescription methodsFor: 'accessors' stamp: 'btb 4/17/2002 21:34'!
name

	^name! !

!JavaSerClassDescription methodsFor: 'accessors' stamp: 'btb 4/17/2002 21:35'!
serialVersionUID: aNumber

	serialVersionUID:=aNumber! !

!JavaSerClassDescription methodsFor: 'writing' stamp: 'btb 2/17/2004 18:58'!
writeToJavaStream: aJavaSerWriteStream

	aJavaSerWriteStream writeClassDescription: self! !

!JavaSerClassDescription methodsFor: 'reading' stamp: 'btb 10/27/2003 19:50'!
readObjectContentsFrom: aJavaReadStream 
	"classDesc newHandle classdata[]  "

	| answer |
	answer := JavaSerObject new.
	answer classDescription: self.
	self readClassDataFor: answer from: aJavaReadStream.
	^answer! !

!JavaSerClassDescription methodsFor: 'convience' stamp: 'btb 2/27/2004 20:06'!
addToCache: aJavaClassCache

	"self isArray ifFalse: ["
		aJavaClassCache addClassDescription: self
	"]" ! !

!JavaSerClassDescription methodsFor: 'convience' stamp: 'btb 5/1/2002 12:43'!
fieldNames

	^self allFields collect: [:each | each name]! !

!JavaSerClassDescription methodsFor: 'reading' stamp: 'btb 8/25/2004 20:00'!
readArrayContentsFrom: aJavaReadStream 
	| size answer type elementType |
	size := aJavaReadStream nextUnsignedInt.
	type := self arrayType.
	answer := JavaSerArray type: type size: size.
	elementType:=type type.
	1 to: size
		do: [:index | answer at: index put: (elementType readContentsFrom: aJavaReadStream)].
	^answer! !

!JavaSerClassDescription methodsFor: 'writing' stamp: 'btb 2/15/2004 19:08'!
writeContents: aJavaSerObject to: aJavaSerWriteStream
	| value |
	self fields do: [:eachField |
		value := aJavaSerObject atField: eachField name.
		eachField writeContents: value to:  aJavaSerWriteStream].! !

!JavaSerClassDescription methodsFor: 'convience' stamp: 'btb 4/26/2002 17:02'!
asJavaSource

	^String streamContents: [:s | self printJavaSourceOn: s]! !

!JavaSerClassDescription methodsFor: 'accessors' stamp: 'btb 4/17/2002 21:28'!
fields

	^fields! !

!JavaSerClassDescription methodsFor: 'accessors' stamp: 'btb 4/17/2002 21:35'!
serialVersionUID

	^serialVersionUID! !

!JavaSerClassDescription methodsFor: 'writing' stamp: 'btb 8/25/2004 20:03'!
writeArrayContents: aJavaSerArray to: aJavaWriteStream

	| elementType |
	aJavaWriteStream nextPutUnsignedInt: aJavaSerArray size.
	elementType :=self arrayType type.
	aJavaSerArray do: [:each | elementType writeContents: each to: aJavaWriteStream]! !

!JavaSerClassDescription methodsFor: 'accessors' stamp: 'btb 4/17/2002 21:27'!
flags: aJavaClasDescriptionFlags

	flags:=aJavaClasDescriptionFlags! !

!JavaSerClassDescription methodsFor: 'accessors' stamp: 'btb 4/22/2002 19:56'!
fields: someFields

	fields:=someFields! !

!JavaSerClassDescription methodsFor: 'convience' stamp: 'btb 4/26/2002 17:02'!
printOn: aStream

	self printJavaSourceOn: aStream! !

!JavaSerClassDescription methodsFor: 'convience' stamp: 'btb 2/28/2004 21:33'!
isArray

	^self name first asCharacter = JavaArrayType code! !

!JavaSerClassDescription methodsFor: 'reading' stamp: 'btb 2/28/2004 12:42'!
readClassDataFor: aJavaObject from: aJavaReadStream 
	self flags isSerializable
		ifTrue: [self superClassDescription
				ifNotNilDo: [:sdc | sdc readClassDataFor: aJavaObject from: aJavaReadStream].
			self readContents: aJavaObject from: aJavaReadStream.
			self flags isWriteMethod
				ifTrue: [aJavaObject addAnnotation: aJavaReadStream readObjectAnnotation forName: self name]]
		ifFalse: [self flags isBlockData
				ifTrue: [aJavaObject addAnnotation: aJavaReadStream readObjectAnnotation forName: self name]
				ifFalse: [aJavaObject
						addAnnotation: (Array with: aJavaReadStream readContent)
						forName: self name]]! !

!JavaSerClassDescription methodsFor: 'accessors' stamp: 'btb 2/27/2004 19:54'!
arrayType
	^JavaType instanceFromString: self name asString! !

!JavaSerClassDescription methodsFor: 'writing' stamp: 'btb 2/28/2004 11:50'!
writeObjectContents: aJavaSerObject to: aJavaSerWriteStream

	self flags isSerializable
		ifTrue: [self superClassDescription 
					ifNotNilDo: [:sdc | sdc writeObjectContents: aJavaSerObject to: aJavaSerWriteStream].
				self writeContents: aJavaSerObject to: aJavaSerWriteStream.
				self flags isWriteMethod
					ifTrue: [aJavaSerWriteStream writeObjectAnnotation: (aJavaSerObject annotationAt: self name)]]
		ifFalse: [self flags isBlockData
				ifTrue: [aJavaSerWriteStream writeObjectAnnotation:  (aJavaSerObject annotationAt: self name)]
				ifFalse: [aJavaSerWriteStream writeContent: (aJavaSerObject annotationAt: self name) first]]! !

!JavaSerClassDescription methodsFor: 'convience' stamp: 'btb 4/26/2002 16:31'!
javaSuperClassDescriptionName

	^self superClassDescription
		ifNil: ['Object']
		ifNotNil: [self superClassDescription name]! !

!JavaSerClassDescription methodsFor: 'accessors' stamp: 'btb 3/6/2004 19:03'!
name: aString

	name:=aString asSymbol! !

!JavaSerClassDescription methodsFor: 'convience' stamp: 'btb 5/16/2002 22:13'!
printJavaSourceOn: aStream

	aStream 
		nextPutAll: 'class ';
		nextPutAll: (self name) asString;
		nextPutAll: ' extends ';
		nextPutAll: (self javaSuperClassDescriptionName) asString;
		nextPutAll: ' {';
		cr.
	self fields do: [:each |
		aStream tab.
		each printJavaSourceOn: aStream.
		aStream cr].
	aStream nextPutAll: '}'.! !

!JavaSerClassDescription methodsFor: 'reading' stamp: 'btb 2/28/2004 12:42'!
readContents: aJavaObject from: aJavaReadStream

	| value |
	self fields do: [:eachField |
		value:=eachField readContentsFrom: aJavaReadStream.
		aJavaObject atField: eachField name put: value].! !

!JavaSerClassDescription methodsFor: 'accessors' stamp: 'btb 4/17/2002 21:27'!
flags

	^flags! !

!JavaSerAbstractClassDescription methodsFor: 'accessors-setters' stamp: 'btb 4/17/2002 21:49'!
superClassDescription: aJavaClassDescription

	superClassDescription:=aJavaClassDescription! !

JavaSerAbstractClassDescription subclass: #JavaSerProxyClassDescription
	instanceVariableNames: 'interfaceNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Serialization-Core'!

!JavaSerProxyClassDescription commentStamp: '<historical>' prior: 0!
Proxy objects were introduced in Java 1.3 and this object represents a java proxy object. A proxy object only needs to know its interface names. This needs some work...

Copyright (c) 2002 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 5/6/2002 12:16!

!JavaSerProxyClassDescription methodsFor: 'accessors-setters' stamp: 'btb 4/17/2002 21:57'!
interfaceNames: aCollectionOfStrings

	interfaceNames:=aCollectionOfStrings! !

!JavaSerProxyClassDescription methodsFor: 'as yet unclassified' stamp: 'btb 2/27/2004 21:09'!
writeToJavaStream: aJavaSerWriteStream 
	
	aJavaSerWriteStream writeProxyClassDescription: self! !

!JavaSerProxyClassDescription methodsFor: 'accessors-setters' stamp: 'btb 4/17/2002 21:57'!
interfaceNames

	^interfaceNames! !

!JavaSerAbstractClassDescription methodsFor: 'accessors-setters' stamp: 'btb 4/17/2002 21:46'!
classAnnotation: aCollection

	classAnnotation:=aCollection! !

!JavaSerAbstractClassDescription methodsFor: 'accessors-setters' stamp: 'btb 4/17/2002 21:49'!
superClassDescription

	^superClassDescription! !

!JavaSerAbstractClassDescription methodsFor: 'accessors-setters' stamp: 'btb 4/17/2002 21:47'!
classAnnotation

	^classAnnotation! !

!JavaSerAbstractObject methodsFor: 'inspect' stamp: 'btb 10/27/2003 21:00'!
inspectorReplaceSelection: index value: aNewObject

	"do nothing"! !

Object subclass: #JavaSerUnknownReference
	instanceVariableNames: 'handle'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Serialization-Core'!

!JavaSerUnknownReference commentStamp: '<historical>' prior: 0!
I represent an unknown java reference in the serialization stream. I am normally resolved by the end of the stream. If you get instances of me after reading a java object from the stream, then there is an error somewhere!!

Copyright (c) 2002 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 5/6/2002 12:15!

!JavaSerUnknownReference methodsFor: 'as yet unclassified' stamp: 'btb 4/16/2002 21:29'!
handle: aHandle

	handle:=aHandle! !

!JavaSerUnknownReference class methodsFor: 'as yet unclassified' stamp: 'btb 4/16/2002 21:35'!
newWithHandle: aHandle

	^self new 
		handle: aHandle;
		yourself! !

!JavaSerUnknownReference methodsFor: 'as yet unclassified' stamp: 'btb 4/16/2002 21:29'!
handle

	^handle! !

Object subclass: #JavaSerConstants
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Serialization-Core'!

!JavaSerConstants commentStamp: 'btb 9/18/2003 19:44' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaSerConstants class methodsFor: 'terminal constants' stamp: 'btb 5/24/2002 12:22'!
tcLongString

	^16r7C! !

!JavaSerConstants class methodsFor: 'terminal constants' stamp: 'btb 5/24/2002 12:19'!
tcNull

	^16r70! !

!JavaSerConstants class methodsFor: 'constants' stamp: 'btb 5/7/2002 12:07'!
baseWireHandle

	^16r7E0000! !

!JavaSerConstants class methodsFor: 'terminal constants' stamp: 'btb 5/24/2002 12:21'!
tcReset

	^16r79! !

!JavaSerConstants class methodsFor: 'class description' stamp: 'btb 5/24/2002 12:17'!
scBlockData

	^16r08! !

!JavaSerConstants class methodsFor: 'terminal constants' stamp: 'btb 5/24/2002 12:22'!
tcBlockDataLong

	^16r7A! !

!JavaSerConstants class methodsFor: 'terminal constants' stamp: 'btb 5/24/2002 12:21'!
tcClass

	^16r76! !

!JavaSerConstants class methodsFor: 'class description' stamp: 'btb 5/24/2002 12:17'!
scSerializable

	^16r02! !

!JavaSerConstants class methodsFor: 'terminal constants' stamp: 'btb 5/24/2002 12:20'!
tcObject

	^16r73! !

!JavaSerConstants class methodsFor: 'class description' stamp: 'btb 5/24/2002 12:17'!
scWriteMethod

	^16r01! !

!JavaSerConstants class methodsFor: 'terminal constants' stamp: 'btb 5/24/2002 12:20'!
tcClassDesc

	^16r72! !

!JavaSerConstants class methodsFor: 'terminal constants' stamp: 'btb 5/24/2002 12:21'!
tcEndBlockData

	^16r78! !

!JavaSerConstants class methodsFor: 'terminal constants' stamp: 'btb 5/24/2002 12:21'!
tcBlockData

	^16r77! !

!JavaSerConstants class methodsFor: 'terminal constants' stamp: 'btb 5/24/2002 12:19'!
tcReference

	^16r71! !

!JavaSerConstants class methodsFor: 'terminal constants' stamp: 'btb 5/24/2002 12:22'!
tcProxyClassDesc

	^16r7D! !

!JavaSerConstants class methodsFor: 'class description' stamp: 'btb 5/24/2002 12:17'!
scExternalizable

	^16r04! !

!JavaSerConstants class methodsFor: 'constants' stamp: 'btb 5/7/2002 12:05'!
streamMagic

	^16rACED! !

!JavaSerConstants class methodsFor: 'terminal constants' stamp: 'btb 5/24/2002 12:22'!
tcException

	^16r7B! !

!JavaSerConstants class methodsFor: 'terminal constants' stamp: 'btb 5/24/2002 12:20'!
tcString

	^16r74! !

!JavaSerConstants class methodsFor: 'constants' stamp: 'btb 5/7/2002 12:07'!
streamVersion

	^5! !

!JavaSerConstants class methodsFor: 'terminal constants' stamp: 'btb 5/24/2002 12:20'!
tcArray

	^16r75! !

Object subclass: #JavaWriteStream
	instanceVariableNames: 'internal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Core'!

!JavaWriteStream commentStamp: 'btb 9/18/2003 19:47' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaWriteStream methodsFor: 'writing' stamp: 'btb 3/5/2004 10:56'!
nextPutChar: aCharacter

	^self nextPutUTFChar: aCharacter ! !

!JavaWriteStream methodsFor: 'accessing' stamp: 'btb 3/23/2003 12:11'!
internal: anObject
	internal := anObject.
	internal binary.! !

!JavaWriteStream methodsFor: 'writing' stamp: 'btb 8/25/2004 19:49'!
nextPutUnsignedInt: anInteger

	| temp |
	temp:=anInteger abs bitAnd: 16rFFFFFFFF.
	self nextPutUnsignedShort: (temp >> 16).
	self nextPutUnsignedShort: temp! !

!JavaWriteStream methodsFor: 'writing' stamp: 'btb 3/22/2003 20:04'!
nextPutByte: aByte

	self internal nextPut: (aByte bitAnd: 16rFF)! !

!JavaWriteStream methodsFor: 'writing' stamp: 'btb 8/25/2004 19:58'!
nextPutInt: anInteger

	^self nextPutUnsignedInt: ((anInteger < 0)
		ifTrue: [(anInteger abs bitXor: 16rFFFFFFFF) + 1]
		ifFalse: [anInteger])! !

!JavaWriteStream methodsFor: 'accessing' stamp: 'btb 3/22/2003 19:47'!
internal
	^internal! !

!JavaWriteStream methodsFor: 'writing' stamp: 'btb 8/25/2004 19:51'!
nextPutFloat: aFloat
	self nextPutInt: aFloat asIEEE32BitWord! !

!JavaWriteStream class methodsFor: 'instance creation' stamp: 'btb 3/22/2003 20:00'!
onStream: aWriteStream

	^super new
		initialize;
		internal: aWriteStream;
		yourself! !

!JavaWriteStream methodsFor: 'writing' stamp: 'btb 8/25/2004 19:59'!
nextPutShort: aShort

	^self nextPutUnsignedShort: ((aShort < 0)
		ifTrue: [(aShort abs bitXor: 16rFFFF) + 1]
		ifFalse: [aShort])! !

!JavaWriteStream methodsFor: 'writing' stamp: 'btb 8/25/2004 19:36'!
nextPutByteArray: aByteArray

	aByteArray do: [:eachByte | self nextPutUnsignedByte: eachByte]! !

!JavaWriteStream methodsFor: 'writing' stamp: 'btb 8/25/2004 19:48'!
nextPutJavaUTFString: aString

	| string size |
	string:=aString asJavaUTF8String.
	size:=string size.
	(size > 16rFFFF)
		ifTrue: [self nextPutUnsignedLong: size]
		ifFalse: [self nextPutUnsignedShort: size].
	string do: [:eachChar | self nextPutUTFChar: eachChar]! !

!JavaWriteStream methodsFor: 'writing' stamp: 'btb 8/25/2004 19:45'!
nextPutUTFChar: aCharacter
	| value |
	value:=aCharacter asJavaUTF8Character value.
	(value noMask: 16r80)
		ifTrue: [self nextPutUnsignedByte: value]
		ifFalse: [self nextPutUnsignedByte: (16rC0 bitOr: (value >> 6));
					 nextPutUnsignedByte: (16r80 bitOr: (value bitAnd: 16r3F))]! !

!JavaWriteStream methodsFor: 'writing' stamp: 'btb 8/25/2004 19:51'!
nextPutDouble: aDouble

	self nextPutInt: (aDouble basicAt: 1).
	self nextPutInt: (aDouble basicAt: 2).! !

!JavaWriteStream methodsFor: 'writing' stamp: 'btb 8/25/2004 19:49'!
nextPutUnsignedLong: aLong

	| temp |
	temp:=aLong abs bitAnd: 16rFFFFFFFFFFFFFFFF.
	self nextPutInt: (temp >> 32).
	self nextPutInt: temp.! !

!JavaWriteStream methodsFor: 'writing' stamp: 'btb 8/25/2004 19:50'!
nextPutUnsignedShort: aShort

	| temp |
	temp:=aShort abs bitAnd: 16rFFFF.
	self nextPutUnsignedByte: (temp >> 8).
	self nextPutUnsignedByte: temp.
	! !

!JavaWriteStream methodsFor: 'writing' stamp: 'btb 8/25/2004 19:33'!
nextPutBoolean: aBoolean

	self nextPutUnsignedByte: (aBoolean ifTrue: [1] ifFalse: [0])! !

!JavaWriteStream methodsFor: 'writing' stamp: 'btb 8/25/2004 19:49'!
nextPutUnsignedByte: aByte

	self internal nextPut: (aByte abs bitAnd: 16rFF)! !

JavaWriteStream subclass: #JavaSerWriteStream
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Serialization-Core'!

!JavaSerWriteStream commentStamp: 'btb 9/18/2003 19:44' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaSerWriteStream methodsFor: 'writing' stamp: 'btb 2/28/2004 11:10'!
writeString: aJavaUTF8String

	| size |
	size := aJavaUTF8String size.
	size > 65535
		ifTrue: [self outputLongStringCode]
		ifFalse: [self outputStringCode].
	self nextPutJavaUTFString: aJavaUTF8String.
	self cacheAt: self newHandle put: aJavaUTF8String! !

!JavaSerWriteStream methodsFor: 'private' stamp: 'btb 2/15/2004 18:01'!
newHandle

	"return the next handle"
	^self cache newHandle! !

!JavaSerWriteStream methodsFor: 'terminal' stamp: 'btb 2/17/2004 19:22'!
outputLongStringCode

	self nextPutByte: JavaSerConstants tcLongString! !

!JavaSerWriteStream methodsFor: 'writing' stamp: 'btb 8/25/2004 20:04'!
writeBlockData: aByteArray 
	| size |
	size := aByteArray size.
	size > 65535
		ifTrue: [self outputBlockDataLongCode. 
			self nextPutUnsignedInt: size]
		ifFalse: [self outputBlockDataCode.
			self nextPutUnsignedByte: size].
	aByteArray
		do: [:each | self nextPutByte: each]! !

!JavaSerWriteStream methodsFor: 'private' stamp: 'btb 2/28/2004 21:39'!
flush

	internal flush! !

!JavaSerWriteStream methodsFor: 'private' stamp: 'btb 10/27/2003 19:50'!
reset
	self cache: JavaSerObjectCache new! !

!JavaSerWriteStream methodsFor: 'private' stamp: 'btb 3/23/2003 12:09'!
initialize

	super initialize.
	self reset.! !

!JavaSerWriteStream methodsFor: 'terminal' stamp: 'btb 2/17/2004 19:21'!
outputBlockDataCode

	self nextPutByte: JavaSerConstants tcBlockData! !

!JavaSerWriteStream methodsFor: 'terminal' stamp: 'btb 2/17/2004 19:22'!
outputExceptionCode

	self nextPutByte: JavaSerConstants tcException! !

!JavaSerWriteStream methodsFor: 'terminal' stamp: 'btb 2/17/2004 19:22'!
outputStringCode

	self nextPutByte: JavaSerConstants tcString! !

!JavaSerWriteStream methodsFor: 'terminal' stamp: 'btb 2/17/2004 19:21'!
outputEndBlockDataCode

	self nextPutByte: JavaSerConstants tcEndBlockData! !

!JavaSerWriteStream methodsFor: 'terminal' stamp: 'btb 2/17/2004 19:22'!
outputProxyClassDescCode

	self nextPutByte: JavaSerConstants tcProxyClassDesc! !

!JavaSerWriteStream methodsFor: 'writing' stamp: 'btb 8/25/2004 20:04'!
writeClassDescription: aClassDesc

	self outputClassDescCode.
	self nextPutJavaUTFString: aClassDesc name.
	self nextPutUnsignedLong: aClassDesc serialVersionUID.
	self cacheAt: self newHandle put: aClassDesc.
	aClassDesc flags writeToJavaStream: self.
	self writeFields: aClassDesc fields.
	self writeObjectAnnotation: aClassDesc classAnnotation.
	self writeContent: aClassDesc superClassDescription! !

!JavaSerWriteStream methodsFor: 'writing' stamp: 'btb 8/25/2004 20:04'!
writeContent: anObject 
	anObject
		ifNil: [^ self outputNullCode].
	anObject class == ByteArray
		ifTrue: [^self writeBlockData: anObject].
	self cache
		handleAt: anObject
		ifPresent: [:handle | 
			self outputReferenceCode.
			self nextPutUnsignedInt: handle]
		ifAbsent: [anObject writeToJavaStream: self]! !

!JavaSerWriteStream methodsFor: 'writing-attributes' stamp: 'btb 8/25/2004 20:05'!
writeVersion

	 self nextPutUnsignedShort: JavaSerConstants streamVersion! !

!JavaSerWriteStream methodsFor: 'terminal' stamp: 'btb 2/17/2004 19:21'!
outputClassDescCode

	self nextPutByte: JavaSerConstants tcClassDesc! !

!JavaSerWriteStream methodsFor: 'private' stamp: 'btb 2/27/2004 20:11'!
classDescriptionForType: aJavaType

	^self classCache classDescriptionForType: aJavaType! !

!JavaSerWriteStream methodsFor: 'private' stamp: 'btb 5/15/2002 20:28'!
cache: aDictionary

	cache:=aDictionary! !

!JavaSerWriteStream methodsFor: 'terminal' stamp: 'btb 2/17/2004 19:22'!
outputObjectCode

	self nextPutByte: JavaSerConstants tcObject! !

!JavaSerWriteStream methodsFor: 'writing-attributes' stamp: 'btb 8/25/2004 20:05'!
writeMagic

	 self nextPutUnsignedShort: JavaSerConstants streamMagic! !

!JavaSerWriteStream methodsFor: 'writing' stamp: 'btb 2/27/2004 20:42'!
writeObject: aJavaSerObject

	self outputObjectCode.
	self writeContent: aJavaSerObject classDescription.
	self cacheAt: self newHandle put: aJavaSerObject.
	aJavaSerObject classDescription writeObjectContents: aJavaSerObject to: self! !

!JavaSerWriteStream methodsFor: 'private' stamp: 'btb 3/23/2003 12:10'!
internal: aWriteStream 
	super internal: aWriteStream.
	self writeMagic.
	self writeVersion.! !

!JavaSerWriteStream methodsFor: 'writing' stamp: 'btb 2/27/2004 20:56'!
writeException: anExceptionObject

	self writeReset.
	self writeContent: anExceptionObject.
	self writeReset.! !

!JavaSerWriteStream methodsFor: 'terminal' stamp: 'btb 2/28/2004 12:52'!
outputNullCode

	self nextPutByte: JavaSerConstants tcNull! !

!JavaSerWriteStream methodsFor: 'writing' stamp: 'btb 8/25/2004 20:05'!
writeFields: someFields

	self nextPutUnsignedShort: someFields size.
	someFields do: [:each | each writeToJavaStream: self].! !

!JavaSerWriteStream methodsFor: 'private' stamp: 'btb 2/28/2004 11:12'!
cacheAt: handle put: aJavaObject

	self cache atHandle: handle put: aJavaObject! !

!JavaSerWriteStream methodsFor: 'private' stamp: 'btb 5/15/2002 20:28'!
cache

	^cache! !

!JavaSerWriteStream methodsFor: 'writing' stamp: 'btb 2/27/2004 20:39'!
writeContents: aCollection

	aCollection do: [:each | self writeContent: each]! !

!JavaSerWriteStream methodsFor: 'terminal' stamp: 'btb 2/17/2004 19:22'!
outputResetCode

	self nextPutByte: JavaSerConstants tcReset! !

!JavaSerWriteStream methodsFor: 'private' stamp: 'btb 2/27/2004 19:26'!
classCache

	^JavaClassCache default! !

!JavaSerWriteStream methodsFor: 'writing' stamp: 'btb 8/25/2004 20:04'!
writeProxyClassDescription: aJavaSerProxyClassDescription 
	self outputProxyClassDescCode.
	self cacheAt: self newHandle put: aJavaSerProxyClassDescription.
	self nextPutUnsignedInt: aJavaSerProxyClassDescription interfaceNames size.
	aJavaSerProxyClassDescription interfaceNames 
		do: [:each | self writeString: each].
	self writeObjectAnnotation: aJavaSerProxyClassDescription classAnnotation.
	self writeContent: aJavaSerProxyClassDescription superClassDescription! !

!JavaSerWriteStream methodsFor: 'private' stamp: 'btb 2/15/2004 17:29'!
cacheAt: handle 

	^self cache atHandle: handle.! !

!JavaSerWriteStream methodsFor: 'writing-primitive' stamp: 'btb 2/28/2004 11:50'!
writeObjectAnnotation: aCollection

	aCollection do: [:each | self writeContent: each].
	self outputEndBlockDataCode.! !

!JavaSerWriteStream methodsFor: 'terminal' stamp: 'btb 2/17/2004 19:21'!
outputClassCode

	self nextPutByte: JavaSerConstants tcClass! !

!JavaSerWriteStream methodsFor: 'writing' stamp: 'btb 2/28/2004 11:12'!
writeArray: aJavaSerArray

	| handle classDesc |
	self outputArrayCode.
	classDesc := self classDescriptionForType: aJavaSerArray type.
	self writeContent: classDesc.
	handle := self newHandle.
	self cacheAt: handle put: aJavaSerArray.
	classDesc writeArrayContents: aJavaSerArray to: self! !

!JavaSerWriteStream methodsFor: 'terminal' stamp: 'btb 2/17/2004 19:21'!
outputArrayCode

	self nextPutByte: JavaSerConstants tcArray! !

!JavaSerWriteStream methodsFor: 'writing' stamp: 'btb 2/27/2004 20:33'!
writeClass: aJavaSerClass

	self outputClassCode.
	self writeContent: aJavaSerClass description.
	self cacheAt: self newHandle put: aJavaSerClass.
	! !

!JavaSerWriteStream methodsFor: 'writing' stamp: 'btb 2/27/2004 20:57'!
writeReset

	self outputResetCode.
	self reset.! !

!JavaSerWriteStream methodsFor: 'terminal' stamp: 'btb 2/17/2004 19:21'!
outputBlockDataLongCode

	self nextPutByte: JavaSerConstants tcBlockDataLong! !

!JavaSerWriteStream methodsFor: 'terminal' stamp: 'btb 2/17/2004 19:22'!
outputReferenceCode

	self nextPutByte: JavaSerConstants tcReference! !

!JavaWriteStream methodsFor: 'writing' stamp: 'btb 8/25/2004 19:58'!
nextPutLong: aLong

	^self nextPutUnsignedLong: ((aLong < 0)
		ifTrue: [(aLong abs bitXor: 16rFFFFFFFFFFFFFFFF) + 1]
		ifFalse: [aLong])! !

Object subclass: #JavaAttribute
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Core'!

!JavaAttribute commentStamp: 'btb 9/18/2003 19:47' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

Object subclass: #JavaByteCodes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader-ByteCode'!

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:13'!
i2b

	^145! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:03'!
dneg

	^119! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:14'!
iand

	^126! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:29'!
lastore

	^80! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:59'!
lneg

	^117! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 19:55'!
aload2

	^44! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 21:00'!
lstore0

	^63! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:07'!
f2i

	^139! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:22'!
iload0

	^26! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 21:08'!
sipush

	^17! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:04'!
dstore2

	^73! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:20'!
iflt

	^155! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 21:01'!
lxor

	^131! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:24'!
invokespecial

	^183! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:16'!
iconst5

	^8! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 19:55'!
aconstNull

	^1! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:29'!
l2i

	^136! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:01'!
dconst0

	^14! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 21:00'!
lstore

	^55! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:13'!
i2c

	^146! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:07'!
f2l

	^140! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:07'!
fastore

	^81! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 19:54'!
aaload

	^50! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 21:09'!
wide

	^196! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 21:07'!
putstatic

	^179! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 19:55'!
areturn

	^176! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:03'!
drem

	^115! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:08'!
fdiv

	^110! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:59'!
lrem

	^113! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/15/2004 10:45'!
dup2X2

	^94! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 21:08'!
sastore

	^86! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 19:57'!
astore3

	^78! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/15/2004 20:38'!
break

	^202! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 19:58'!
bipush

	^16! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:30'!
ldc

	^18! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:26'!
istore2

	^61! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 21:08'!
saload

	^53! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 19:59'!
d2i

	^142! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 21:07'!
putfield

	^181! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:11'!
fstore3

	^70! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:02'!
dload1

	^39! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 21:01'!
lushr

	^125! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:25'!
ishl

	^120! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 19:56'!
astore2

	^77! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:20'!
ifge

	^156! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:11'!
freturn

	^174! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:16'!
iconst4

	^7! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:59'!
lshr

	^123! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:09'!
fload3

	^37! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 19:59'!
dadd

	^99! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:28'!
jsrW

	^201! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 21:06'!
newarray

	^188! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/15/2004 20:38'!
impdep2

	^255! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 19:57'!
baload

	^51! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 21:00'!
lstore2

	^65! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:08'!
fconst0

	^11! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:23'!
instanceof

	^193! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:58'!
lmul

	^105! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:29'!
laload

	^47! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 21:00'!
lstore1

	^64! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:59'!
lor

	^129! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 19:55'!
aload3

	^45! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:58'!
lload0

	^30! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:09'!
fload

	^23! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:15'!
iconst1

	^4! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:57'!
ldc2W

	^20! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:06'!
dupX1

	^90! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:22'!
iload

	^21! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:22'!
iload1

	^27! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:12'!
getfield

	^180! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:05'!
dstore3

	^74! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:13'!
i2l

	^133! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:09'!
fload0

	^34! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:01'!
dconst1

	^15! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:13'!
i2d

	^135! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:29'!
ladd

	^97! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:18'!
ifIcmplt

	^161! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:25'!
ior

	^128! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 21:06'!
pop

	^87! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:24'!
invokevirtual

	^182! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:05'!
dsub

	^103! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:22'!
iinc

	^132! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 19:56'!
arraylength

	^190! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 21:02'!
multianewarray

	^197! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 19:58'!
caload

	^52! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 19:55'!
aload0

	^42! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:14'!
iadd

	^96! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:59'!
lookupswitch

	^171! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 19:56'!
astore

	^58! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 21:01'!
lsub

	^101! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 21:08'!
swap

	^95! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:04'!
dstore0

	^71! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:27'!
iushr

	^124! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:29'!
land

	^127! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:18'!
ifIcmpeq

	^159! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:27'!
istore3

	^62! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:30'!
lconst1

	^10! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:26'!
istore0

	^59! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:15'!
iconst0

	^3! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:00'!
dastore

	^82! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 21:09'!
tableswitch

	^170! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:11'!
fstore1

	^68! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:01'!
dcmpl

	^151! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:13'!
i2s

	^147! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:57'!
ldiv

	^109! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:13'!
i2f

	^134! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:25'!
ireturn

	^172! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 21:06'!
newobject

	^187! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:21'!
ifle

	^158! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:21'!
ifgt

	^157! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:11'!
fstore0

	^67! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:18'!
ifIcmpge

	^162! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:24'!
invokestatic

	^184! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:05'!
dup

	^89! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:10'!
fneg

	^118! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 21:02'!
monitorexit

	^195! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:20'!
ifeq

	^153! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:59'!
lreturn

	^173! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:23'!
ineg

	^116! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 21:06'!
nop

	^0! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 21:00'!
lstore3

	^66! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:08'!
fconst1

	^12! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:03'!
dmul

	^107! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:22'!
iload3

	^29! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:02'!
dload2

	^40! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:28'!
ixor

	^130! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:21'!
ifnonnull

	^199! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 19:56'!
astore0

	^75! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:58'!
lload1

	^31! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:18'!
ifIcmpne

	^160! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:07'!
fcmpg

	^150! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:20'!
ifne

	^154! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:22'!
iload2

	^28! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:06'!
dupX2

	^91! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:12'!
fsub

	^102! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:09'!
fload1

	^35! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:27'!
isub

	^100! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 19:58'!
d2f

	^144! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:29'!
lcmp

	^148! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:23'!
invokeinterface

	^185! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:59'!
lshl

	^121! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:26'!
istore

	^54! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:11'!
fstore

	^56! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 21:01'!
monitorenter

	^194! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 19:59'!
daload

	^49! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:12'!
getstatic

	^178! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:15'!
iconst3

	^6! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:10'!
frem

	^114! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 19:55'!
aload

	^25! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:28'!
l2d

	^138! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:25'!
irem

	^112! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 19:57'!
athrow

	^191! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:16'!
idiv

	^108! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 19:55'!
aload1

	^43! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:30'!
lconst0

	^9! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:02'!
dload

	^24! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:04'!
dstore1

	^72! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:57'!
ldcW

	^19! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:06'!
f2d

	^141! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:12'!
gotoW

	^200! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:01'!
dcmpg

	^152! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:58'!
lload

	^22! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:04'!
dreturn

	^175! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:04'!
dstore

	^57! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:25'!
ishr

	^122! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:11'!
fstore2

	^69! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:28'!
jsr

	^168! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 21:08'!
return

	^177! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/15/2004 20:38'!
impdep1

	^254! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 19:59'!
d2l

	^143! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:16'!
ifAcmpeq

	^165! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:10'!
fmul

	^106! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:12'!
goto

	^167! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:15'!
iconst2

	^5! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:28'!
l2f

	^137! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:23'!
imul

	^104! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:19'!
ifIcmple

	^164! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 19:58'!
checkcast

	^192! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:19'!
ifIcmpgt

	^163! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/15/2004 10:44'!
dup2X1

	^93! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:26'!
istore1

	^60! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 19:54'!
aastore

	^83! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:08'!
fconst2

	^13! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:21'!
ifnull

	^198! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:58'!
lload3

	^33! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 21:07'!
ret

	^169! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:17'!
ifAcmpne

	^166! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:14'!
iaload

	^46! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:03'!
dload3

	^41! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 19:57'!
bastore

	^84! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:02'!
ddiv

	^111! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:02'!
dload0

	^38! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:06'!
dup2

	^92! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 21:07'!
pop2

	^88! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:14'!
iastore

	^79! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:58'!
lload2

	^32! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 19:54'!
anewarray

	^189! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:08'!
fcmpl

	^149! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 19:58'!
castore

	^85! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:07'!
faload

	^48! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:07'!
fadd

	^98! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:15'!
iconstM1

	^2! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 19:56'!
astore1

	^76! !

!JavaByteCodes class methodsFor: 'as yet unclassified' stamp: 'btb 8/12/2004 20:09'!
fload2

	^36! !

Object subclass: #JavaLineNumberInfo
	instanceVariableNames: 'startPC lineNumber'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader-Attributes'!

!JavaLineNumberInfo commentStamp: 'btb 9/18/2003 19:46' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaLineNumberInfo methodsFor: 'reading' stamp: 'btb 8/16/2004 10:58'!
readFromClassDefLoader: aClassDefLoader


	self
		startPC: (aClassDefLoader nextUnsignedShort);
		lineNumber: (aClassDefLoader nextUnsignedShort)! !

!JavaLineNumberInfo class methodsFor: 'as yet unclassified' stamp: 'btb 8/16/2004 11:07'!
readFromClassDefLoader: aClassDefLoader

	^self new readFromClassDefLoader: aClassDefLoader! !

!JavaLineNumberInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 17:39'!
startPC: anObject
	startPC := anObject! !

!JavaLineNumberInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 17:39'!
lineNumber
	^lineNumber! !

!JavaLineNumberInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 17:39'!
lineNumber: anObject
	lineNumber := anObject! !

!JavaLineNumberInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 17:39'!
startPC
	^startPC! !

Object subclass: #JavaReadStream
	instanceVariableNames: 'internal'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Core'!

!JavaReadStream commentStamp: 'btb 9/18/2003 19:47' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaReadStream class methodsFor: 'instance creation' stamp: 'btb 8/24/2004 20:09'!
onByteArray: aByteArray

	^self onStream: aByteArray readStream! !

!JavaReadStream methodsFor: 'reading' stamp: 'btb 3/23/2003 12:03'!
nextJavaUTFString
	"http://java.sun.com/products/jdk/1.1/docs/guide/jni/spec/types.doc.html"
	| length |
	length:=self nextUnsignedShort.
	^self nextJavaUTFString: length! !

!JavaReadStream methodsFor: 'reading' stamp: 'btb 3/5/2004 10:49'!
nextChar

	^self nextUTFChar! !

!JavaReadStream methodsFor: 'reading' stamp: 'btb 3/23/2003 12:04'!
nextDouble
	"http://java.sun.com/j2se/1.3/docs/api/java/lang/Double.html"
	| temp1 temp2 |
	temp1:=self nextUnsignedInt.
	temp2:=self nextUnsignedInt.
	^(Float new: 2)
		basicAt: 1 put: temp1;
		basicAt: 2 put: temp2;
		yourself.! !

!JavaReadStream methodsFor: 'reading' stamp: 'btb 8/24/2004 20:22'!
nextByteArray: size

	| answer |
	answer:=ByteArray new: size.
	1 to: size do: [:index |
		answer at: index put: self nextUnsignedByte].
	^answer! !

!JavaReadStream methodsFor: 'accessing' stamp: 'btb 3/22/2003 19:46'!
internal
	^internal! !

!JavaReadStream methodsFor: 'reading' stamp: 'btb 3/23/2003 12:01'!
nextInt

	^self nextSigned: 4! !

!JavaReadStream methodsFor: 'reading' stamp: 'btb 8/24/2004 22:25'!
nextUnsigned: numOfBytes

	^(self internal next: numOfBytes) asJavaUnsignedValue
	! !

!JavaReadStream methodsFor: 'reading' stamp: 'btb 3/23/2003 12:03'!
nextShort

	^self nextSigned: 2! !

!JavaReadStream class methodsFor: 'instance creation' stamp: 'btb 3/22/2004 19:55'!
onStream: aReadStream

	^self new
		internal: aReadStream;
		yourself! !

!JavaReadStream methodsFor: 'reading' stamp: 'btb 3/23/2003 15:26'!
peekAsciiChar

	^self peek asCharacter! !

!JavaReadStream methodsFor: 'reading' stamp: 'btb 8/25/2004 19:36'!
nextByte

	^self internal next! !

!JavaReadStream methodsFor: 'reading' stamp: 'btb 3/22/2003 19:52'!
nextJavaUTFString: length 
	"http://java.sun.com/products/jdk/1.1/docs/guide/jni/spec/types.doc.html"

	| answer |
	answer := JavaUTF8String new: length.
	1 to: length do: [:index | answer at: index put: self nextUTFChar].
	^answer! !

!JavaReadStream methodsFor: 'reading' stamp: 'btb 3/23/2003 12:01'!
nextUnsignedInt

	^self nextUnsigned: 4! !

JavaReadStream subclass: #JavaSerReadStream
	instanceVariableNames: 'cache'
	classVariableNames: 'TerminalReadActions'
	poolDictionaries: ''
	category: 'Java-Serialization-Core'!

!JavaSerReadStream commentStamp: '<historical>' prior: 0!
The heart of reading java serialization streams

Example:

| fileName fs |
fileName:='c:\temp\test1.ser'.
fs:=FileStream fileNamed: fileName.
[(JavaReadStream on: fs) readObject inspect.
] ensure: [fs close].

Copyright (c) 2002 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 5/6/2002 12:16!

!JavaSerReadStream methodsFor: 'peeking' stamp: 'btb 5/1/2002 22:28'!
peekIsObject

	^self peekIsBlockData not! !

!JavaSerReadStream methodsFor: 'private-terminal' stamp: 'btb 8/25/2004 20:01'!
obtainReference

	| handle |
	handle:=self nextUnsignedInt.
	^self cacheAt: handle "if the handle is not resolved in cache...it will return an unknown reference"! !

!JavaSerReadStream methodsFor: 'private-terminal' stamp: 'btb 2/16/2004 19:40'!
obtainArray
	"classDesc newHandle (int)<size> values[size]"

	| classDesc newHandle answer |
	classDesc:=self readContent.
	newHandle:=self newHandle.
	answer:=classDesc readArrayContentsFrom: self.
	self cacheAt: newHandle put: answer.
	^answer! !

!JavaSerReadStream methodsFor: 'private-terminal' stamp: 'btb 8/24/2004 20:22'!
obtainBlockDataShort

	| size |
	size:=self nextUnsignedByte.
	^self nextByteArray: size! !

!JavaSerReadStream methodsFor: 'private-terminal' stamp: 'btb 8/24/2004 20:22'!
obtainClassDescription
	"className serialVersionUID newHandle classDescInfo"
	| answer handle |
	answer := JavaSerClassDescription new.
	answer name: self nextJavaUTFString asAsciiString;
		 serialVersionUID: self nextLong.
	handle := self newHandle.
	answer
		flags: (JavaSerClassDescriptionFlags newWith: self nextUnsignedByte);
		 fields: self readFields;
		 classAnnotation: self readObjectAnnotation;
		 superClassDescription: self readContent.
	self cacheAt: handle put: answer.
	answer addToCache: self classCache.
	^ answer! !

!JavaSerReadStream methodsFor: 'private' stamp: 'btb 2/27/2004 19:23'!
classCache

	^JavaClassCache default! !

!JavaSerReadStream methodsFor: 'private-terminal' stamp: 'btb 8/25/2004 20:01'!
obtainProxyClassDescription
	"newHandle (int)<count> proxyInterfaceName[count] classAnnotation superClassDesc"

	| count interfaceNames answer handle |
	answer := JavaSerProxyClassDescription new.
	handle := self newHandle.
	count := self nextUnsignedInt.
	interfaceNames := Array new: count.
	1 to: count
		do: [:index | interfaceNames at: index put: self nextJavaUTFString asAsciiString].
	answer
		interfaceNames: interfaceNames;
		classAnnotation: self readObjectAnnotation;
		superClassDescription: self readContent.
	self cacheAt: handle put: answer.
	^answer! !

!JavaSerReadStream methodsFor: 'private-terminal' stamp: 'btb 4/17/2002 20:57'!
obtainEndBlockData

	^#EndBlockData! !

!JavaSerReadStream methodsFor: 'private' stamp: 'btb 2/15/2004 17:07'!
referenceAt: handle 

	^self cache referenceAt: handle! !

!JavaSerReadStream methodsFor: 'private-terminal' stamp: 'btb 6/15/2003 20:33'!
obtainString

	"newHandle (utf)"

	| handle answer |
	handle:=self newHandle.
	answer:=self nextJavaUTFString.
	self cacheAt: handle put: answer.
	^answer! !

!JavaSerReadStream methodsFor: 'peeking' stamp: 'btb 10/27/2003 19:46'!
peekIsBlockData

	| temp |
	temp:=self peek.
	^temp =  (JavaSerConstants tcBlockData) 
				or: [temp = (JavaSerConstants tcBlockDataLong) 
				or: [temp = (JavaSerConstants tcEndBlockData) ]]! !

!JavaSerReadStream methodsFor: 'private-terminal' stamp: 'btb 2/16/2004 20:35'!
obtainObject
	| classDesc newHandle answer |
	classDesc:=self readContent.
	newHandle:=self newHandle.
	answer:=classDesc readObjectContentsFrom: self.
	self cacheAt: newHandle put: answer.
	^answer! !

!JavaSerReadStream methodsFor: 'reading-attributes' stamp: 'btb 8/24/2004 22:36'!
readMagic

	| magicContents |
	magicContents:=self nextUnsignedShort.
	(magicContents = (JavaSerConstants streamMagic))
		ifFalse: [Error signal: 'Not Java Serialization Stream'].
	! !

!JavaSerReadStream class methodsFor: 'initialize-release' stamp: 'btb 10/27/2003 19:46'!
initializeTerminalReadActions

	TerminalReadActions _ Dictionary new.
	TerminalReadActions 
		 at: (JavaSerConstants tcNull) put: #obtainNull;
		 at: (JavaSerConstants tcReference) put: #obtainReference;
		 at: (JavaSerConstants tcClassDesc) put: #obtainClassDescription;
		 at: (JavaSerConstants tcObject) put: #obtainObject;
		 at: (JavaSerConstants tcString) put: #obtainString;
		 at: (JavaSerConstants tcArray) put: #obtainArray;
		 at: (JavaSerConstants tcClass) put: #obtainClass;
		 at: (JavaSerConstants tcBlockData) put: #obtainBlockDataShort;
		 at: (JavaSerConstants tcEndBlockData) put: #obtainEndBlockData;
		 at: (JavaSerConstants tcReset) put: #obtainReset;
		 at: (JavaSerConstants tcBlockDataLong) put: #obtainBlockDataLong;
		 at: (JavaSerConstants tcException) put: #obtainException;
		 at: (JavaSerConstants tcLongString) put: #obtainStringLong;
		 at: (JavaSerConstants tcProxyClassDesc) put: #obtainProxyClassDescription.! !

!JavaSerReadStream methodsFor: 'private' stamp: 'btb 7/28/2002 08:12'!
resolveReferencesToHandle: handle to: cacheObject

	| reference |
	reference:=self referenceAt: handle.
	reference ifNotNil: [reference becomeForward: cacheObject].
	self removeReferenceAt: handle.! !

!JavaSerReadStream methodsFor: 'private' stamp: 'btb 4/16/2002 12:24'!
cache: aDictionary

	cache:=aDictionary! !

!JavaSerReadStream class methodsFor: 'constants-codes' stamp: 'btb 4/17/2002 20:04'!
terminalReadActions
	TerminalReadActions ifNil: [self initializeTerminalReadActions].
	^TerminalReadActions! !

!JavaSerReadStream methodsFor: 'reading-attributes' stamp: 'btb 8/25/2004 20:03'!
readVersion

	| versionContents version |
	versionContents:=self nextUnsignedShort.
	"Hint: Need to adapt to older versions...For now, just throw this"
	version:=JavaSerConstants streamVersion.
	(versionContents = version)
		ifFalse: [Error signal: ('Wrong Version Need: ' , version asString) ].
	! !

!JavaSerReadStream methodsFor: 'reading-attributes' stamp: 'btb 8/24/2004 20:22'!
readContent
	
	| type action |
	type:=self nextUnsignedByte.
	action:=self terminalReadActions at: type ifAbsent: [Error signal: ('Bad Terminal: ', type asString)].
	^self perform: action! !

!JavaSerReadStream methodsFor: 'reading-attributes' stamp: 'btb 7/26/2002 20:35'!
readObjectAnnotation

	"endBlockData
  	 contents endBlockData"
	| answer last |
	answer:=OrderedCollection new.
	[last:=self readContent.
	 last == #EndBlockData] 
		whileFalse: [answer add: last].
	^answer! !

!JavaSerReadStream methodsFor: 'reading' stamp: 'btb 5/6/2002 12:38'!
readObject

	^self readContent! !

!JavaSerReadStream methodsFor: 'private-terminal' stamp: 'btb 2/16/2004 20:30'!
obtainClass
	"classDesc newHandle"

	| answer handle |
	answer:=JavaSerClass new.
	answer description: self readContent.
	handle:=self newHandle.
	self cacheAt: handle put: answer.
	^answer! !

!JavaSerReadStream methodsFor: 'private' stamp: 'btb 3/23/2003 12:09'!
initialize
	super initialize.
	self reset.! !

!JavaSerReadStream methodsFor: 'private' stamp: 'btb 2/15/2004 17:06'!
removeReferenceAt: handle 

	self cache removeReferenceAt: handle! !

!JavaSerReadStream methodsFor: 'private-terminal' stamp: 'btb 8/25/2004 20:01'!
obtainBlockDataLong

	| size |
	size:=self nextUnsignedInt.
	^self nextByteArray: size! !

!JavaSerReadStream methodsFor: 'private' stamp: 'btb 10/27/2003 19:50'!
reset
	"This is sent by some of the terminal guys when we are instructed to reset the object stream"

	"we will want to drop all objects in the cache"

	self cache: JavaSerObjectCache new! !

!JavaSerReadStream methodsFor: 'peeking' stamp: 'btb 10/27/2003 19:46'!
peekIsClassDescription

	| temp |
	temp:=self peek.
	^temp = (JavaSerConstants tcClassDesc)
		or: [temp = (JavaSerConstants tcProxyClassDesc)
		or: [temp = (JavaSerConstants tcNull)
		or: [temp = (JavaSerConstants tcReference)]]]! !

!JavaSerReadStream methodsFor: 'peeking' stamp: 'btb 10/27/2003 19:47'!
peekIsArray

	| temp |
	temp:=self peek.
	^temp = (JavaSerConstants tcArray)
		or: [temp = (JavaSerConstants tcNull)
		or: [temp = (JavaSerConstants tcReference)]]! !

!JavaSerReadStream methodsFor: 'private' stamp: 'btb 7/28/2002 11:14'!
cacheAt: handle 

	^self cache atHandle: handle.! !

!JavaSerReadStream methodsFor: 'reading' stamp: 'btb 8/25/2004 20:02'!
readFields

	"(short)<count>  fieldDesc[count]"
	| count answer |
	count:=self nextUnsignedShort.
	answer:=Array new: count.
	1 to: count do: [:index | | code each |
		code := self nextChar.
		each := JavaSerField newFor: code.
		each readFrom: self.
		answer at: index put: each].
	^answer! !

!JavaSerReadStream methodsFor: 'private' stamp: 'btb 3/23/2003 12:11'!
internal: aReadStream

	super internal: aReadStream.
	self readMagic.
	self readVersion.! !

!JavaSerReadStream methodsFor: 'private-terminal' stamp: 'btb 5/1/2002 22:27'!
obtainReset

	self reset.
	^nil! !

!JavaSerReadStream methodsFor: 'cache' stamp: 'btb 7/28/2002 11:16'!
newHandle

	^self cache newHandle! !

!JavaSerReadStream methodsFor: 'private-terminal' stamp: 'btb 2/28/2004 12:11'!
obtainNull

	^nil! !

!JavaSerReadStream methodsFor: 'private' stamp: 'btb 4/16/2002 12:24'!
cache

	^cache! !

!JavaSerReadStream methodsFor: 'private-terminal' stamp: 'btb 2/16/2004 20:34'!
obtainException

	"reset (Throwable)object	 reset"
	| result |
	self reset.
	result := self readContent.
	self reset.
	^result! !

!JavaSerReadStream methodsFor: 'cache' stamp: 'btb 7/28/2002 11:13'!
cacheAt: handle put: aJavaObject

	self cache atHandle: handle put: aJavaObject! !

!JavaSerReadStream methodsFor: 'codes-constants' stamp: 'btb 4/15/2002 20:52'!
terminalReadActions

	^self class terminalReadActions! !

!JavaSerReadStream methodsFor: 'private-terminal' stamp: 'btb 6/15/2003 20:50'!
obtainStringLong

	"newHandle (long-utf)"

	| handle answer |
	handle:=self newHandle.
	answer:=self nextJavaUTFStringLong.
	self cacheAt: handle put: answer.
	^answer! !

!JavaSerReadStream methodsFor: 'reading' stamp: 'btb 7/26/2002 20:39'!
readObjects
	| answer |
	answer:=OrderedCollection new.
	[self atEnd] whileFalse: [answer add: self readObject].
	^answer! !

!JavaReadStream methodsFor: 'reading' stamp: 'btb 3/23/2003 12:03'!
nextUnsignedShort

	^self nextUnsigned: 2! !

!JavaReadStream methodsFor: 'reading' stamp: 'btb 3/22/2003 20:15'!
atEnd

	^self internal atEnd! !

JavaReadStream subclass: #JavaClassDefLoader
	instanceVariableNames: 'majorVersion minorVersion constantPool accessFlags thisClassInfo superClassInfo interfacesInfo fieldsInfo methodsInfo attributesInfo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader'!

!JavaClassDefLoader commentStamp: 'btb 9/18/2003 19:54' prior: 0!
| fileStream answer |
fileStream:=FileStream readOnlyFileNamed: 'C:\bbuxton\dev\squeak\current35\java\java\lang\Thread.class'.
[
	answer:=JavaClassLoader loadFrom: fileStream.
] ensure: [fileStream close].
answer

Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaClassDefLoader methodsFor: 'loading' stamp: 'btb 3/23/2003 12:06'!
loadMajorVersion

	self majorVersion: (self nextUnsignedShort)! !

!JavaClassDefLoader methodsFor: 'loading' stamp: 'btb 3/23/2003 19:21'!
loadInterfacesInfo

	| count interfaces |
	count := self nextUnsignedShort.
	interfaces := OrderedCollection new.
	self interfacesInfo: interfaces.
	count timesRepeat: [interfaces add: self nextConstantPoolInfo].
	! !

!JavaClassDefLoader methodsFor: 'accessing' stamp: 'btb 3/22/2003 15:23'!
minorVersion: anObject
	minorVersion := anObject! !

!JavaClassDefLoader methodsFor: 'accessing' stamp: 'btb 3/22/2003 15:23'!
constantPool: anObject
	constantPool := anObject! !

!JavaClassDefLoader methodsFor: 'accessing' stamp: 'btb 3/22/2003 15:23'!
majorVersion: anObject
	majorVersion := anObject! !

!JavaClassDefLoader methodsFor: 'accessing' stamp: 'btb 3/23/2003 18:33'!
fieldsInfo: anObject
	fieldsInfo := anObject! !

!JavaClassDefLoader methodsFor: 'accessing' stamp: 'btb 3/23/2003 18:32'!
interfacesInfo: anObject
	interfacesInfo := anObject! !

!JavaClassDefLoader methodsFor: 'accessing' stamp: 'btb 3/23/2003 18:33'!
methodsInfo
	^methodsInfo! !

!JavaClassDefLoader methodsFor: 'constant pool' stamp: 'btb 3/23/2003 13:40'!
constantPoolInfoAt: index

	^self constantPool at: index! !

!JavaClassDefLoader methodsFor: 'loading' stamp: 'btb 8/16/2004 10:44'!
loadMethodInfo

	| info |
	info:=JavaMethodInfo new.
	info readFromClassDefLoader: self.
	^info! !

!JavaClassDefLoader methodsFor: 'public' stamp: 'btb 8/16/2004 19:31'!
methodInfoNamed: aName

	^self methodsInfo detect: [:each | each nameInfo value asString = aName]! !

!JavaClassDefLoader methodsFor: 'loading' stamp: 'btb 3/22/2004 19:59'!
load

	[self 
		checkMagic;
		loadMinorVersion;
		loadMajorVersion;
		loadConstantPool;
		loadAccessFlags;
		loadThisClassInfo;
		loadSuperClassInfo;
		loadInterfacesInfo;
		loadFieldsInfo;
		loadMethodsInfo;
		loadAttributesInfo] ensure: [self internal: nil].! !

!JavaClassDefLoader methodsFor: 'accessing' stamp: 'btb 3/23/2003 18:33'!
attributesInfo: anObject
	attributesInfo := anObject! !

!JavaClassDefLoader methodsFor: 'accessing' stamp: 'btb 3/23/2003 18:32'!
thisClassInfo: anObject
	thisClassInfo := anObject! !

!JavaClassDefLoader methodsFor: 'loading' stamp: 'btb 3/23/2003 19:41'!
loadFieldsInfo

	| count fields |
	count := self nextUnsignedShort.
	fields := OrderedCollection new.
	self fieldsInfo: fields.
	count timesRepeat: [fields add: self loadFieldInfo].! !

!JavaClassDefLoader class methodsFor: 'as yet unclassified' stamp: 'btb 3/22/2003 15:09'!
new

	^super new initialize! !

!JavaClassDefLoader methodsFor: 'accessing' stamp: 'btb 3/23/2003 18:32'!
accessFlags: anObject
	accessFlags := anObject! !

!JavaClassDefLoader methodsFor: 'loading' stamp: 'btb 8/25/2004 19:11'!
loadConstantPoolInfo

	| tag answer |
	tag := self nextUnsignedByte.
	answer:=JavaConstantPoolInfo newForTag: tag.
	answer readFromClassDefLoader: self.
	^answer
	! !

!JavaClassDefLoader methodsFor: 'loading' stamp: 'btb 3/23/2003 18:44'!
loadAccessFlags

	self accessFlags: self nextUnsignedShort.! !

!JavaClassDefLoader methodsFor: 'accessing' stamp: 'btb 3/22/2003 15:23'!
constantPool
	^constantPool! !

!JavaClassDefLoader methodsFor: 'loading' stamp: 'btb 3/23/2003 19:22'!
loadSuperClassInfo

	self superClassInfo: self nextConstantPoolInfo! !

!JavaClassDefLoader methodsFor: 'accessing' stamp: 'btb 3/23/2003 18:33'!
attributesInfo
	^attributesInfo! !

!JavaClassDefLoader methodsFor: 'accessing' stamp: 'btb 3/22/2004 19:58'!
isLoading
	^self internal notNil! !

!JavaClassDefLoader methodsFor: 'accessing' stamp: 'btb 3/23/2003 18:32'!
superClassInfo: anObject
	superClassInfo := anObject! !

!JavaClassDefLoader methodsFor: 'loading' stamp: 'btb 8/16/2004 10:44'!
loadAttributeInfo

	^JavaAttributeInfo readFromClassDefLoader: self! !

!JavaClassDefLoader methodsFor: 'accessing' stamp: 'btb 3/22/2003 15:23'!
majorVersion
	^majorVersion! !

!JavaClassDefLoader methodsFor: 'loading' stamp: 'btb 3/23/2003 12:06'!
loadMinorVersion

	self minorVersion: (self nextUnsignedShort)! !

!JavaClassDefLoader methodsFor: 'accessing' stamp: 'btb 3/22/2003 15:23'!
minorVersion
	^minorVersion! !

!JavaClassDefLoader methodsFor: 'loading' stamp: 'btb 3/23/2003 19:42'!
loadMethodsInfo

	| count methods |
	count := self nextUnsignedShort.
	methods := OrderedCollection new.
	self methodsInfo: methods.
	count timesRepeat: [methods add: self loadMethodInfo].! !

!JavaClassDefLoader methodsFor: 'accessing' stamp: 'btb 3/23/2003 18:33'!
methodsInfo: anObject
	methodsInfo := anObject! !

!JavaClassDefLoader methodsFor: 'accessing' stamp: 'btb 3/23/2003 18:32'!
superClassInfo
	^superClassInfo! !

!JavaClassDefLoader methodsFor: 'loading' stamp: 'btb 8/16/2004 17:56'!
loadConstantPool

	| count pool index |
	count:=self nextUnsignedShort.
	pool:=Array new: count.
	self constantPool: pool.
	index := 1.
	[index < count] whileTrue: 
		[| poolInfo |
		poolInfo := self loadConstantPoolInfo.
		pool at: index put: poolInfo.
		index:=poolInfo shouldSkipNext
			ifTrue: [index + 2]
			ifFalse: [index + 1]].! !

!JavaClassDefLoader methodsFor: 'loading' stamp: 'btb 3/23/2003 20:03'!
loadAttributesInfo

	| count attributes |
	attributes := OrderedCollection new.
	self attributesInfo: attributes.
	self atEnd ifTrue: [^self].
	count := self nextUnsignedShort.	
	count timesRepeat: [attributes add: self loadAttributesInfo].! !

!JavaClassDefLoader methodsFor: 'accessing' stamp: 'btb 3/22/2003 16:04'!
constants

	^self class constants! !

!JavaClassDefLoader methodsFor: 'loading' stamp: 'btb 8/16/2004 10:44'!
loadFieldInfo

	| info |
	info:=JavaFieldInfo new.
	info readFromClassDefLoader: self.
	^info! !

!JavaClassDefLoader methodsFor: 'reading' stamp: 'btb 3/23/2003 19:20'!
nextConstantPoolInfo

	^self constantPoolInfoAt: self nextUnsignedShort! !

!JavaClassDefLoader class methodsFor: 'as yet unclassified' stamp: 'btb 3/23/2003 13:30'!
loadFrom: aStream

	^(self onStream: aStream) load! !

!JavaClassDefLoader methodsFor: 'accessing' stamp: 'btb 3/23/2003 18:32'!
interfacesInfo
	^interfacesInfo! !

!JavaClassDefLoader methodsFor: 'constant pool' stamp: 'btb 5/11/2003 17:55'!
nextClassPoolInfo

	^self constantPoolInfoAt: (self nextUnsignedShort)! !

!JavaClassDefLoader methodsFor: 'loading' stamp: 'btb 3/23/2003 19:22'!
loadThisClassInfo

	self thisClassInfo: self nextConstantPoolInfo! !

!JavaClassDefLoader methodsFor: 'accessing' stamp: 'btb 3/23/2003 18:32'!
thisClassInfo
	^thisClassInfo! !

!JavaClassDefLoader methodsFor: 'loading' stamp: 'btb 8/14/2004 17:33'!
checkMagic
	| magic |
	magic := self nextUnsigned: 4.
	magic ~= JavaClassDefLoaderConstants magic 
		ifTrue: [JavaClassDefLoaderFileFormatError signal: 'Bad Magic: ' , magic hex]! !

!JavaClassDefLoader methodsFor: 'accessing' stamp: 'btb 3/23/2003 18:33'!
fieldsInfo
	^fieldsInfo! !

!JavaClassDefLoader methodsFor: 'accessing' stamp: 'btb 3/23/2003 18:32'!
accessFlags
	^accessFlags! !

!JavaReadStream methodsFor: 'reading' stamp: 'btb 8/24/2004 20:31'!
next

	^self internal next! !

!JavaReadStream methodsFor: 'reading' stamp: 'btb 8/24/2004 20:31'!
nextUnsignedByte

	^self internal next! !

!JavaReadStream methodsFor: 'accessing' stamp: 'btb 3/22/2004 20:01'!
internal: anObject
	internal := anObject.
	internal ifNotNil: [internal binary]! !

!JavaReadStream methodsFor: 'reading' stamp: 'btb 8/24/2004 20:23'!
nextBoolean

	^self nextUnsignedByte ~~ 0! !

!JavaReadStream methodsFor: 'reading' stamp: 'btb 8/24/2004 20:22'!
nextUTFChar
	| firstByte secondByte thirdByte |
	firstByte := self nextUnsignedByte.
	^(firstByte noMask: 128) 
		ifTrue: [JavaUTF8Character value: firstByte]
		ifFalse: 
			[secondByte := self nextUnsignedByte.
			(firstByte bitAnd: 224) = 192 
				ifTrue: 
					["three byte format ((x&0xf)<<12)+(y&0x3f)<<6)+(z&0x3f) "

					thirdByte := self nextUnsignedByte.
					JavaUTF8Character 
						value: ((firstByte bitAnd: 15) << 12) + ((secondByte bitAnd: 63) << 6) 
								+ (thirdByte bitAnd: 63)]
				ifFalse: 
					["two byte format ((x&0x1f)<<6)+(y&0x3f)"

					JavaUTF8Character 
						value: ((firstByte bitAnd: 31) << 6) + (secondByte bitAnd: 63)]]! !

!JavaReadStream methodsFor: 'reading' stamp: 'btb 3/23/2003 12:03'!
nextJavaUTFStringLong
	"http://java.sun.com/products/jdk/1.1/docs/guide/jni/spec/types.doc.html"
	| length |
	length:=self nextUnsignedLong.
	^self nextJavaUTFString: length! !

!JavaReadStream methodsFor: 'reading' stamp: 'btb 3/23/2003 15:25'!
peek

	^self internal peek! !

!JavaReadStream methodsFor: 'reading' stamp: 'btb 8/24/2004 22:26'!
nextSigned: numOfBytes

	^(self internal next: numOfBytes) asJavaSignedValue
	! !

!JavaReadStream methodsFor: 'reading' stamp: 'btb 3/23/2003 12:04'!
nextFloat
	"http://java.sun.com/j2se/1.3/docs/api/java/lang/Float.html"
	| temp |
	temp:=self nextUnsignedInt.
	^Float fromIEEE32Bit: temp! !

!JavaReadStream methodsFor: 'reading' stamp: 'btb 8/24/2004 20:14'!
position

	^self internal position! !

!JavaReadStream methodsFor: 'reading' stamp: 'btb 3/23/2003 12:02'!
nextUnsignedLong

	^self nextUnsigned: 8
	! !

!JavaReadStream methodsFor: 'reading' stamp: 'btb 3/23/2003 12:02'!
nextLong

	^self nextSigned: 8
	! !

Object subclass: #JavaClassDefLoaderConstants
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader'!

!JavaClassDefLoaderConstants commentStamp: 'btb 9/18/2003 19:45' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaClassDefLoaderConstants class methodsFor: 'constants' stamp: 'btb 3/23/2003 20:06'!
accFinal

	^16r0010! !

!JavaClassDefLoaderConstants class methodsFor: 'constants' stamp: 'btb 3/23/2003 20:07'!
accTransient

	^16r0080! !

!JavaClassDefLoaderConstants class methodsFor: 'constants' stamp: 'btb 3/23/2003 20:06'!
accPrivate

	^16r0002! !

!JavaClassDefLoaderConstants class methodsFor: 'constants' stamp: 'btb 3/23/2003 20:08'!
accSynchronized

	^16r0020! !

!JavaClassDefLoaderConstants class methodsFor: 'constants' stamp: 'btb 3/22/2003 16:10'!
magic 

	^16rCAFEBABE! !

!JavaClassDefLoaderConstants class methodsFor: 'constants' stamp: 'btb 3/23/2003 20:06'!
accVolatile

	^16r0040! !

!JavaClassDefLoaderConstants class methodsFor: 'constants' stamp: 'btb 3/23/2003 20:05'!
accPublic

	^16r0001! !

!JavaClassDefLoaderConstants class methodsFor: 'constants' stamp: 'btb 3/23/2003 20:09'!
accStrict

	^16r0800! !

!JavaClassDefLoaderConstants class methodsFor: 'constants' stamp: 'btb 3/23/2003 20:06'!
accProtected

	^16r0004! !

!JavaClassDefLoaderConstants class methodsFor: 'constants' stamp: 'btb 3/23/2003 20:06'!
accStatic

	^16r0008! !

!JavaClassDefLoaderConstants class methodsFor: 'constants' stamp: 'btb 3/23/2003 20:08'!
accAbstract

	^16r0400! !

!JavaClassDefLoaderConstants class methodsFor: 'constants' stamp: 'btb 5/11/2003 19:49'!
accInterface

	^16r0200! !

!JavaClassDefLoaderConstants class methodsFor: 'constants' stamp: 'btb 3/23/2003 20:08'!
accNative

	^16r0100! !

Object subclass: #JavaField
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Core'!

!JavaField commentStamp: 'btb 9/18/2003 19:47' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

Object subclass: #JavaClassCache
	instanceVariableNames: 'entries'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'Java-Serialization-Core'!

!JavaClassCache methodsFor: 'private-accessing' stamp: 'btb 2/28/2004 18:10'!
entries: aDictionary
	entries := aDictionary! !

!JavaClassCache methodsFor: 'public' stamp: 'btb 2/27/2004 19:31'!
addClassDescription: aJavaClassDescription 
	^ (self entryAtType: aJavaClassDescription type)
		classDescription: aJavaClassDescription! !

!JavaClassCache methodsFor: 'private' stamp: 'btb 2/27/2004 19:06'!
addEntry: anEntry 
	^self entries at: anEntry key put: anEntry! !

!JavaClassCache methodsFor: 'public' stamp: 'btb 2/27/2004 19:05'!
classDescriptionForType: aJavaObjectType 
	^ (self entryAtType: aJavaObjectType)
		ifNotNilDo: [:entry | entry classDescription]! !

!JavaClassCache methodsFor: 'private' stamp: 'btb 3/22/2004 20:11'!
initialize
	super initialize.
	self entries: Dictionary new! !

!JavaClassCache class methodsFor: 'as yet unclassified' stamp: 'btb 2/27/2004 19:26'!
default
	"In the future, I would not like this, I can imagine having different caches so that you could read in one version of the java stream and then write it out with a different one, but for now, this will do"
	^ Default
		ifNil: [Default := self new]! !

!JavaClassCache methodsFor: 'private-accessing' stamp: 'btb 2/28/2004 18:08'!
entries
	^entries! !

!JavaClassCache class methodsFor: 'as yet unclassified' stamp: 'btb 2/27/2004 18:57'!
new

	^self basicNew initialize! !

!JavaClassCache class methodsFor: 'as yet unclassified' stamp: 'btb 2/27/2004 19:24'!
reset

	Default := nil! !

!JavaClassCache methodsFor: 'private' stamp: 'btb 2/27/2004 19:14'!
entryAtType: aJavaType 
	^ self entries at: aJavaType asTypeInfoString ifAbsent: [self addType: aJavaType]! !

!JavaClassCache methodsFor: 'public' stamp: 'btb 2/27/2004 19:08'!
addType: aJavaType 
	| newEntry |
	newEntry := JavaClassCacheEntry type: aJavaType.
	^ self addEntry: newEntry! !

Object subclass: #JavaByteCodeInterpreter
	instanceVariableNames: ''
	classVariableNames: 'OpcodeToSelectorDictionary'
	poolDictionaries: ''
	category: 'Java-ClassDefLoader-ByteCode'!

!JavaByteCodeInterpreter class methodsFor: 'generation' stamp: 'btb 8/15/2004 10:20'!
generateOpcodeSelectorStubs

	"Call this code from subclasses and it will generate the opcode stubs needed...Do not call from this class"
	self generateOpcodeSelectorStubsWithBody: '^self shouldBeImplemented'! !

!JavaByteCodeInterpreter class methodsFor: 'private' stamp: 'btb 8/15/2004 11:07'!
initialize
	super initialize.
	self opcodeToSelectorDictionary: self createOpcodeToSelectorDictionary! !

!JavaByteCodeInterpreter methodsFor: 'private' stamp: 'btb 8/16/2004 11:47'!
betweenOperandsExecute! !

!JavaByteCodeInterpreter methodsFor: 'private' stamp: 'btb 8/15/2004 09:32'!
selectorForOpcode: aByte

	^self opcodeToSelectorDictionary at: aByte ifAbsent: [self error: 'Bad opcode: ', aByte]! !

JavaByteCodeInterpreter subclass: #JavaByteCodeDisassembler
	instanceVariableNames: 'printStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader-ByteCode'!

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeIrem: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'irem' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeLload2: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'lload2' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeDsub: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'dsub' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeFconst1: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'fconst1' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeF2i: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'f2i' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-output' stamp: 'btb 8/16/2004 13:50'!
outputPoolInfo: aName on: aStream for: aJavaClassDefLoader

	self outputPoolInfo: aName on: aStream for: aJavaClassDefLoader size: 2
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeFreturn: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'freturn' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeImpdep1: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'impdep1' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeIushr: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'iushr' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeIstore0: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'istore0' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:24'!
executeIfnonnull: aStream for: aJavaClassDefLoader
	self outputJump: 'ifnonnull' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:56'!
executePutfield: aStream for: aJavaClassDefLoader
	self outputPoolInfo: 'putfield' on: aStream for: aJavaClassDefLoader! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeIreturn: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'ireturn' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeLsub: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'lsub' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:56'!
executeNewobject: aStream for: aJavaClassDefLoader
	self outputPoolInfo: 'newobject' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeDupX1: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'dupX1' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeLstore0: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'lstore0' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:54'!
executeInvokevirtual: aStream for: aJavaClassDefLoader
	self outputPoolInfo: 'invokevirtual' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-output' stamp: 'btb 8/16/2004 13:14'!
outputLongJump: aName on: aStream for: aJavaClassDefLoader
	
	self outputJump: aName on: aStream for: aJavaClassDefLoader size: 4! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeIshr: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'ishr' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:35'!
executeIload: aStream for: aJavaClassDefLoader
	self outputArrayIndex: 'iload' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private' stamp: 'btb 8/25/2004 19:05'!
convertAndAddAsIndex: aByteArray current: currentIndex

	^self formatIndex: ((self convertToSignedValue: aByteArray) + currentIndex)! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeAreturn: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'areturn' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeDup2X2: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'dup2X2' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeIconst2: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'iconst2' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeIconstM1: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'iconstM1' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeDstore0: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'dstore0' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeDreturn: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'dreturn' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeDcmpl: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'dcmpl' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeIload0: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'iload0' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/24/2004 20:29'!
executeSipush: aStream for: aJavaClassDefLoader
	| operands |
	self
		outputIndex: aStream position
		opcode: aStream nextUnsignedByte.
	operands := self 
		outputOperands: 2
		from: aStream.
	self printStream
		nextPutAll: ' //sipush ';
		nextPutAll: (self convertToValue: operands) printString
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeIxor: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'ixor' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeIand: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'iand' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeImul: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'imul' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:15'!
executeGotoW: aStream for: aJavaClassDefLoader
	self outputLongJump: 'gotoW' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/25/2004 20:51'!
executeTableswitch: aStream for: aJavaClassDefLoader
	| offset defaultBytes lowBytes highBytes low high operands currentIndex operandsStream |
	currentIndex := aStream position.
	self
		outputIndex: currentIndex
		opcode: aStream next.
	offset := self calculateCorrectingOffset: 4 for: aStream.
	self 
		outputOperands: offset
		from: aStream.
	defaultBytes := self outputOperands: 4 from: aStream.
	lowBytes := self outputOperands: 4 from: aStream.
	highBytes := self outputOperands: 4 from: aStream.
	low := self convertToValue: lowBytes.
	high := self convertToValue: highBytes.
	operands := self outputOperands: ((high - low + 1) * 4) from: aStream.
	self printStream
		nextPutAll: ' //tableswitch';
		cr.
	self printStream
		tab; nextPutAll: 'default: ';
		nextPutAll: (self convertAndAddAsIndex: defaultBytes current: currentIndex);
		cr.
	operandsStream := operands readStream.
	low to: high do: [:index |
		self printStream
			tab; 
			nextPutAll: index printString;
			nextPutAll: ': ';
			nextPutAll: (self convertAndAddAsIndex: (operandsStream next: 4) current: currentIndex).
		operandsStream atEnd ifFalse: [self printStream cr]]
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:34'!
executeIstore: aStream for: aJavaClassDefLoader
	self outputArrayIndex: 'istore' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:54'!
executeLdc2W: aStream for: aJavaClassDefLoader
	self outputPoolInfo: 'ldc2W' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeCastore: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'castore' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeIneg: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'ineg' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeLload0: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'lload0' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private' stamp: 'btb 8/25/2004 19:04'!
convertToSignedValue: aByteArray

	^aByteArray asJavaSignedValue! !

!JavaByteCodeDisassembler methodsFor: 'accessing' stamp: 'btb 8/15/2004 11:12'!
printStream: anObject
	"Set the value of printStream"

	printStream _ anObject! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:58'!
executeIinc: aStream for: aJavaClassDefLoader
	| operands |
	self
		outputIndex: aStream position
		opcode: aStream next.
	operands := self 
		outputOperands: 2
		from: aStream.
	self printStream
		nextPutAll: ' //iinc ';
		nextPutAll: (operands at: 1) printString;
		nextPutAll: ' +';
		nextPutAll: (operands at: 2) printString
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeFastore: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'fastore' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private' stamp: 'btb 8/25/2004 20:50'!
calculateCorrectingOffset: boundaryToCheck for: aStream

	| offset |
	offset := aStream position rem: boundaryToCheck.
	^(offset == 0)
		ifTrue: [0]
		ifFalse: [boundaryToCheck - offset]

	! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeAconstNull: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'aconstNull' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeLcmp: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'lcmp' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeDadd: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'dadd' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeLushr: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'lushr' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-output' stamp: 'btb 8/24/2004 20:28'!
outputOperands: aNumberOfOperands from: aStream

	| operands |
	self printStream space.
	operands := ByteArray new: aNumberOfOperands.
	(1 to: aNumberOfOperands) 
		do: [:index | | next | 
			next := aStream nextUnsignedByte. 
			operands at: index put: next.
			self outputHex: next]
		separatedBy: [self printStream space].
	^operands! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeDload3: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'dload3' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeDrem: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'drem' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:21'!
executeIfIcmpgt: aStream for: aJavaClassDefLoader
	self outputJump: 'ifIcmpgt' on: aStream for: aJavaClassDefLoader! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeD2f: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'd2f' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:59'!
executeWide: aStream for: aJavaClassDefLoader
	| innerOpcode operands operandStream |
	self
		outputIndex: aStream position
		opcode: aStream next.
	innerOpcode := aStream next.
	self printStream space.
	self outputHex: innerOpcode.
	operands := (innerOpcode = JavaByteCodes iinc)
		ifTrue: [self outputOperands: 4 from: aStream]
		ifFalse: [self outputOperands: 2 from: aStream].
	self printStream
		nextPutAll: ' //wide ';
		nextPutAll: (self convertToInstruction: innerOpcode).
	operandStream := operands readStream.
	[operandStream atEnd] whileFalse: 
		[self printStream 
			nextPut: Character space;
			nextPutAll: (self convertToValue: (operandStream next: 2))].
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeLadd: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'ladd' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeAastore: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'aastore' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeFstore3: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'fstore3' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:15'!
executeGoto: aStream for: aJavaClassDefLoader
	self outputJump: 'goto' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeFconst0: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'fconst0' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeLrem: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'lrem' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeFload2: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'fload2' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeIstore3: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'istore3' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeIload2: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'iload2' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler class methodsFor: 'creation' stamp: 'btb 8/15/2004 11:12'!
on: aStream

	^self new printStream: aStream! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeSaload: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'saload' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeLstore3: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'lstore3' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executePop2: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'pop2' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:55'!
executeLdcW: aStream for: aJavaClassDefLoader
	self outputPoolInfo: 'ldcW' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeAstore3: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'astore3' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private' stamp: 'btb 8/15/2004 22:00'!
convertToInstruction: aByteCode

	^JavaByteCodes class selectors detect: [:each | (JavaByteCodes perform: each) = aByteCode] ifNone: [self error: 'Instruction not found for byte code: ', aByteCode printString]! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeFdiv: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'fdiv' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeAload1: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'aload1' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:19'!
executeIfAcmpne: aStream for: aJavaClassDefLoader
	self outputJump: 'ifAcmpne' on: aStream for: aJavaClassDefLoader! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeIconst5: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'iconst5' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:33'!
executeJsrW: aStream for: aJavaClassDefLoader
	self outputLongJump: 'jsrW' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeDstore3: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'dstore3' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeLshr: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'lshr' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-output' stamp: 'btb 8/15/2004 14:18'!
outputHex: anInteger

	self printStream
		nextPutAll: (anInteger printPaddedWith: $0 to: 2 base: 16)! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeDmul: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'dmul' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/25/2004 20:51'!
executeLookupswitch: aStream for: aJavaClassDefLoader
	| offset defaultBytes npairsBytes npairs operands currentIndex operandsStream |
	currentIndex := aStream position.
	self
		outputIndex: currentIndex
		opcode: aStream nextUnsignedByte.
	offset := self calculateCorrectingOffset: 4 for: aStream.
	self 
		outputOperands: offset
		from: aStream.
	defaultBytes := self outputOperands: 4 from: aStream.
	npairsBytes := self outputOperands: 4 from: aStream.
	npairs := self convertToValue: npairsBytes.
	operands := self outputOperands: (npairs * 8) from: aStream.
	self printStream
		nextPutAll: ' //lookupswitch '; 
		nextPutAll: 'pairs=';
		nextPutAll: npairs printString;
		cr.
	self printStream
		tab; nextPutAll: 'default: ';
		nextPutAll: (self convertAndAddAsIndex: defaultBytes current: currentIndex);
		cr.
	operandsStream := operands readStream.
	1 to: npairs do: [:index |
		self printStream
			tab; 
			nextPutAll: (self convertToValue: (operandsStream next: 4)) printString;
			nextPutAll: ': ';
			nextPutAll: (self convertAndAddAsIndex: (operandsStream next: 4) current: currentIndex).
		operandsStream atEnd ifFalse: [self printStream cr]]
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeIconst1: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'iconst1' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:52'!
executeGetstatic: aStream for: aJavaClassDefLoader
	self outputPoolInfo: 'getstatic' on: aStream for: aJavaClassDefLoader! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:23'!
executeIflt: aStream for: aJavaClassDefLoader
	self outputJump: 'iflt' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-output' stamp: 'btb 8/15/2004 21:36'!
outputIndex: anIndex

	self printStream
		nextPutAll: (self formatIndex: anIndex);
		nextPutAll: ': '! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeDload1: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'dload1' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeDneg: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'dneg' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeLand: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'land' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeLconst1: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'lconst1' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeLxor: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'lxor' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeLmul: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'lmul' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeSastore: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'sastore' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-output' stamp: 'btb 8/24/2004 20:29'!
outputJump: aName on: aStream for: aJavaClassDefLoader size: anInteger
	| operands currentIndex |
	currentIndex := aStream position.
	self
		outputIndex: currentIndex
		opcode: aStream nextUnsignedByte.
	operands := self 
		outputOperands: anInteger
		from: aStream.
	self printStream
		nextPutAll: ' //';
		nextPutAll: aName;
		nextPut: Character space;
		nextPutAll: (self convertAndAddAsIndex: operands current: currentIndex) ! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeLreturn: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'lreturn' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:36'!
executeFload: aStream for: aJavaClassDefLoader
	self outputArrayIndex: 'fload' on: aStream for: aJavaClassDefLoader! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeLneg: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'lneg' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeAaload: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'aaload' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeFload0: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'fload0' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeLload3: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'lload3' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeDconst1: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'dconst1' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeFstore1: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'fstore1' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:36'!
executeFstore: aStream for: aJavaClassDefLoader
	self outputArrayIndex: 'fstore' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:55'!
executeLdc: aStream for: aJavaClassDefLoader
	self outputPoolInfo: 'ldc' on: aStream for: aJavaClassDefLoader size: 1! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeDaload: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'daload' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:57'!
executePutstatic: aStream for: aJavaClassDefLoader
	self outputPoolInfo: 'putstatic' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeL2d: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'l2d' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeD2l: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'd2l' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeNop: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'nop' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-output' stamp: 'btb 8/16/2004 13:28'!
outputArrayIndex: aName on: aStream for: aJavaClassDefLoader
	| operands |
	self
		outputIndex: aStream position
		opcode: aStream next.
	operands := self 
		outputOperands: 1 
		from: aStream.
	self printStream
		nextPutAll: ' //';
		nextPutAll: aName;
		nextPut: Character space;
		nextPutAll: operands first printString! !

!JavaByteCodeDisassembler methodsFor: 'accessing' stamp: 'btb 8/15/2004 11:12'!
printStream
	"Answer the value of printStream"

	^ printStream! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:37'!
executeDload: aStream for: aJavaClassDefLoader
	self outputArrayIndex: 'dload' on: aStream for: aJavaClassDefLoader! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeFstore2: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'fstore2' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:31'!
executeRet: aStream for: aJavaClassDefLoader
	self outputArrayIndex: 'ret' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeAload3: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'aload3' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeFsub: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'fsub' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeFcmpg: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'fcmpg' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeIstore2: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'istore2' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeIastore: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'iastore' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeDupX2: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'dupX2' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private' stamp: 'btb 8/25/2004 19:04'!
convertToValue: aByteArray

	^aByteArray asJavaUnsignedValue! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:22'!
executeIfeq: aStream for: aJavaClassDefLoader
	self outputJump: 'ifeq' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeIload1: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'iload1' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:17'!
executeIfAcmpeq: aStream for: aJavaClassDefLoader
	self outputJump: 'ifAcmpeq' on: aStream for: aJavaClassDefLoader! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:37'!
executeBipush: aStream for: aJavaClassDefLoader
	self outputArrayIndex: 'bipush' on: aStream for: aJavaClassDefLoader! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeLastore: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'lastore' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeLstore2: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'lstore2' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeI2b: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'i2b' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler class methodsFor: 'generation' stamp: 'btb 8/16/2004 12:27'!
generateOpcodeSelectorStubs

	"JavaByteCodeDisassembler generateOpcodeSelectorStubs"
	| methodStream |
	methodStream := String new writeStream.
	methodStream
		nextPutAll: 'self outputNoOperands: ''{1}'' on: aStream for: aJavaClassDefLoader'.
	self generateOpcodeSelectorStubsWithBody: methodStream contents! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeAstore2: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'astore2' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeLload1: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'lload1' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private' stamp: 'btb 8/15/2004 21:36'!
convertToIndex: aByteArray

	^self formatIndex: (self convertToValue: aByteArray)! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeIdiv: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'idiv' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-output' stamp: 'btb 8/15/2004 14:19'!
outputIndex: anIndex opcode: anOpcode

	self 
		outputIndex: anIndex;
		outputHex: anOpcode! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeIconst4: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'iconst4' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:51'!
executeCheckcast: aStream for: aJavaClassDefLoader
	self outputPoolInfo: 'checkcast' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeDastore: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'dastore' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeDstore2: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'dstore2' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeIconst0: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'iconst0' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:23'!
executeIfle: aStream for: aJavaClassDefLoader
	self outputJump: 'ifle' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeIaload: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'iaload' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:37'!
executeDstore: aStream for: aJavaClassDefLoader
	self outputArrayIndex: 'dstore' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeLconst0: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'lconst0' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeL2i: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'l2i' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:51'!
executeAnewarray: aStream for: aJavaClassDefLoader
	self outputPoolInfo: 'anewarray' on: aStream for: aJavaClassDefLoader! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeMonitorexit: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'monitorexit' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeBaload: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'baload' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeArraylength: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'arraylength' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeLaload: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'laload' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private' stamp: 'btb 8/16/2004 18:50'!
formatIndex: anIndex

	"^anIndex printPaddedWith: $0 to: 4 base: 16"
	^anIndex printPaddedWith: Character space to: 4 base: 10! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 19:05'!
executeInvokeinterface: aStream for: aJavaClassDefLoader
	| operands index poolInfo |
	self
		outputIndex: aStream position
		opcode: aStream next.
	operands := self 
		outputOperands: 4
		from: aStream.
	index := self convertToValue: (operands copyFrom: 1 to: 2).
	poolInfo := aJavaClassDefLoader constantPoolInfoAt: index.
	self printStream
		nextPutAll: ' //invokeinterface '.
	poolInfo disassembleOn: self printStream
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeIshl: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'ishl' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeDup2X1: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'dup2X1' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeDconst0: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'dconst0' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeD2i: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'd2i' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeFstore0: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'fstore0' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeFload3: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'fload3' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeDup: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'dup' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:24'!
executeIfnull: aStream for: aJavaClassDefLoader
	self outputJump: 'ifnull' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeBastore: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'bastore' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:23'!
executeIfgt: aStream for: aJavaClassDefLoader
	self outputJump: 'ifgt' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-output' stamp: 'btb 8/24/2004 20:27'!
outputPoolInfo: aName on: aStream for: aJavaClassDefLoader size: aSize

	| operands index poolInfo |
	self
		outputIndex: aStream position
		opcode: aStream nextUnsignedByte.
	operands := self 
		outputOperands: aSize
		from: aStream.
	index := self convertToValue: operands.
	poolInfo := aJavaClassDefLoader constantPoolInfoAt: index.
	self printStream
		nextPutAll: ' //';
		nextPutAll: aName;
		nextPut: Character space.
	poolInfo disassembleOn: self printStream
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:22'!
executeIfIcmpne: aStream for: aJavaClassDefLoader
	self outputJump: 'ifIcmpne' on: aStream for: aJavaClassDefLoader! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeFadd: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'fadd' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeI2f: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'i2f' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeIload3: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'iload3' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-output' stamp: 'btb 8/16/2004 13:14'!
outputJump: aName on: aStream for: aJavaClassDefLoader
	
	self outputJump: aName on: aStream for: aJavaClassDefLoader size: 2! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:53'!
executeInvokespecial: aStream for: aJavaClassDefLoader
	self outputPoolInfo: 'invokespecial' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeFrem: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'frem' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeIor: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'ior' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeFconst2: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'fconst2' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeDcmpg: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'dcmpg' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeAstore0: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'astore0' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeAload2: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'aload2' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:23'!
executeIfne: aStream for: aJavaClassDefLoader
	self outputJump: 'ifne' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeIsub: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'isub' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeSwap: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'swap' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeF2l: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'f2l' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:53'!
executeInvokestatic: aStream for: aJavaClassDefLoader
	self outputPoolInfo: 'invokestatic' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeIstore1: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'istore1' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeImpdep2: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'impdep2' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeDload2: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'dload2' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executePop: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'pop' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeLstore1: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'lstore1' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 19:05'!
executeMultianewarray: aStream for: aJavaClassDefLoader
	| operands index poolInfo |
	self
		outputIndex: aStream position
		opcode: aStream next.
	operands := self 
		outputOperands: 3
		from: aStream.
	index := self convertToValue: (operands copyFrom: 1 to: 2).
	poolInfo := aJavaClassDefLoader constantPoolInfoAt: index.
	self printStream
		nextPutAll: ' //multianewarray '.
	poolInfo disassembleOn: self printStream.
	self printStream
		nextPutAll: ' dim: ';
		nextPutAll: (operands at: 3) printString
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeDdiv: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'ddiv' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeF2d: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'f2d' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeAstore1: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'astore1' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:52'!
executeInstanceof: aStream for: aJavaClassDefLoader
	self outputPoolInfo: 'instanceof' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeFload1: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'fload1' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:32'!
executeLstore: aStream for: aJavaClassDefLoader
	self outputArrayIndex: 'lstore' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:38'!
executeAstore: aStream for: aJavaClassDefLoader
	self outputArrayIndex: 'astore' on: aStream for: aJavaClassDefLoader! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeIconst3: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'iconst3' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeI2s: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'i2s' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:33'!
executeJsr: aStream for: aJavaClassDefLoader
	self outputJump: 'jsr' on: aStream for: aJavaClassDefLoader! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeLdiv: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'ldiv' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeDstore1: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'dstore1' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeL2f: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'l2f' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-output' stamp: 'btb 8/16/2004 11:48'!
betweenOperandsExecute

	self printStream cr! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeFmul: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'fmul' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeReturn: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'return' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:52'!
executeGetfield: aStream for: aJavaClassDefLoader
	self outputPoolInfo: 'getfield' on: aStream for: aJavaClassDefLoader! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeLor: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'lor' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:21'!
executeIfIcmpge: aStream for: aJavaClassDefLoader
	self outputJump: 'ifIcmpge' on: aStream for: aJavaClassDefLoader! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeFneg: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'fneg' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeCaload: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'caload' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeFcmpl: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'fcmpl' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeDup2: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'dup2' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeAload0: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'aload0' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeFaload: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'faload' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:32'!
executeLload: aStream for: aJavaClassDefLoader
	self outputArrayIndex: 'lload' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeI2l: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'i2l' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeAthrow: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'athrow' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeI2c: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'i2c' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/24/2004 20:29'!
executeNewarray: aStream for: aJavaClassDefLoader
	| operands type |
	self
		outputIndex: aStream position
		opcode: aStream nextUnsignedByte.
	operands := self 
		outputOperands: 1
		from: aStream.
	type := operands first.
	self printStream
		nextPutAll: ' //newarray '.
	(type == 4)
		ifTrue: [self printStream nextPutAll: 'boolean'].
	(type == 5)
		ifTrue: [self printStream nextPutAll: 'char'].
	(type == 6)
		ifTrue: [self printStream nextPutAll: 'float'].
	(type == 7)
		ifTrue: [self printStream nextPutAll: 'double'].
	(type == 8)
		ifTrue: [self printStream nextPutAll: 'byte'].
	(type == 9)
		ifTrue: [self printStream nextPutAll: 'short'].
	(type == 10)
		ifTrue: [self printStream nextPutAll: 'int'].
	(type == 11)
		ifTrue: [self printStream nextPutAll: 'long']
! !

!JavaByteCodeDisassembler methodsFor: 'private-output' stamp: 'btb 8/24/2004 20:28'!
outputNoOperands: aName on: aStream for: aJavaClassDefLoader
	self
		outputIndex: aStream position
		opcode: aStream nextUnsignedByte.
	self printStream
		nextPutAll: ' //';
		nextPutAll: aName! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:20'!
executeIfIcmpeq: aStream for: aJavaClassDefLoader
	self outputJump: 'ifIcmpeq' on: aStream for: aJavaClassDefLoader! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:21'!
executeIfIcmple: aStream for: aJavaClassDefLoader
	self outputJump: 'ifIcmple' on: aStream for: aJavaClassDefLoader! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:23'!
executeIfge: aStream for: aJavaClassDefLoader
	self outputJump: 'ifge' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeDload0: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'dload0' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeBreak: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'break' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeLshl: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'lshl' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:21'!
executeIfIcmplt: aStream for: aJavaClassDefLoader
	self outputJump: 'ifIcmplt' on: aStream for: aJavaClassDefLoader! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeI2d: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'i2d' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 13:29'!
executeAload: aStream for: aJavaClassDefLoader
	self outputArrayIndex: 'aload' on: aStream for: aJavaClassDefLoader! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:29'!
executeIadd: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'iadd' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeDisassembler methodsFor: 'private-execution' stamp: 'btb 8/16/2004 12:30'!
executeMonitorenter: aStream for: aJavaClassDefLoader
	self outputNoOperands: 'monitorenter' on: aStream for: aJavaClassDefLoader
! !

!JavaByteCodeInterpreter methodsFor: 'public' stamp: 'btb 8/16/2004 14:29'!
execute: aStream for: aClassDefLoader

	
	[aStream atEnd] 
		whileFalse: [| nextOpcode |
					nextOpcode := aStream peek.
					self perform: (self selectorForOpcode: nextOpcode) with: aStream with: aClassDefLoader.
					aStream atEnd ifFalse: [self betweenOperandsExecute]]! !

!JavaByteCodeInterpreter methodsFor: 'private' stamp: 'btb 8/15/2004 11:02'!
opcodeToSelectorDictionary

	^self class opcodeToSelectorDictionary! !

!JavaByteCodeInterpreter class methodsFor: 'generation' stamp: 'btb 8/15/2004 13:47'!
generateOpcodeSelectorStubsWithBody: aMethodBody

	"Call this code from subclasses and it will generate the opcode stubs needed...Do not call from this class"
	(self == JavaByteCodeInterpreter)
		ifTrue: [self error: 'Do not call this method from this class. Only in subclasses'].
	
	JavaByteCodes class selectors do: [:each | | methodStream newMethodSelector |
		methodStream := String new writeStream.
		methodStream 
			nextPutAll: 'execute';
			nextPutAll: each capitalized;
			nextPutAll: ': aStream for: aJavaClassDefLoader';
			cr;
			nextPutAll: (self formatMethodBody: (aMethodBody format: (Array with: each))).
		newMethodSelector:=self
			compile: methodStream contents
			classified: 'auto-generated'.
		"self reformatMethodAt:  newMethodSelector"]! !

!JavaByteCodeInterpreter class methodsFor: 'private' stamp: 'btb 8/15/2004 11:01'!
opcodeToSelectorDictionary: anObject
	"Set the value of opcodeToSelectorDictionary"

	OpcodeToSelectorDictionary _ anObject! !

!JavaByteCodeInterpreter class methodsFor: 'private' stamp: 'btb 8/15/2004 11:02'!
opcodeToSelectorDictionary

	^OpcodeToSelectorDictionary! !

!JavaByteCodeInterpreter class methodsFor: 'generation' stamp: 'btb 8/15/2004 12:00'!
formatMethodBody: aString

	| result readStream |
	result := String new writeStream.
	readStream := aString readStream.
	[readStream atEnd] whileFalse: 
		[result 
			tab; 
			nextPutAll: readStream nextLine;
			cr].
	^result contents! !

!JavaByteCodeInterpreter class methodsFor: 'private' stamp: 'btb 8/16/2004 11:44'!
createOpcodeToSelectorDictionary

	| result |
	result := IdentityDictionary new.
	JavaByteCodes class selectors do: [:each |
		result 
			at: (JavaByteCodes perform: each) 
			put: ('execute', (each capitalized), ':for:') asSymbol].
	^result! !

Object subclass: #JavaClassCacheEntry
	instanceVariableNames: 'type classDescription'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Serialization-Core'!

!JavaClassCacheEntry methodsFor: 'accessing' stamp: 'btb 2/27/2004 18:55'!
type: anObject
	type := anObject! !

!JavaClassCacheEntry class methodsFor: 'as yet unclassified' stamp: 'btb 2/27/2004 18:59'!
type: aJavaType classDescription: aJavaClassDescription 
	^( self type: aJavaType)
		 classDescription: aJavaClassDescription! !

!JavaClassCacheEntry methodsFor: 'public' stamp: 'btb 2/27/2004 19:00'!
key

	^self type asTypeInfoString! !

!JavaClassCacheEntry methodsFor: 'accessing' stamp: 'btb 2/27/2004 18:55'!
type
	^type! !

!JavaClassCacheEntry class methodsFor: 'as yet unclassified' stamp: 'btb 2/27/2004 18:59'!
type: aJavaType 
	^ self new type: aJavaType! !

!JavaClassCacheEntry methodsFor: 'accessing' stamp: 'btb 2/27/2004 18:56'!
classDescription: anObject
	classDescription := anObject! !

!JavaClassCacheEntry methodsFor: 'accessing' stamp: 'btb 2/27/2004 18:56'!
classDescription
	^classDescription! !

Object subclass: #JavaCodeExceptionInfo
	instanceVariableNames: 'startPC endPC handlerPC catchType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader-Attributes'!

!JavaCodeExceptionInfo commentStamp: 'btb 9/18/2003 19:45' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaCodeExceptionInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 17:07'!
startPC
	^startPC! !

!JavaCodeExceptionInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 17:08'!
endPC: anObject
	endPC := anObject! !

!JavaCodeExceptionInfo methodsFor: 'reading' stamp: 'btb 8/16/2004 10:48'!
readFromClassDefLoader: aClassDefLoader

	self 
		startPC: (aClassDefLoader nextUnsignedShort);
		endPC: (aClassDefLoader nextUnsignedShort);
		handlerPC: (aClassDefLoader nextUnsignedShort);
		catchType: (aClassDefLoader nextUnsignedShort)	! !

!JavaCodeExceptionInfo class methodsFor: 'as yet unclassified' stamp: 'btb 8/16/2004 10:47'!
readFromClassDefLoader: aClassDefLoader

	^self new readFromClassDefLoader: aClassDefLoader! !

!JavaCodeExceptionInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 17:08'!
catchType: anObject
	catchType := anObject! !

!JavaCodeExceptionInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 17:08'!
endPC
	^endPC! !

!JavaCodeExceptionInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 17:07'!
startPC: anObject
	startPC := anObject! !

!JavaCodeExceptionInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 17:08'!
catchType
	^catchType! !

!JavaCodeExceptionInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 17:08'!
handlerPC
	^handlerPC! !

!JavaCodeExceptionInfo methodsFor: 'accessing' stamp: 'btb 5/11/2003 17:08'!
handlerPC: anObject
	handlerPC := anObject! !

Object subclass: #JavaSerClassDescriptionFlags
	instanceVariableNames: 'isWriteMethod isBlockData isExternalizable isSerializable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Serialization-Core'!

!JavaSerClassDescriptionFlags commentStamp: '<historical>' prior: 0!
I am place holder for description flags in the java serialization protocol to describe how a class should load istself in (or write itself out for that matter). The waters get very murky when you start talking about isSerializable and isExternalizable java objects. The java serialization specs are horribly written and they also assume that the java serialization stream will be read and written out by a java program (which isn't a bad assumption on their part, but bad for us) Anyway, this causes a lot of weird things to happen on the stream, I plan on adding a java byte code interpreter in the future to get around this issue.

Copyright (c) 2002 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 5/6/2002 12:17!

!JavaSerClassDescriptionFlags methodsFor: 'private' stamp: 'btb 4/17/2002 21:22'!
isSerializable: aBoolean

	isSerializable:=aBoolean! !

!JavaSerClassDescriptionFlags methodsFor: 'private' stamp: 'btb 4/17/2002 21:21'!
isExternalizable: aBoolean

	isExternalizable:=aBoolean! !

!JavaSerClassDescriptionFlags methodsFor: 'private' stamp: 'btb 10/27/2003 19:47'!
initializeWith: aByte

	self isWriteMethod: (aByte anyMask: (JavaSerConstants scWriteMethod)).
	self isBlockData: (aByte anyMask: (JavaSerConstants scBlockData)).
	self isSerializable: (aByte anyMask: (JavaSerConstants scSerializable)).
	self isExternalizable: (aByte anyMask: (JavaSerConstants scExternalizable)).! !

!JavaSerClassDescriptionFlags methodsFor: 'private' stamp: 'btb 2/17/2004 19:11'!
writeToJavaStream: aJavaWriteStream

	aJavaWriteStream nextPutByte: self flagValue! !

!JavaSerClassDescriptionFlags methodsFor: 'accessors' stamp: 'btb 4/17/2002 21:19'!
isBlockData

	^isBlockData! !

!JavaSerClassDescriptionFlags methodsFor: 'accessors' stamp: 'btb 4/17/2002 21:18'!
isWriteMethod
	^isWriteMethod! !

!JavaSerClassDescriptionFlags methodsFor: 'accessors' stamp: 'btb 4/17/2002 21:19'!
isSerializable

	^isSerializable! !

!JavaSerClassDescriptionFlags methodsFor: 'private' stamp: 'btb 4/17/2002 21:21'!
isWriteMethod: aBoolean

	isWriteMethod:=aBoolean! !

!JavaSerClassDescriptionFlags methodsFor: 'private' stamp: 'btb 4/17/2002 21:21'!
isBlockData: aBoolean

	isBlockData:=aBoolean! !

!JavaSerClassDescriptionFlags methodsFor: 'private' stamp: 'btb 2/28/2004 21:59'!
flagValue

	| result |
	result := 0.
	self isWriteMethod ifTrue: [result:=result bitOr: JavaSerConstants scWriteMethod].
	self isBlockData ifTrue: [result:=result bitOr: JavaSerConstants scBlockData].
	self isSerializable ifTrue: [result:=result bitOr: JavaSerConstants scSerializable].
	self isExternalizable ifTrue: [result:=result bitOr: JavaSerConstants scExternalizable].
	^result! !

!JavaSerClassDescriptionFlags methodsFor: 'accessors' stamp: 'btb 4/17/2002 21:19'!
isExternalizable

	^isExternalizable! !

!JavaSerClassDescriptionFlags class methodsFor: 'creation' stamp: 'btb 4/17/2002 21:20'!
newWith: aByte

	^self new initializeWith: aByte! !

Object subclass: #JavaSerObjectCache
	instanceVariableNames: 'currentHandle objectsByHandle references handlesByObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Serialization-Core'!

!JavaSerObjectCache commentStamp: 'btb 9/18/2003 19:44' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaSerObjectCache methodsFor: 'private' stamp: 'btb 7/28/2002 11:05'!
referenceAt: handle 

	^self references at: handle ifAbsent: [].! !

!JavaSerObjectCache methodsFor: 'public' stamp: 'btb 2/16/2004 21:11'!
handleAt: anObject ifPresent: aOneArgBlock ifAbsent: aBlock

	| value |
	value:=self handlesByObject at: anObject ifAbsent: [^aBlock value].
	^aOneArgBlock value: value! !

!JavaSerObjectCache methodsFor: 'private' stamp: 'btb 7/28/2002 11:08'!
removeReferenceAt: handle 

	self references removeKey: handle ifAbsent: [].! !

!JavaSerObjectCache methodsFor: 'public' stamp: 'btb 7/28/2002 21:14'!
atHandle: handle put: aJavaObject

	self objectsByHandle at: handle put: aJavaObject.
	self handlesByObject at: aJavaObject put: handle.
	self resolveReferencesToHandle: handle to: aJavaObject.! !

!JavaSerObjectCache methodsFor: 'as yet unclassified' stamp: 'btb 3/22/2004 20:11'!
initialize
	super initialize.
	self reset! !

!JavaSerObjectCache methodsFor: 'private' stamp: 'btb 10/27/2003 19:51'!
newReferenceAt: handle 
	| temp |
	temp := JavaSerUnknownReference new.
	temp handle: handle.
	self references at: handle put: temp.
	^temp! !

!JavaSerObjectCache methodsFor: 'as yet unclassified' stamp: 'btb 7/28/2002 08:31'!
references: anObject
	references:=anObject! !

!JavaSerObjectCache methodsFor: 'as yet unclassified' stamp: 'btb 7/28/2002 21:13'!
handlesByObject: anObject

	handlesByObject:=anObject! !

!JavaSerObjectCache methodsFor: 'public' stamp: 'btb 7/28/2002 10:55'!
newHandle

	"return the next handle"
	|newHandle|
	newHandle:=self currentHandle.
	self currentHandle: (currentHandle+1).
	^newHandle! !

!JavaSerObjectCache methodsFor: 'as yet unclassified' stamp: 'btb 7/28/2002 08:31'!
references
	^references! !

!JavaSerObjectCache class methodsFor: 'as yet unclassified' stamp: 'btb 7/28/2002 10:53'!
new

	^super new initialize! !

!JavaSerObjectCache methodsFor: 'public' stamp: 'btb 7/28/2002 11:04'!
atHandle: handle

	^self objectsByHandle at: handle ifAbsent: [self referenceAtOrNew: handle]! !

!JavaSerObjectCache methodsFor: 'private' stamp: 'btb 7/28/2002 11:06'!
referenceAtOrNew: handle 

	^self referenceAt: handle ifAbsent: [self newReferenceAt: handle].! !

!JavaSerObjectCache methodsFor: 'as yet unclassified' stamp: 'btb 7/28/2002 08:31'!
currentHandle: anObject
	currentHandle:=anObject! !

!JavaSerObjectCache methodsFor: 'as yet unclassified' stamp: 'btb 7/28/2002 08:31'!
currentHandle
	^currentHandle! !

!JavaSerObjectCache methodsFor: 'as yet unclassified' stamp: 'btb 7/28/2002 21:12'!
handlesByObject

	^handlesByObject! !

!JavaSerObjectCache methodsFor: 'as yet unclassified' stamp: 'btb 7/28/2002 10:57'!
objectsByHandle: anObject
	objectsByHandle:=anObject! !

!JavaSerObjectCache methodsFor: 'private' stamp: 'btb 7/28/2002 11:06'!
referenceAt: handle ifAbsent: block

	^self references at: handle ifAbsent: block.! !

!JavaSerObjectCache methodsFor: 'public' stamp: 'btb 10/27/2003 19:47'!
reset

	self objectsByHandle: IdentityDictionary new.
	self handlesByObject: IdentityDictionary new.
	self references: IdentityDictionary new.
	self currentHandle: JavaSerConstants baseWireHandle.! !

!JavaSerObjectCache methodsFor: 'private' stamp: 'btb 7/28/2002 11:07'!
resolveReferencesToHandle: handle to: cacheObject

	| reference |
	reference:=self referenceAt: handle ifAbsent: [].
	reference ifNotNil: [reference becomeForward: cacheObject].
	self removeReferenceAt: handle.! !

!JavaSerObjectCache methodsFor: 'as yet unclassified' stamp: 'btb 7/28/2002 10:57'!
objectsByHandle
	^objectsByHandle! !

Object subclass: #JavaMethod
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Core'!

!JavaMethod commentStamp: 'btb 9/18/2003 19:47' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

ArrayedCollection variableSubclass: #JavaUTF8String
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Core'!

!JavaUTF8String commentStamp: 'btb 9/18/2003 19:47' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

!JavaUTF8String class methodsFor: 'as yet unclassified' stamp: 'btb 2/27/2004 21:19'!
onString: aString

	| answer |
	answer:=self new: aString size.
	1 to: aString size do: [:i |
		answer at: i put: (aString at: i) asJavaUTF8Character].
	^answer! !

!JavaUTF8String methodsFor: 'converting' stamp: 'btb 5/16/2002 21:53'!
asString

	^self asAsciiString! !

!JavaUTF8String methodsFor: 'as yet unclassified' stamp: 'btb 3/22/2004 20:15'!
printOn: aStream 
	aStream nextPutAll: 'UTF8-'''.
	self do: 
			[:eachChar | 
			aStream nextPut: eachChar asAsciiCharacter.
			eachChar == $' ifTrue: [aStream nextPut: eachChar]].
	aStream nextPut: $'! !

!JavaUTF8String methodsFor: 'as yet unclassified' stamp: 'btb 2/28/2004 21:35'!
writeToJavaStream: aJavaWriteStream

	aJavaWriteStream writeString: self! !

!JavaUTF8String methodsFor: 'converting' stamp: 'btb 5/16/2002 21:58'!
asSymbol

	^self asString asSymbol! !

!JavaUTF8String methodsFor: 'converting' stamp: 'btb 10/27/2003 20:02'!
asJavaUTF8String

	^self! !

!JavaUTF8String methodsFor: 'converting' stamp: 'btb 5/16/2002 22:00'!
asAsciiString

	| answer |
	answer:=String new: self size.
	1 to: self size do: [:i |
		answer at: i put: (self at: i) asAsciiCharacter].
	^answer! !

!String methodsFor: '*Java' stamp: 'btb 10/27/2003 19:40'!
asJavaUTF8String
	^JavaUTF8String onString: self! !

Error subclass: #JavaClassDefLoaderFileFormatError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader'!

!JavaClassDefLoaderFileFormatError commentStamp: 'btb 9/18/2003 19:45' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

Error subclass: #JavaConstantPoolError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader-ConstantPool'!

!JavaConstantPoolError commentStamp: 'btb 9/18/2003 19:46' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

Error subclass: #JavaAttributeInfoError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader-Attributes'!

!JavaAttributeInfoError commentStamp: 'btb 9/18/2003 19:45' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

Error subclass: #JavaTypeError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Core-Type'!

!JavaTypeError commentStamp: 'btb 9/18/2003 19:48' prior: 0!
Copyright (c) 2003 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 9/18/2003 19:43!

Inspector subclass: #JavaSerObjectInspector
	instanceVariableNames: 'variableNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Serialization-Inspector'!

!JavaSerObjectInspector commentStamp: '<historical>' prior: 0!
A quick and dirty inspector to see innards of a java object in a intelligent way.
I whipped this together pretty quickly....I love SMALLTALK!!

Copyright (c) 2002 Blaine Buxton

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

btb 5/6/2002 12:25!

!JavaSerObjectInspector methodsFor: 'overridden' stamp: 'btb 10/27/2003 21:10'!
replaceSelectionValue: anObject

	^self object inspectorReplaceSelection: selectionIndex value: anObject! !

!JavaSerObjectInspector methodsFor: 'overridden' stamp: 'btb 4/30/2002 21:48'!
fieldList

	^variableNames! !

!JavaSerObjectInspector methodsFor: 'overridden' stamp: 'btb 10/27/2003 20:59'!
calculateVariableNames

	variableNames := self object inspectorVariableNames.
	selectionIndex:=0.! !

!JavaSerObjectInspector methodsFor: 'overridden' stamp: 'btb 10/27/2003 20:47'!
inspect: aJavaSerAbstractObject

	self initialize.
	object _ aJavaSerAbstractObject.
	contents _ ''.
	self calculateVariableNames.! !

!JavaSerObjectInspector methodsFor: 'overridden' stamp: 'btb 10/27/2003 21:03'!
selection

	selectionIndex = 0 ifTrue: [^ ''].
	^ self object inspectorSelection: selectionIndex! !

!JavaSerObjectInspector methodsFor: 'overridden' stamp: 'btb 4/30/2002 22:09'!
selectionUnmodifiable
	"For dicionary inspectors, any selection is modifiable"

	^ selectionIndex <= 1! !

!JavaSerObjectInspector methodsFor: 'overridden' stamp: 'btb 4/30/2002 21:53'!
contentsIsString
	"Hacked so contents empty when deselected"

	^ (selectionIndex = 0)! !

TestCase subclass: #JavaClassDefLoaderTestCase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-ClassDefLoader-Tests'!

!JavaClassDefLoaderTestCase methodsFor: 'data' stamp: 'btb 8/16/2004 19:19'!
zippedZipInputStreamClassBytes
	^#(31 139 8 0 0 0 0 0 0 0 149 88 11 124 147 229 185 255 191 77 210 164 233 215 146 150 6 105 147 72 192 57 75 74 65 185 116 8 194 164 165 104 107 165 28 40 30 10 122 36 109 191 182 145 244 75 204 133 211 178 13 113 3 111 103 115 151 195 230 16 229 50 116 117 19 207 220 145 166 104 145 178 171 187 123 118 220 93 183 185 185 185 171 219 220 125 238 204 158 255 243 125 73 154 182 140 253 214 254 242 188 151 231 121 159 219 251 188 207 243 36 95 120 253 169 179 0 46 87 190 18 68 112 196 137 163 46 28 115 163 8 199 157 248 144 27 14 156 112 226 33 55 156 120 216 141 91 240 97 39 134 221 112 227 17 33 254 136 128 143 10 120 84 192 73 1 143 57 241 95 46 124 204 141 10 28 119 115 253 184 108 126 92 102 255 45 231 158 144 229 41 97 247 132 236 141 148 224 26 100 4 140 10 226 180 236 61 233 196 83 110 204 195 35 34 239 73 217 25 147 147 103 132 224 105 55 206 10 193 184 11 231 220 120 163 232 248 9 23 62 233 198 66 153 126 202 133 79 187 177 8 199 29 52 8 183 77 76 76 184 241 25 124 86 248 60 35 124 62 231 196 231 101 252 130 137 183 219 174 219 36 171 47 186 240 37 25 191 44 224 43 162 203 179 2 254 199 133 175 202 248 191 46 60 39 227 215 4 124 93 192 55 68 198 35 78 124 211 141 102 124 203 137 111 187 185 121 60 111 216 119 76 69 5 60 47 224 5 241 225 119 77 137 46 231 117 155 92 248 94 158 242 251 78 188 232 70 7 30 113 225 7 50 254 80 192 75 46 252 40 75 209 129 31 187 240 178 140 63 201 159 249 169 11 63 203 46 220 248 185 11 191 112 227 151 120 197 133 95 185 240 235 172 135 150 139 114 191 113 226 85 39 126 171 224 208 141 84 98 72 97 110 219 45 225 221 225 37 233 84 36 186 100 79 36 190 100 123 36 222 44 152 213 10 182 238 68 183 130 119 26 65 211 230 166 101 75 137 45 73 232 3 225 136 17 49 250 20 84 171 66 113 106 32 222 149 238 85 40 218 209 200 213 150 142 246 205 205 235 137 106 81 40 107 138 25 201 84 216 72 221 16 142 166 117 155 216 172 224 90 223 188 161 109 93 71 243 122 89 187 120 162 59 26 75 234 61 60 177 157 72 83 187 230 246 13 92 118 41 184 117 35 153 78 232 237 113 221 160 90 181 11 111 80 176 55 197 122 116 133 89 109 17 67 223 152 30 232 210 19 29 225 174 40 119 220 205 131 221 122 60 21 161 72 50 189 138 26 166 214 210 204 90 203 140 72 108 73 139 17 79 167 182 164 18 122 120 96 181 112 210 250 244 212 70 125 48 213 108 57 164 166 118 225 223 119 137 219 84 50 75 89 66 170 72 212 146 74 165 104 168 157 76 105 129 179 118 71 99 75 139 185 145 220 21 137 115 168 109 93 72 23 57 204 211 196 11 89 91 123 19 61 67 217 91 59 54 172 164 58 166 35 231 90 39 45 5 162 97 163 111 137 133 161 232 242 110 158 74 233 57 101 20 22 213 206 36 187 128 234 166 208 102 131 234 249 106 255 30 149 184 163 68 232 54 164 163 209 161 188 33 220 117 80 209 43 26 232 80 217 17 203 100 99 217 210 220 6 141 115 111 137 165 19 221 250 134 136 184 99 54 89 22 248 121 177 200 211 176 7 111 33 42 127 15 237 249 155 162 35 44 194 160 21 4 26 222 129 223 81 209 28 233 166 116 178 191 43 220 189 171 128 165 144 252 94 97 206 84 75 90 140 222 40 157 148 16 236 31 4 252 49 39 112 106 252 10 234 54 13 6 98 26 18 72 106 120 43 222 162 225 109 50 251 147 40 121 241 164 103 55 210 21 155 98 17 131 92 11 244 117 71 140 96 36 25 52 136 212 176 87 120 69 65 157 238 148 217 159 5 252 5 175 105 120 55 238 208 240 87 164 53 252 31 110 213 16 23 112 15 254 67 225 146 73 254 45 70 143 62 216 158 78 181 247 54 198 210 70 79 50 47 68 195 65 188 95 195 223 112 159 134 215 49 225 228 83 64 205 204 139 155 212 169 60 109 232 131 113 189 59 165 247 4 205 167 115 81 161 20 234 111 132 163 205 137 68 44 65 62 17 99 119 56 26 233 9 118 199 6 226 9 61 153 36 131 224 128 158 234 143 49 62 22 20 28 139 70 245 190 112 116 93 162 47 61 192 39 89 32 172 202 32 34 21 217 173 7 37 196 131 81 221 232 75 245 59 149 210 84 145 178 105 184 87 124 240 1 220 71 194 220 37 82 165 2 219 238 199 97 13 31 196 33 133 202 129 8 229 27 125 65 243 205 7 141 240 128 174 225 61 120 175 134 247 225 63 53 101 167 251 148 3 105 133 249 186 209 157 24 138 139 121 219 91 54 229 200 99 169 96 50 29 143 199 18 220 215 84 49 110 85 168 143 25 209 161 96 46 191 152 132 17 61 25 236 14 27 193 254 48 53 110 222 214 17 236 209 147 221 137 72 60 21 75 72 24 220 170 41 167 0 23 152 52 60 211 159 21 163 69 149 204 136 181 220 171 209 148 27 119 107 170 148 193 163 52 81 182 76 204 14 230 60 60 85 88 48 25 233 51 194 41 38 51 77 149 227 238 28 211 2 97 141 233 222 94 157 87 20 200 49 176 236 76 70 246 232 193 218 252 253 106 106 150 242 8 168 224 139 13 118 165 83 193 62 58 66 54 42 249 108 131 93 67 41 61 185 80 83 179 85 149 166 188 34 167 118 42 187 220 189 147 213 12 206 115 212 69 124 1 83 233 249 106 10 104 46 31 116 170 185 154 170 86 53 10 165 121 233 151 15 50 68 23 42 248 103 248 169 224 221 242 26 207 255 100 167 208 204 140 243 92 9 225 253 120 207 151 248 152 163 170 207 159 227 205 252 101 175 221 46 195 21 231 39 105 59 191 74 214 209 217 233 164 158 92 175 247 134 211 209 84 14 195 252 71 239 233 41 38 254 136 209 59 179 138 230 57 48 65 230 158 149 93 28 205 117 58 222 67 20 235 100 196 200 87 215 105 250 20 102 201 66 183 148 79 218 125 125 56 213 79 233 3 194 196 81 219 106 214 23 231 110 61 145 52 95 167 157 226 89 78 236 169 200 128 46 117 199 18 237 96 149 75 132 205 180 222 100 165 117 169 125 155 39 235 184 205 44 224 182 168 148 217 226 180 97 85 179 82 210 116 196 82 225 40 147 20 183 195 113 86 225 158 11 150 159 25 209 188 90 138 78 235 5 177 45 23 192 186 82 177 92 129 172 170 61 111 113 116 231 116 108 161 230 46 46 204 78 195 44 203 173 83 220 214 22 19 46 165 169 216 181 250 96 142 167 247 124 170 173 198 124 182 77 183 48 231 238 66 9 219 94 166 119 246 41 69 82 50 204 145 185 220 28 89 61 56 214 32 133 52 105 119 155 123 255 206 245 96 193 122 136 31 214 62 115 254 214 236 248 54 243 220 44 206 88 61 8 247 113 181 20 54 158 1 42 67 167 160 14 161 108 12 69 157 149 182 81 216 199 63 110 182 76 183 19 150 67 250 165 16 91 190 58 246 210 245 120 187 180 172 196 21 241 243 14 236 39 20 78 239 101 115 89 196 113 107 104 12 142 206 186 138 34 140 162 120 12 206 78 251 40 92 230 170 132 24 119 231 40 74 71 160 133 184 115 198 53 130 178 144 109 4 74 64 121 136 121 69 182 102 133 236 35 240 212 61 35 202 84 116 86 86 142 98 118 129 50 33 54 155 96 99 89 195 255 75 225 199 98 58 109 25 222 128 149 120 14 235 176 2 27 208 128 86 188 137 157 234 149 60 113 0 119 100 13 189 39 107 104 107 104 20 85 52 214 251 89 56 67 25 204 225 84 203 224 34 14 115 51 168 14 17 91 179 125 4 222 103 224 80 143 11 217 41 248 238 167 110 214 212 63 130 128 165 43 151 143 231 117 90 140 82 194 38 58 101 61 103 205 116 241 53 152 131 107 17 64 11 191 14 180 210 109 109 212 236 122 92 141 118 98 55 77 113 224 157 249 171 104 50 247 128 121 162 225 48 108 34 179 204 38 224 108 6 23 23 29 155 120 85 28 83 62 233 138 74 30 0 182 19 238 64 53 110 196 197 184 105 10 235 187 112 119 150 245 50 40 147 245 172 172 241 229 135 224 176 157 180 159 156 198 106 23 97 148 22 12 160 140 33 87 200 138 29 132 197 74 221 194 107 22 218 151 133 149 255 48 124 254 186 179 39 224 13 28 70 133 63 176 83 230 37 28 31 64 233 24 230 241 174 131 227 129 251 69 150 56 140 62 45 58 153 245 233 163 210 145 31 49 195 210 250 187 86 90 114 9 235 80 157 63 48 138 249 107 3 69 199 48 215 244 251 40 22 152 150 135 20 47 102 152 33 195 43 35 81 6 151 4 132 93 160 228 224 131 86 208 88 20 69 39 3 7 100 251 224 17 70 28 199 187 214 18 190 193 60 112 169 201 149 113 245 198 206 202 203 70 81 59 62 201 42 212 73 210 192 1 157 55 28 56 57 134 133 157 149 52 176 110 60 239 161 4 99 141 223 228 104 251 62 4 233 155 90 134 254 34 6 255 98 222 224 10 186 250 77 244 209 54 188 19 59 241 46 232 236 69 6 216 137 37 216 83 236 97 75 177 159 109 213 29 108 77 222 141 251 56 99 7 194 255 195 252 127 24 15 224 81 122 33 131 163 24 195 49 126 67 252 16 158 197 9 124 7 15 225 5 124 120 202 13 188 147 124 173 203 124 138 123 197 28 123 231 149 28 124 64 140 89 212 89 89 63 138 197 227 114 35 243 170 176 228 52 174 184 107 173 173 193 62 140 171 2 94 123 79 131 195 235 48 163 232 33 184 205 177 193 97 133 150 215 193 184 18 44 125 82 106 250 111 24 30 175 221 235 216 217 96 247 218 3 199 39 62 237 181 31 120 44 239 129 70 120 8 159 160 236 83 156 101 80 197 39 29 192 105 122 227 73 92 66 173 22 210 134 101 56 131 85 252 98 124 13 198 25 239 231 176 25 159 192 86 124 138 193 249 36 186 104 95 161 69 247 230 35 127 133 185 6 42 36 9 221 207 228 48 138 165 162 143 154 30 235 95 102 14 250 10 3 244 89 42 240 213 2 102 69 210 246 102 3 244 105 238 241 59 174 10 88 70 122 46 30 197 178 97 20 183 153 207 185 204 118 26 43 170 208 112 240 80 246 125 151 121 106 78 99 229 85 124 227 86 84 92 153 141 138 89 103 215 248 252 15 97 182 223 209 207 201 137 137 215 66 126 43 55 9 206 230 35 207 236 236 52 86 101 176 122 99 189 240 114 146 213 8 174 50 231 158 98 115 177 166 254 20 214 216 247 218 115 81 183 86 248 91 4 46 147 192 103 45 220 212 107 4 111 22 106 143 107 175 199 117 12 115 56 247 121 92 71 177 220 60 120 245 228 193 114 147 118 157 181 168 52 23 141 214 98 142 185 240 155 115 191 105 215 17 204 241 157 113 173 178 135 170 237 166 214 245 213 244 107 83 253 227 166 191 75 153 218 151 103 29 124 7 243 40 24 121 165 120 158 187 47 48 209 127 143 55 251 125 44 192 15 25 231 47 225 114 252 136 55 251 50 115 216 79 152 195 126 198 204 246 115 108 196 47 120 187 175 224 102 252 138 241 254 27 22 157 87 201 231 183 140 250 223 177 217 254 3 134 241 71 198 202 159 24 7 127 193 231 241 26 51 244 235 120 17 19 120 133 194 95 99 211 110 87 54 229 34 44 83 14 229 85 197 202 199 102 120 242 82 221 210 145 91 197 165 104 43 175 180 132 151 58 98 91 235 243 51 60 125 13 142 97 140 133 188 142 253 14 181 172 2 19 123 27 138 189 197 206 61 31 149 76 114 52 155 81 202 37 219 255 131 207 209 105 159 77 217 79 108 191 77 13 99 123 94 192 185 189 21 216 119 84 146 218 34 38 181 245 227 38 122 245 84 244 49 166 214 11 210 231 87 94 135 215 126 124 98 189 12 5 52 129 51 142 85 197 54 49 236 92 200 183 95 101 237 114 122 157 89 187 30 254 39 236 122 120 218 103 91 246 179 187 186 216 84 209 235 124 223 214 97 108 203 175 60 243 246 122 138 7 45 177 158 55 239 221 39 216 85 249 37 81 13 174 73 218 89 123 61 218 160 215 181 111 42 121 222 14 159 24 119 245 24 154 59 171 139 109 76 229 27 38 11 229 189 76 20 80 30 20 169 10 56 85 37 220 106 54 202 84 21 106 248 133 161 95 205 197 46 85 13 67 249 113 155 10 224 78 53 15 247 168 32 222 165 46 193 199 212 165 24 85 151 225 41 85 139 167 85 29 62 195 115 95 82 139 241 156 90 130 231 213 82 188 168 150 225 37 181 28 47 171 21 252 161 169 65 93 173 174 84 215 169 85 106 163 90 163 34 106 173 138 170 117 106 143 106 84 31 84 77 234 176 218 160 78 168 229 234 35 170 133 129 198 239 123 217 254 101 62 27 4 41 70 37 99 184 166 179 110 20 215 78 170 93 44 175 69 117 16 205 175 199 217 52 115 156 17 41 105 166 153 143 173 37 131 214 53 254 35 44 87 167 112 221 57 72 182 109 227 231 122 127 143 63 131 141 117 147 111 186 61 155 147 60 146 63 178 217 168 113 126 21 218 15 30 202 230 135 127 145 103 94 151 77 38 242 202 235 114 185 66 94 185 181 208 172 87 78 190 242 210 55 103 176 229 0 207 175 144 243 99 232 224 29 108 173 188 33 131 127 21 124 6 219 42 59 57 39 221 118 210 101 176 163 242 70 46 51 184 201 148 115 10 141 196 252 91 6 55 207 224 176 211 226 208 88 192 33 76 186 153 28 214 89 29 84 23 25 172 46 100 208 109 49 88 119 26 61 156 85 234 22 15 161 204 238 244 78 178 153 204 243 173 204 244 80 59 248 235 220 141 208 212 77 152 175 110 70 189 10 99 165 234 194 58 213 141 22 213 131 45 170 23 55 171 62 68 85 63 134 216 144 220 173 118 97 76 197 240 69 21 199 223 84 138 191 7 164 213 122 53 52 165 62 240 119 129 108 177 217 105 213 7 44 26 198 101 84 168 207 106 12 164 226 73 25 28 195 114 106 223 63 238 247 218 119 174 145 234 185 54 240 224 196 243 147 250 45 144 38 69 221 6 155 218 135 89 234 118 120 213 219 17 80 251 177 64 29 192 101 220 175 83 119 22 200 173 49 139 189 21 95 245 220 147 248 242 134 124 230 203 14 249 236 59 205 137 199 53 184 239 228 180 88 187 151 71 249 115 69 246 104 93 182 181 158 29 98 185 89 121 32 228 115 236 148 209 227 25 186 253 177 105 7 63 64 248 128 217 86 61 248 255 158 232 29 5 79 23 0 0)! !

!JavaClassDefLoaderTestCase methodsFor: 'data' stamp: 'btb 8/16/2004 15:54'!
zipInputStreamClassBytes
	| stream |
	stream := GZipReadStream on: self zippedZipInputStreamClassBytes asByteArray.
	^stream upToEnd.! !

!JavaClassDefLoaderTestCase methodsFor: 'data' stamp: 'btb 8/16/2004 19:17'!
zippedZipOutputStreamClassBytes
	^#(31 139 8 0 0 0 0 0 0 0 157 89 9 124 148 213 181 255 159 76 38 51 153 124 64 18 18 52 36 33 3 10 36 51 132 176 25 16 1 133 16 37 16 18 132 64 89 220 134 228 75 24 157 204 196 89 36 80 23 172 88 151 46 110 88 5 180 238 166 175 117 151 36 42 22 212 182 80 251 124 118 209 214 165 181 187 213 218 167 93 222 243 189 182 182 229 253 207 55 223 108 36 250 94 95 126 191 185 203 185 231 158 123 206 185 103 187 95 190 243 143 103 14 1 152 37 129 66 92 139 111 186 240 45 55 142 120 144 135 163 46 124 219 3 39 94 244 224 58 124 199 133 127 245 192 141 151 20 233 223 92 120 217 131 162 228 228 187 46 124 207 131 177 201 201 247 181 249 129 54 175 104 243 170 7 63 196 143 60 28 189 230 0 142 29 115 225 117 55 222 240 224 4 28 213 229 55 221 248 177 246 63 209 99 222 82 180 159 234 244 103 58 250 121 33 130 248 133 243 152 253 231 193 47 241 43 15 65 191 86 248 43 218 188 173 205 111 180 121 71 155 119 93 248 173 27 239 121 224 87 226 65 252 206 141 127 119 227 125 55 62 80 154 191 87 208 31 180 249 163 114 254 39 23 254 195 131 70 188 228 198 127 106 255 161 54 255 165 231 254 183 74 249 231 52 87 127 81 216 95 211 211 143 210 163 191 185 241 119 221 244 15 55 142 217 192 70 129 91 36 133 33 121 110 113 216 147 177 146 239 22 167 71 10 196 229 22 183 91 10 45 184 189 120 173 120 210 123 138 220 98 184 100 140 7 155 112 84 183 21 185 100 172 7 231 144 79 25 199 107 144 98 183 148 16 89 74 61 50 94 138 21 163 76 167 229 100 90 38 184 229 4 237 79 44 146 10 153 232 146 74 37 93 165 147 106 29 77 210 253 53 78 94 53 242 29 171 214 40 200 171 205 100 109 166 80 51 114 146 142 78 182 48 220 174 85 107 172 65 158 172 90 163 90 123 211 154 21 56 117 102 31 63 213 2 41 142 5 74 205 142 165 6 249 133 60 176 148 22 32 211 180 153 238 146 90 151 212 185 196 39 112 154 225 120 116 135 224 196 214 11 3 151 4 26 18 241 96 168 97 103 176 175 97 115 176 175 89 87 78 19 184 20 37 104 198 4 165 89 72 27 204 206 120 36 202 101 103 56 208 171 139 229 89 139 43 2 177 109 241 192 214 144 201 117 71 103 180 51 119 85 233 55 173 109 154 59 71 137 111 143 6 227 113 51 44 144 149 130 130 80 164 51 210 221 77 112 103 164 183 151 231 166 207 12 5 194 61 13 235 200 71 184 135 187 10 122 205 248 182 72 23 55 181 240 166 187 131 225 96 108 155 169 211 205 92 235 12 69 98 58 41 88 215 209 190 182 121 185 96 76 83 36 28 139 7 194 241 13 129 80 194 116 168 70 184 107 121 243 153 173 75 59 154 151 235 220 45 240 152 225 88 34 106 182 247 41 47 142 218 186 13 130 252 166 72 151 41 24 215 26 12 155 109 137 222 173 102 180 67 101 34 110 115 127 167 217 23 15 146 44 143 89 196 227 227 75 4 21 181 73 86 131 145 134 246 68 188 47 17 39 187 102 160 247 52 37 229 137 153 241 166 148 72 229 181 35 101 82 164 66 34 173 182 5 203 175 109 81 144 155 160 86 243 18 51 36 48 72 177 205 236 143 55 39 47 172 178 246 227 110 204 58 207 82 130 141 234 84 29 147 109 87 237 150 101 45 22 217 130 164 202 184 100 225 241 28 11 165 181 189 41 53 108 222 216 145 26 54 53 183 165 161 109 84 167 179 118 229 74 235 12 11 180 110 91 36 26 79 173 183 168 120 249 181 89 203 203 118 196 213 56 198 244 152 241 245 29 103 46 104 53 195 61 241 109 31 163 2 222 165 97 227 217 219 38 140 134 182 101 25 137 175 139 36 162 157 230 153 65 189 142 50 138 158 173 241 153 186 199 192 29 216 47 24 159 186 146 150 246 244 165 145 157 36 162 55 105 42 6 6 240 85 30 150 171 207 229 102 119 40 16 55 163 92 21 191 54 51 4 197 199 219 191 110 189 207 192 23 240 197 212 81 185 246 111 224 6 220 152 179 148 54 126 3 55 225 102 3 183 98 143 129 219 177 215 144 122 236 119 201 76 67 26 100 150 129 67 56 44 152 146 17 190 37 20 50 123 2 161 165 209 158 132 26 81 150 44 19 55 183 172 241 118 83 17 94 219 103 188 241 72 196 27 138 132 123 102 26 248 18 110 35 70 48 124 73 32 20 236 82 132 190 168 25 139 113 159 55 233 65 134 204 22 114 242 48 30 50 112 175 74 242 57 124 222 192 99 28 201 92 236 113 201 60 67 78 145 70 67 230 227 89 67 22 144 85 57 85 249 189 73 71 11 177 151 180 71 26 97 134 181 249 41 31 243 90 81 198 219 27 228 217 225 30 111 44 184 211 156 145 230 198 236 178 1 145 168 151 177 162 158 170 145 211 148 246 156 164 3 219 155 183 111 51 163 102 246 166 201 139 189 137 240 113 68 4 167 228 108 250 191 158 40 152 148 160 255 247 245 209 152 205 81 21 133 91 84 230 69 218 44 198 109 134 44 145 211 83 38 147 101 157 203 18 221 221 102 84 80 210 149 232 11 5 59 105 63 73 70 22 122 13 57 67 150 26 178 76 154 12 12 226 81 67 150 75 179 129 39 85 211 103 170 226 247 201 89 134 172 144 89 130 234 212 117 37 69 80 78 189 181 102 127 31 13 142 172 41 29 58 74 161 119 107 34 238 237 137 196 45 0 67 167 203 187 85 125 166 206 144 85 74 164 54 151 200 113 146 231 208 107 21 166 203 201 185 248 180 80 106 37 11 109 86 191 75 86 27 210 38 237 130 162 244 217 179 250 25 115 235 12 12 169 64 107 112 223 8 58 73 237 230 208 17 156 144 101 214 97 122 88 56 16 106 142 70 35 84 219 73 217 43 93 102 63 189 186 189 123 89 36 17 238 138 101 153 85 89 56 226 237 76 68 163 106 235 106 252 214 81 6 30 199 19 130 186 0 179 73 111 159 58 129 215 10 64 222 190 64 44 78 148 46 111 164 219 155 109 27 134 156 45 107 93 178 206 144 14 60 65 253 99 63 45 92 85 55 53 237 80 189 9 110 221 22 184 196 244 6 226 222 144 169 132 34 97 51 181 125 189 108 112 201 167 12 217 40 155 70 4 143 84 48 54 48 172 170 217 204 203 197 83 120 218 192 1 189 235 131 244 38 60 163 62 247 28 158 55 100 139 156 99 224 235 202 196 227 132 201 185 114 158 33 231 203 5 180 132 17 68 179 195 92 42 62 140 136 88 185 72 35 61 52 149 14 99 26 203 91 54 107 176 158 253 49 185 171 117 244 19 172 28 51 62 17 51 99 132 4 18 161 120 106 33 21 34 179 92 66 179 186 29 245 153 86 105 186 142 46 179 123 100 193 145 38 205 4 18 15 246 154 185 148 118 196 120 171 116 43 251 218 59 136 176 58 24 10 5 99 22 81 53 127 38 202 14 107 91 126 50 14 56 59 147 125 62 201 146 7 215 37 102 52 102 89 79 1 11 12 34 115 69 11 23 238 167 180 130 5 217 153 166 125 235 133 180 214 211 70 66 234 70 130 72 48 208 199 162 129 57 123 198 104 217 170 117 244 16 193 125 238 120 36 165 161 178 218 186 209 202 28 79 160 171 171 57 100 142 82 53 164 248 225 53 184 186 146 154 179 52 193 250 199 195 20 218 17 137 7 66 45 97 173 18 86 126 2 7 149 44 50 62 126 181 40 69 168 93 21 228 230 204 170 159 4 99 51 91 90 35 202 126 81 60 178 194 236 79 9 83 62 218 153 90 40 50 0 169 222 29 17 165 55 97 116 131 163 46 70 131 83 203 137 190 46 75 74 183 153 212 72 76 43 174 186 44 43 106 14 51 53 70 3 26 35 72 166 124 212 5 242 26 214 26 42 165 212 92 197 167 175 116 220 182 64 108 117 36 106 54 167 143 114 114 87 52 32 200 211 234 163 160 115 91 32 186 52 158 172 210 154 44 249 155 20 18 141 6 118 40 176 110 75 19 38 243 33 113 29 235 204 235 97 240 5 199 180 170 229 185 22 10 86 207 170 192 234 89 2 88 61 147 139 213 223 106 247 204 219 86 207 194 192 234 25 157 172 254 14 171 175 192 157 132 11 190 108 193 238 226 252 238 172 249 61 24 207 150 217 156 237 253 132 204 129 131 107 64 169 239 0 100 47 198 28 68 222 166 82 199 48 242 15 63 110 85 194 15 176 29 11 45 131 125 112 241 205 86 130 122 60 168 175 6 174 229 241 55 128 175 176 85 74 151 161 128 16 160 217 231 63 8 231 166 188 252 97 20 12 195 229 59 8 247 166 97 20 14 194 195 97 17 135 198 32 198 112 56 150 195 113 131 40 246 113 169 196 87 236 30 36 15 142 65 136 47 127 16 227 51 135 79 67 33 219 197 100 162 146 162 84 225 100 84 163 1 53 152 71 37 46 228 236 116 44 193 114 182 130 127 193 87 109 86 86 145 97 101 101 186 255 8 188 254 33 148 149 172 95 127 63 38 248 159 66 121 233 132 251 85 200 19 54 149 158 56 140 138 195 62 255 32 38 102 14 43 165 92 192 10 62 124 87 146 124 43 15 95 205 149 175 225 33 155 240 18 155 240 196 202 98 247 93 40 169 220 107 211 170 180 104 85 82 132 227 105 109 132 62 18 203 176 133 204 159 195 149 135 211 180 166 146 146 210 42 164 230 171 42 135 80 157 217 234 177 22 76 190 112 187 9 121 4 143 38 47 43 175 140 36 185 34 253 190 97 76 226 182 154 35 212 239 16 69 60 128 201 101 152 178 103 31 60 148 241 228 33 76 37 100 90 222 221 40 242 19 171 116 16 211 116 254 53 235 185 247 71 203 12 146 127 87 234 235 134 191 74 46 79 87 2 123 81 193 97 109 114 56 150 195 186 36 89 195 175 247 227 27 64 99 6 115 114 6 115 66 10 115 47 79 116 88 136 212 139 127 83 233 140 97 212 31 246 23 151 13 98 230 0 46 75 237 221 71 210 186 121 16 211 7 208 144 34 99 67 167 15 162 118 192 98 99 186 174 236 217 107 147 106 176 72 165 79 207 98 46 185 62 43 121 148 135 71 229 176 48 219 130 83 13 115 6 49 151 221 24 110 156 71 155 56 229 8 38 43 194 65 52 210 16 231 151 46 24 194 169 186 196 110 8 11 117 147 207 63 140 211 184 195 67 236 69 106 40 53 153 27 186 30 83 216 198 120 31 113 126 166 72 96 28 182 99 34 250 105 52 59 81 135 79 99 54 221 97 13 174 192 197 248 12 33 87 209 49 175 166 203 93 195 235 191 158 101 221 231 88 19 221 128 231 233 230 47 209 201 95 163 155 255 146 78 254 1 221 251 207 44 201 199 226 118 57 145 207 147 73 184 67 78 194 157 50 13 119 201 44 220 195 10 251 94 57 139 101 148 137 7 228 66 60 40 81 62 59 182 211 253 178 221 241 177 148 99 231 93 67 119 85 91 249 40 101 43 173 254 35 242 135 180 29 200 43 25 59 32 85 219 14 136 183 120 8 75 6 44 179 58 157 179 51 134 176 116 239 177 15 185 141 30 122 249 62 188 172 55 64 248 178 33 52 93 205 107 56 37 91 133 203 147 42 156 62 132 230 210 51 57 38 222 89 196 27 194 138 210 150 140 90 245 86 185 178 114 8 171 70 80 104 77 82 168 205 162 176 154 120 35 41 212 113 165 120 8 109 36 208 153 77 160 61 73 160 238 41 172 225 168 244 236 36 13 197 180 33 107 179 200 112 101 157 202 65 59 212 113 135 114 68 235 243 219 59 6 121 10 77 96 61 167 27 134 240 41 223 38 218 144 50 23 24 196 156 1 236 181 53 49 135 191 18 147 124 204 255 95 84 145 68 84 192 199 138 210 156 77 98 227 63 33 202 65 108 178 130 208 230 195 73 148 45 62 201 49 215 157 152 196 246 113 154 201 19 12 167 79 98 12 75 205 25 52 194 185 172 64 27 89 123 46 100 191 156 69 103 27 158 197 121 172 54 111 164 113 222 141 23 240 3 28 197 47 240 109 169 192 203 50 21 223 149 217 248 30 95 57 223 151 165 120 69 86 224 85 89 207 15 70 27 241 186 4 241 134 220 137 183 228 33 252 84 126 141 183 229 3 188 35 31 226 93 249 43 222 203 50 207 201 90 133 39 205 83 74 248 109 78 227 227 160 154 103 213 126 84 86 249 15 221 135 242 234 253 40 169 170 190 64 199 133 236 239 64 209 65 156 67 117 156 123 184 122 31 242 31 87 59 62 106 59 246 121 150 143 18 144 14 109 91 178 66 219 212 180 73 251 171 170 135 113 254 0 154 172 11 172 190 90 175 47 125 29 201 253 211 247 124 217 38 122 129 77 52 192 93 67 216 106 5 145 108 213 90 224 206 140 98 87 50 204 131 94 155 143 191 192 139 143 80 139 191 81 177 127 71 61 115 234 60 17 44 17 7 46 16 39 122 164 0 23 138 27 9 209 175 109 30 220 34 99 232 217 99 113 183 20 243 235 66 41 14 200 248 28 63 126 50 157 160 159 164 31 171 162 58 109 63 238 218 107 235 193 142 253 26 160 134 96 230 223 107 75 208 109 75 48 231 140 228 74 79 219 0 115 108 253 211 96 137 253 28 130 195 184 144 227 139 4 251 142 189 239 171 81 188 26 115 24 33 77 186 93 25 177 150 48 160 65 170 145 207 32 84 36 53 48 100 50 198 203 20 156 32 39 99 10 45 97 134 212 98 182 212 225 84 241 97 145 248 209 194 126 45 191 81 156 43 51 177 85 26 114 68 57 144 22 229 20 107 14 102 123 214 26 76 42 148 168 87 15 150 227 146 38 63 40 184 24 237 138 248 57 161 152 143 253 12 177 60 125 28 219 6 84 72 152 150 37 15 248 202 16 30 70 159 143 190 50 115 24 23 107 239 179 251 105 118 63 153 235 118 8 43 118 223 141 114 95 161 110 72 55 3 106 37 244 52 155 74 173 221 79 79 238 154 247 20 162 171 125 51 14 217 180 98 71 152 227 216 29 26 224 247 89 133 205 112 232 90 60 185 84 98 161 56 44 4 2 125 201 188 83 146 17 112 45 107 1 208 127 92 178 12 227 164 137 26 93 142 26 105 198 116 62 244 231 74 11 22 200 74 44 150 85 104 150 213 88 45 109 88 47 237 212 234 217 48 101 45 111 109 29 174 224 131 244 26 250 221 23 101 3 211 195 70 220 47 155 114 20 52 148 82 16 171 152 100 173 226 165 130 18 182 72 163 137 152 225 109 2 125 18 114 62 121 187 128 188 5 200 219 86 242 214 153 67 127 56 125 1 45 132 169 97 190 72 250 219 143 187 128 79 186 136 255 191 170 57 222 113 4 101 218 17 177 205 87 175 136 3 240 72 155 207 186 137 76 83 104 211 157 171 253 39 93 80 61 143 240 213 59 148 82 60 163 136 48 107 77 48 199 186 228 34 42 34 68 69 244 82 17 97 94 82 4 13 210 135 249 114 49 78 103 254 61 75 98 104 151 56 47 41 193 239 242 219 209 39 253 232 151 29 184 82 62 141 171 228 82 126 110 191 28 95 144 43 112 179 236 98 94 191 146 121 252 51 204 217 87 225 17 217 141 103 229 179 120 78 174 97 112 189 46 71 193 252 16 96 95 224 125 132 21 104 88 163 130 119 170 32 25 249 108 167 63 110 104 105 183 70 155 3 152 120 196 10 13 19 169 168 133 78 95 133 211 210 105 133 211 97 141 226 3 112 91 132 50 34 55 50 39 64 110 160 200 55 210 219 111 66 137 220 140 42 185 133 34 239 161 183 223 74 111 255 18 109 243 54 44 149 219 177 130 15 133 245 178 31 155 25 243 179 89 231 71 11 155 245 179 105 73 234 156 154 219 46 93 61 163 210 113 105 9 142 93 62 132 203 102 176 112 78 141 173 120 92 134 203 53 32 31 111 132 247 241 159 44 247 211 251 31 32 19 15 162 86 6 114 14 226 39 18 251 160 132 157 70 154 121 208 174 182 250 26 199 101 101 184 242 138 107 73 189 190 166 216 157 61 41 206 158 156 152 158 216 76 92 149 203 196 36 6 93 200 195 100 226 17 106 226 81 76 146 199 224 103 152 90 32 79 96 185 60 153 195 204 215 83 57 141 58 76 50 51 129 204 92 157 76 32 89 57 231 184 247 148 60 77 195 125 6 229 114 48 139 154 91 63 237 218 239 131 40 231 74 173 209 177 200 177 120 128 53 83 213 16 62 187 164 186 248 10 166 198 221 66 141 140 175 46 113 29 179 38 121 3 40 216 45 142 221 121 82 197 148 80 118 207 177 31 85 62 148 62 205 199 231 4 228 121 254 139 232 5 222 238 55 48 70 190 201 88 254 45 84 8 77 68 142 98 154 188 136 58 174 205 147 151 136 201 111 78 201 243 25 111 242 173 167 215 155 36 121 77 171 255 208 98 199 18 71 99 254 0 124 254 242 252 121 141 206 114 103 146 19 7 57 41 43 119 218 172 56 44 86 28 142 221 249 82 158 95 69 70 170 159 117 47 116 58 26 11 28 141 174 1 92 231 47 119 205 107 116 151 187 117 107 73 133 179 188 96 119 129 148 187 111 234 24 192 69 229 110 139 132 47 13 45 46 216 89 130 231 118 221 212 145 129 156 126 121 9 118 237 82 244 69 25 160 65 180 159 231 160 21 236 76 99 142 220 187 219 37 229 46 114 182 189 194 249 88 90 71 221 124 157 65 94 229 125 255 144 255 238 121 141 55 243 58 141 239 13 76 144 55 81 45 63 198 73 242 19 222 255 91 244 130 159 81 79 175 51 66 255 10 203 88 233 52 203 219 88 37 191 193 217 242 14 54 202 187 232 150 223 34 44 239 97 151 252 14 183 202 251 116 246 15 232 232 191 103 245 244 54 94 147 63 241 180 23 172 26 229 27 255 3 164 128 126 101 206 29 0 0)! !

!JavaClassDefLoaderTestCase methodsFor: 'test' stamp: 'btb 8/16/2004 19:38'!
testReadThreadClass

	| readStream aClassDefLoader fieldInfo methodInfo |
	readStream := ReadStream on: self threadClassBytes.
	aClassDefLoader := JavaClassDefLoader loadFrom: readStream.
	self should: [aClassDefLoader majorVersion = 48].
	self should: [aClassDefLoader minorVersion = 0].
	self should: [aClassDefLoader thisClassInfo javaType printString ='java.lang.Thread'].
	self should: [aClassDefLoader superClassInfo javaType printString = 'java.lang.Object'].
	fieldInfo := aClassDefLoader fieldsInfo detect: [:each | each nameInfo value asString = 'daemon'].
	self should: [fieldInfo isPrivate].
	self should: [fieldInfo descriptor class == JavaBooleanType].
	self shouldnt: [aClassDefLoader methodsInfo do: [:each | each disassemblyString]] raise: Error.
	methodInfo := aClassDefLoader methodInfoNamed: 'interrupted'.
	self should: [methodInfo isStatic].
	self should: [methodInfo isPublic].
	self should: [methodInfo descriptor class == JavaMethodType].
	self should: [methodInfo descriptor arguments isEmpty].
	self should: [methodInfo descriptor returnType class == JavaBooleanType].
	self should: [aClassDefLoader interfacesInfo size == 1].
	self should: [methodInfo disassemblyString = self expectedInterruptedMethodDisassembly]! !

!JavaClassDefLoaderTestCase methodsFor: 'test' stamp: 'btb 8/25/2004 20:56'!
testReadZipInputStreamClass

	| readStream aClassDefLoader methodsInfo methodInfo |
	readStream := ReadStream on: self zipInputStreamClassBytes.
	aClassDefLoader := JavaClassDefLoader loadFrom: readStream.
	methodsInfo :=aClassDefLoader methodsInfo.
	methodsInfo do: [:each | each disassemblyString].
	methodInfo := aClassDefLoader methodInfoNamed: 'read'.
	self should: [methodInfo disassemblyString = self expectedReadMethodDisassembly].
	methodInfo := aClassDefLoader methodInfoNamed: 'getUTF8String'.
	self should: [methodInfo disassemblyString = self expectedGetUTF8StringDisassembly].! !

!JavaClassDefLoaderTestCase methodsFor: 'data' stamp: 'btb 8/16/2004 19:17'!
zipOutputStreamClassBytes
	| stream |
	stream := GZipReadStream on: self zippedZipInputStreamClassBytes asByteArray.
	^stream upToEnd.! !

!JavaClassDefLoaderTestCase methodsFor: 'data' stamp: 'btb 8/25/2004 20:56'!
expectedReadMethodDisassembly

	^'   0: 2A //aload0
   1: B7 00 14 //invokespecial java.util.zip.ZipInputStream>>void ensureOpen()
   4: 1C //iload2
   5: 9B 00 1B //iflt   32
   8: 1C //iload2
   9: 2B //aload1
  10: BE //arraylength
  11: A3 00 15 //ifIcmpgt   32
  14: 1D //iload3
  15: 9B 00 11 //iflt   32
  18: 1C //iload2
  19: 1D //iload3
  20: 60 //iadd
  21: 2B //aload1
  22: BE //arraylength
  23: A3 00 09 //ifIcmpgt   32
  26: 1C //iload2
  27: 1D //iload3
  28: 60 //iadd
  29: 9C 00 0B //ifge   40
  32: BB 00 1F //newobject ClassInfo:java.lang.IndexOutOfBoundsException
  35: 59 //dup
  36: B7 00 20 //invokespecial java.lang.IndexOutOfBoundsException>>void <init>()
  39: BF //athrow
  40: 1D //iload3
  41: 9A 00 05 //ifne   46
  44: 03 //iconst0
  45: AC //ireturn
  46: 2A //aload0
  47: B4 00 15 //getfield java.util.zip.ZipInputStream>>java.util.zip.ZipEntry entry
  50: C7 00 05 //ifnonnull   55
  53: 02 //iconstM1
  54: AC //ireturn
  55: 2A //aload0
  56: B4 00 15 //getfield java.util.zip.ZipInputStream>>java.util.zip.ZipEntry entry
  59: B4 00 1B //getfield java.util.zip.ZipEntry>>int method
  62: AB 00 00 00 00 9E 00 00 00 02 00 00 00 00 00 00 00 48 00 00 00 08 00 00 00 1A //lookupswitch pairs=2
	default:  220
	0:  134
	8:   88
  88: 2A //aload0
  89: 2B //aload1
  90: 1C //iload2
  91: 1D //iload3
  92: B7 00 21 //invokespecial java.util.zip.InflaterInputStream>>int read(byte[], int, int)
  95: 3E //istore3
  96: 1D //iload3
  97: 02 //iconstM1
  98: A0 00 18 //ifIcmpne  122
 101: 2A //aload0
 102: 2A //aload0
 103: B4 00 15 //getfield java.util.zip.ZipInputStream>>java.util.zip.ZipEntry entry
 106: B7 00 22 //invokespecial java.util.zip.ZipInputStream>>void readEnd(java.util.zip.ZipEntry)
 109: 2A //aload0
 110: 04 //iconst1
 111: B5 00 0E //putfield java.util.zip.ZipInputStream>>boolean entryEOF
 114: 2A //aload0
 115: 01 //aconstNull
 116: B5 00 15 //putfield java.util.zip.ZipInputStream>>java.util.zip.ZipEntry entry
 119: A7 00 0D //goto  132
 122: 2A //aload0
 123: B4 00 0C //getfield java.util.zip.ZipInputStream>>java.util.zip.CRC32 crc
 126: 2B //aload1
 127: 1C //iload2
 128: 1D //iload3
 129: B6 00 23 //invokevirtual java.util.zip.CRC32>>void update(byte[], int, int)
 132: 1D //iload3
 133: AC //ireturn
 134: 2A //aload0
 135: B4 00 1D //getfield java.util.zip.ZipInputStream>>long remaining
 138: 09 //lconst0
 139: 94 //lcmp
 140: 9D 00 0F //ifgt  155
 143: 2A //aload0
 144: 04 //iconst1
 145: B5 00 0E //putfield java.util.zip.ZipInputStream>>boolean entryEOF
 148: 2A //aload0
 149: 01 //aconstNull
 150: B5 00 15 //putfield java.util.zip.ZipInputStream>>java.util.zip.ZipEntry entry
 153: 02 //iconstM1
 154: AC //ireturn
 155: 1D //iload3
 156: 85 //i2l
 157: 2A //aload0
 158: B4 00 1D //getfield java.util.zip.ZipInputStream>>long remaining
 161: 94 //lcmp
 162: 9E 00 09 //ifle  171
 165: 2A //aload0
 166: B4 00 1D //getfield java.util.zip.ZipInputStream>>long remaining
 169: 88 //l2i
 170: 3E //istore3
 171: 2A //aload0
 172: B4 00 24 //getfield java.util.zip.ZipInputStream>>java.io.InputStream in
 175: 2B //aload1
 176: 1C //iload2
 177: 1D //iload3
 178: B6 00 25 //invokevirtual java.io.InputStream>>int read(byte[], int, int)
 181: 3E //istore3
 182: 1D //iload3
 183: 02 //iconstM1
 184: A0 00 0D //ifIcmpne  197
 187: BB 00 26 //newobject ClassInfo:java.util.zip.ZipException
 190: 59 //dup
 191: 12 27 //ldc StringInfo:''unexpected EOF''
 193: B7 00 28 //invokespecial java.util.zip.ZipException>>void <init>(java.lang.String)
 196: BF //athrow
 197: 2A //aload0
 198: B4 00 0C //getfield java.util.zip.ZipInputStream>>java.util.zip.CRC32 crc
 201: 2B //aload1
 202: 1C //iload2
 203: 1D //iload3
 204: B6 00 23 //invokevirtual java.util.zip.CRC32>>void update(byte[], int, int)
 207: 2A //aload0
 208: 59 //dup
 209: B4 00 1D //getfield java.util.zip.ZipInputStream>>long remaining
 212: 1D //iload3
 213: 85 //i2l
 214: 65 //lsub
 215: B5 00 1D //putfield java.util.zip.ZipInputStream>>long remaining
 218: 1D //iload3
 219: AC //ireturn
 220: BB 00 29 //newobject ClassInfo:java.lang.InternalError
 223: 59 //dup
 224: 12 2A //ldc StringInfo:''invalid compression method''
 226: B7 00 2B //invokespecial java.lang.InternalError>>void <init>(java.lang.String)
 229: BF //athrow'! !

!JavaClassDefLoaderTestCase methodsFor: 'data' stamp: 'btb 10/29/2003 20:53'!
threadClassBytes

	^#(202 254 186 190 0 0 0 48 1 73 9 0 89 0 205 9 0 89 0 206 7 0 207 8 0 208 10 0 3 0 209 3 0 15 66 63 8 0 210 3 0 7 161 32 10 0 89 0 211 10 0 89 0 212 10 0 213 0 214 10 0 215 0 216 10 0 89 0 216 10 0 217 0 218 9 0 89 0 219 10 0 89 0 220 9 0 89 0 221 10 0 89 0 222 9 0 89 0 223 10 0 224 0 225 9 0 89 0 226 9 0 89 0 227 10 0 228 0 229 9 0 89 0 230 9 0 89 0 231 10 0 89 0 232 9 0 89 0 233 10 0 234 0 235 9 0 89 0 236 10 0 217 0 237 10 0 90 0 238 9 0 89 0 239 9 0 89 0 240 7 0 241 10 0 34 0 238 8 0 242 10 0 34 0 243 10 0 89 0 244 10 0 34 0 245 10 0 34 0 246 10 0 89 0 247 11 0 91 0 248 10 0 217 0 249 10 0 89 0 250 10 0 89 0 218 9 0 89 0 251 7 0 252 8 0 253 10 0 47 0 209 10 0 215 0 254 10 0 89 0 255 7 1 0 10 0 52 0 238 10 0 89 1 1 11 1 2 1 3 10 0 89 1 4 10 0 89 1 5 7 1 6 10 0 58 0 238 10 0 89 1 7 10 0 89 1 8 10 0 3 0 238 10 0 217 1 9 10 0 89 1 10 10 0 224 1 11 10 0 217 1 12 10 0 217 1 13 10 0 213 1 14 10 0 90 1 15 10 0 89 1 16 7 1 17 8 1 18 10 0 71 0 209 10 0 71 1 19 7 1 20 10 0 75 0 238 10 0 215 1 21 8 1 22 10 0 89 1 23 8 1 24 10 0 217 1 23 8 1 25 8 1 26 10 1 27 1 28 10 1 27 1 29 10 1 27 1 30 8 0 192 10 0 89 1 31 7 1 32 7 1 33 7 1 34 1 0 4 110 97 109 101 1 0 2 91 67 1 0 8 112 114 105 111 114 105 116 121 1 0 1 73 1 0 7 116 104 114 101 97 100 81 1 0 18 76 106 97 118 97 47 108 97 110 103 47 84 104 114 101 97 100 59 1 0 5 101 101 116 111 112 1 0 1 74 1 0 11 115 105 110 103 108 101 95 115 116 101 112 1 0 1 90 1 0 6 100 97 101 109 111 110 1 0 9 115 116 105 108 108 98 111 114 110 1 0 6 116 97 114 103 101 116 1 0 20 76 106 97 118 97 47 108 97 110 103 47 82 117 110 110 97 98 108 101 59 1 0 5 103 114 111 117 112 1 0 23 76 106 97 118 97 47 108 97 110 103 47 84 104 114 101 97 100 71 114 111 117 112 59 1 0 18 99 111 110 116 101 120 116 67 108 97 115 115 76 111 97 100 101 114 1 0 23 76 106 97 118 97 47 108 97 110 103 47 67 108 97 115 115 76 111 97 100 101 114 59 1 0 29 105 110 104 101 114 105 116 101 100 65 99 99 101 115 115 67 111 110 116 114 111 108 67 111 110 116 101 120 116 1 0 36 76 106 97 118 97 47 115 101 99 117 114 105 116 121 47 65 99 99 101 115 115 67 111 110 116 114 111 108 67 111 110 116 101 120 116 59 1 0 16 116 104 114 101 97 100 73 110 105 116 78 117 109 98 101 114 1 0 20 115 116 111 112 84 104 114 101 97 100 80 101 114 109 105 115 115 105 111 110 1 0 29 76 106 97 118 97 47 108 97 110 103 47 82 117 110 116 105 109 101 80 101 114 109 105 115 115 105 111 110 59 1 0 12 116 104 114 101 97 100 76 111 99 97 108 115 7 1 35 1 0 14 84 104 114 101 97 100 76 111 99 97 108 77 97 112 1 0 12 73 110 110 101 114 67 108 97 115 115 101 115 1 0 38 76 106 97 118 97 47 108 97 110 103 47 84 104 114 101 97 100 76 111 99 97 108 36 84 104 114 101 97 100 76 111 99 97 108 77 97 112 59 1 0 23 105 110 104 101 114 105 116 97 98 108 101 84 104 114 101 97 100 76 111 99 97 108 115 1 0 9 115 116 97 99 107 83 105 122 101 1 0 7 98 108 111 99 107 101 114 1 0 26 76 115 117 110 47 110 105 111 47 99 104 47 73 110 116 101 114 114 117 112 116 105 98 108 101 59 1 0 12 77 73 78 95 80 82 73 79 82 73 84 89 1 0 13 67 111 110 115 116 97 110 116 86 97 108 117 101 3 0 0 0 1 1 0 13 78 79 82 77 95 80 82 73 79 82 73 84 89 3 0 0 0 5 1 0 12 77 65 88 95 80 82 73 79 82 73 84 89 3 0 0 0 10 1 0 15 114 101 103 105 115 116 101 114 78 97 116 105 118 101 115 1 0 3 40 41 86 1 0 13 110 101 120 116 84 104 114 101 97 100 78 117 109 1 0 3 40 41 73 1 0 4 67 111 100 101 1 0 15 76 105 110 101 78 117 109 98 101 114 84 97 98 108 101 1 0 9 98 108 111 99 107 101 100 79 110 1 0 29 40 76 115 117 110 47 110 105 111 47 99 104 47 73 110 116 101 114 114 117 112 116 105 98 108 101 59 41 86 1 0 13 99 117 114 114 101 110 116 84 104 114 101 97 100 1 0 20 40 41 76 106 97 118 97 47 108 97 110 103 47 84 104 114 101 97 100 59 1 0 5 121 105 101 108 100 1 0 5 115 108 101 101 112 1 0 4 40 74 41 86 1 0 10 69 120 99 101 112 116 105 111 110 115 7 1 36 1 0 5 40 74 73 41 86 1 0 4 105 110 105 116 1 0 65 40 76 106 97 118 97 47 108 97 110 103 47 84 104 114 101 97 100 71 114 111 117 112 59 76 106 97 118 97 47 108 97 110 103 47 82 117 110 110 97 98 108 101 59 76 106 97 118 97 47 108 97 110 103 47 83 116 114 105 110 103 59 74 41 86 1 0 6 60 105 110 105 116 62 1 0 23 40 76 106 97 118 97 47 108 97 110 103 47 82 117 110 110 97 98 108 101 59 41 86 1 0 46 40 76 106 97 118 97 47 108 97 110 103 47 84 104 114 101 97 100 71 114 111 117 112 59 76 106 97 118 97 47 108 97 110 103 47 82 117 110 110 97 98 108 101 59 41 86 1 0 21 40 76 106 97 118 97 47 108 97 110 103 47 83 116 114 105 110 103 59 41 86 1 0 44 40 76 106 97 118 97 47 108 97 110 103 47 84 104 114 101 97 100 71 114 111 117 112 59 76 106 97 118 97 47 108 97 110 103 47 83 116 114 105 110 103 59 41 86 1 0 41 40 76 106 97 118 97 47 108 97 110 103 47 82 117 110 110 97 98 108 101 59 76 106 97 118 97 47 108 97 110 103 47 83 116 114 105 110 103 59 41 86 1 0 64 40 76 106 97 118 97 47 108 97 110 103 47 84 104 114 101 97 100 71 114 111 117 112 59 76 106 97 118 97 47 108 97 110 103 47 82 117 110 110 97 98 108 101 59 76 106 97 118 97 47 108 97 110 103 47 83 116 114 105 110 103 59 41 86 1 0 5 115 116 97 114 116 1 0 3 114 117 110 1 0 4 101 120 105 116 1 0 4 115 116 111 112 1 0 10 68 101 112 114 101 99 97 116 101 100 1 0 24 40 76 106 97 118 97 47 108 97 110 103 47 84 104 114 111 119 97 98 108 101 59 41 86 1 0 9 105 110 116 101 114 114 117 112 116 1 0 11 105 110 116 101 114 114 117 112 116 101 100 1 0 3 40 41 90 1 0 13 105 115 73 110 116 101 114 114 117 112 116 101 100 1 0 4 40 90 41 90 1 0 7 100 101 115 116 114 111 121 1 0 7 105 115 65 108 105 118 101 1 0 7 115 117 115 112 101 110 100 1 0 6 114 101 115 117 109 101 1 0 11 115 101 116 80 114 105 111 114 105 116 121 1 0 4 40 73 41 86 1 0 11 103 101 116 80 114 105 111 114 105 116 121 1 0 7 115 101 116 78 97 109 101 1 0 7 103 101 116 78 97 109 101 1 0 20 40 41 76 106 97 118 97 47 108 97 110 103 47 83 116 114 105 110 103 59 1 0 14 103 101 116 84 104 114 101 97 100 71 114 111 117 112 1 0 25 40 41 76 106 97 118 97 47 108 97 110 103 47 84 104 114 101 97 100 71 114 111 117 112 59 1 0 11 97 99 116 105 118 101 67 111 117 110 116 1 0 9 101 110 117 109 101 114 97 116 101 1 0 22 40 91 76 106 97 118 97 47 108 97 110 103 47 84 104 114 101 97 100 59 41 73 1 0 16 99 111 117 110 116 83 116 97 99 107 70 114 97 109 101 115 1 0 4 106 111 105 110 1 0 9 100 117 109 112 83 116 97 99 107 1 0 9 115 101 116 68 97 101 109 111 110 1 0 4 40 90 41 86 1 0 8 105 115 68 97 101 109 111 110 1 0 11 99 104 101 99 107 65 99 99 101 115 115 1 0 8 116 111 83 116 114 105 110 103 1 0 21 103 101 116 67 111 110 116 101 120 116 67 108 97 115 115 76 111 97 100 101 114 1 0 25 40 41 76 106 97 118 97 47 108 97 110 103 47 67 108 97 115 115 76 111 97 100 101 114 59 1 0 21 115 101 116 67 111 110 116 101 120 116 67 108 97 115 115 76 111 97 100 101 114 1 0 26 40 76 106 97 118 97 47 108 97 110 103 47 67 108 97 115 115 76 111 97 100 101 114 59 41 86 1 0 9 104 111 108 100 115 76 111 99 107 1 0 21 40 76 106 97 118 97 47 108 97 110 103 47 79 98 106 101 99 116 59 41 90 1 0 12 115 101 116 80 114 105 111 114 105 116 121 48 1 0 5 115 116 111 112 48 1 0 21 40 76 106 97 118 97 47 108 97 110 103 47 79 98 106 101 99 116 59 41 86 1 0 8 115 117 115 112 101 110 100 48 1 0 7 114 101 115 117 109 101 48 1 0 10 105 110 116 101 114 114 117 112 116 48 1 0 8 60 99 108 105 110 105 116 62 1 0 10 83 111 117 114 99 101 70 105 108 101 1 0 11 84 104 114 101 97 100 46 106 97 118 97 12 0 112 0 95 12 0 122 0 123 1 0 34 106 97 118 97 47 108 97 110 103 47 73 108 108 101 103 97 108 65 114 103 117 109 101 110 116 69 120 99 101 112 116 105 111 110 1 0 25 116 105 109 101 111 117 116 32 118 97 108 117 101 32 105 115 32 110 101 103 97 116 105 118 101 12 0 149 0 152 1 0 37 110 97 110 111 115 101 99 111 110 100 32 116 105 109 101 111 117 116 32 118 97 108 117 101 32 111 117 116 32 111 102 32 114 97 110 103 101 12 0 142 0 143 12 0 139 0 140 7 1 37 12 1 38 1 39 7 1 40 12 0 177 0 178 7 1 41 12 0 188 0 132 12 0 106 0 107 12 0 187 0 164 12 0 102 0 101 12 0 173 0 134 12 0 94 0 95 7 1 42 12 1 43 1 44 12 0 92 0 93 12 0 108 0 109 7 1 45 12 1 46 1 47 12 0 110 0 111 12 0 104 0 105 12 0 171 0 172 12 0 120 0 119 7 1 48 12 1 49 1 50 12 0 121 0 99 12 1 51 1 52 12 0 149 0 132 12 0 103 0 101 12 0 115 0 119 1 0 22 106 97 118 97 47 108 97 110 103 47 83 116 114 105 110 103 66 117 102 102 101 114 1 0 7 84 104 114 101 97 100 45 12 1 53 1 54 12 0 133 0 134 12 1 53 1 55 12 0 189 0 176 12 0 147 0 148 12 0 157 0 132 12 1 56 1 52 12 0 168 0 164 12 0 113 0 114 1 0 27 106 97 118 97 47 108 97 110 103 47 82 117 110 116 105 109 101 80 101 114 109 105 115 115 105 111 110 1 0 10 115 116 111 112 84 104 114 101 97 100 12 1 57 1 58 12 0 170 0 132 1 0 21 106 97 118 97 47 108 97 110 103 47 84 104 114 101 97 100 68 101 97 116 104 12 0 197 0 198 7 1 59 12 0 162 0 132 12 0 201 0 132 12 0 165 0 166 1 0 27 106 97 118 97 47 108 97 110 103 47 78 111 83 117 99 104 77 101 116 104 111 100 69 114 114 111 114 12 0 199 0 132 12 0 200 0 132 12 1 60 0 134 12 0 196 0 172 12 1 61 1 62 12 0 179 0 134 12 0 180 0 181 12 1 63 1 64 12 1 65 0 143 12 0 183 0 143 1 0 19 106 97 118 97 47 108 97 110 103 47 69 120 99 101 112 116 105 111 110 1 0 11 83 116 97 99 107 32 116 114 97 99 101 12 1 66 0 132 1 0 37 106 97 118 97 47 108 97 110 103 47 73 108 108 101 103 97 108 84 104 114 101 97 100 83 116 97 116 101 69 120 99 101 112 116 105 111 110 12 0 188 1 52 1 0 7 84 104 114 101 97 100 91 12 0 175 0 176 1 0 1 44 1 0 1 93 1 0 0 7 1 67 12 1 68 0 191 12 1 69 1 70 12 1 71 1 72 12 0 131 0 132 1 0 16 106 97 118 97 47 108 97 110 103 47 84 104 114 101 97 100 1 0 16 106 97 118 97 47 108 97 110 103 47 79 98 106 101 99 116 1 0 18 106 97 118 97 47 108 97 110 103 47 82 117 110 110 97 98 108 101 1 0 36 106 97 118 97 47 108 97 110 103 47 84 104 114 101 97 100 76 111 99 97 108 36 84 104 114 101 97 100 76 111 99 97 108 77 97 112 1 0 30 106 97 118 97 47 108 97 110 103 47 73 110 116 101 114 114 117 112 116 101 100 69 120 99 101 112 116 105 111 110 1 0 16 106 97 118 97 47 108 97 110 103 47 83 121 115 116 101 109 1 0 18 103 101 116 83 101 99 117 114 105 116 121 77 97 110 97 103 101 114 1 0 29 40 41 76 106 97 118 97 47 108 97 110 103 47 83 101 99 117 114 105 116 121 77 97 110 97 103 101 114 59 1 0 25 106 97 118 97 47 108 97 110 103 47 83 101 99 117 114 105 116 121 77 97 110 97 103 101 114 1 0 21 106 97 118 97 47 108 97 110 103 47 84 104 114 101 97 100 71 114 111 117 112 1 0 16 106 97 118 97 47 108 97 110 103 47 83 116 114 105 110 103 1 0 11 116 111 67 104 97 114 65 114 114 97 121 1 0 4 40 41 91 67 1 0 30 106 97 118 97 47 115 101 99 117 114 105 116 121 47 65 99 99 101 115 115 67 111 110 116 114 111 108 108 101 114 1 0 10 103 101 116 67 111 110 116 101 120 116 1 0 38 40 41 76 106 97 118 97 47 115 101 99 117 114 105 116 121 47 65 99 99 101 115 115 67 111 110 116 114 111 108 67 111 110 116 101 120 116 59 1 0 21 106 97 118 97 47 108 97 110 103 47 84 104 114 101 97 100 76 111 99 97 108 1 0 18 99 114 101 97 116 101 73 110 104 101 114 105 116 101 100 77 97 112 1 0 78 40 76 106 97 118 97 47 108 97 110 103 47 84 104 114 101 97 100 76 111 99 97 108 36 84 104 114 101 97 100 76 111 99 97 108 77 97 112 59 41 76 106 97 118 97 47 108 97 110 103 47 84 104 114 101 97 100 76 111 99 97 108 36 84 104 114 101 97 100 76 111 99 97 108 77 97 112 59 1 0 3 97 100 100 1 0 21 40 76 106 97 118 97 47 108 97 110 103 47 84 104 114 101 97 100 59 41 86 1 0 6 97 112 112 101 110 100 1 0 44 40 76 106 97 118 97 47 108 97 110 103 47 83 116 114 105 110 103 59 41 76 106 97 118 97 47 108 97 110 103 47 83 116 114 105 110 103 66 117 102 102 101 114 59 1 0 27 40 73 41 76 106 97 118 97 47 108 97 110 103 47 83 116 114 105 110 103 66 117 102 102 101 114 59 1 0 6 114 101 109 111 118 101 1 0 15 99 104 101 99 107 80 101 114 109 105 115 115 105 111 110 1 0 29 40 76 106 97 118 97 47 115 101 99 117 114 105 116 121 47 80 101 114 109 105 115 115 105 111 110 59 41 86 1 0 24 115 117 110 47 110 105 111 47 99 104 47 73 110 116 101 114 114 117 112 116 105 98 108 101 1 0 14 103 101 116 77 97 120 80 114 105 111 114 105 116 121 1 0 7 118 97 108 117 101 79 102 1 0 22 40 91 67 41 76 106 97 118 97 47 108 97 110 103 47 83 116 114 105 110 103 59 1 0 17 99 117 114 114 101 110 116 84 105 109 101 77 105 108 108 105 115 1 0 3 40 41 74 1 0 4 119 97 105 116 1 0 15 112 114 105 110 116 83 116 97 99 107 84 114 97 99 101 1 0 21 106 97 118 97 47 108 97 110 103 47 67 108 97 115 115 76 111 97 100 101 114 1 0 20 103 101 116 67 97 108 108 101 114 67 108 97 115 115 76 111 97 100 101 114 1 0 10 105 115 65 110 99 101 115 116 111 114 1 0 26 40 76 106 97 118 97 47 108 97 110 103 47 67 108 97 115 115 76 111 97 100 101 114 59 41 90 1 0 21 103 101 116 71 101 116 67 108 97 115 115 76 111 97 100 101 114 80 101 114 109 1 0 31 40 41 76 106 97 118 97 47 108 97 110 103 47 82 117 110 116 105 109 101 80 101 114 109 105 115 115 105 111 110 59 0 33 0 89 0 90 0 1 0 91 0 20 0 2 0 92 0 93 0 0 0 2 0 94 0 95 0 0 0 2 0 96 0 97 0 0 0 2 0 98 0 99 0 0 0 2 0 100 0 101 0 0 0 2 0 102 0 101 0 0 0 2 0 103 0 101 0 0 0 2 0 104 0 105 0 0 0 2 0 106 0 107 0 0 0 2 0 108 0 109 0 0 0 2 0 110 0 111 0 0 0 10 0 112 0 95 0 0 0 10 0 113 0 114 0 0 0 0 0 115 0 119 0 0 0 0 0 120 0 119 0 0 0 2 0 121 0 99 0 0 0 66 0 122 0 123 0 0 0 25 0 124 0 95 0 1 0 125 0 0 0 2 0 126 0 25 0 127 0 95 0 1 0 125 0 0 0 2 0 128 0 25 0 129 0 95 0 1 0 125 0 0 0 2 0 130 0 54 1 10 0 131 0 132 0 0 0 42 0 133 0 134 0 1 0 135 0 0 0 34 0 3 0 0 0 0 0 10 178 0 1 89 4 96 179 0 1 172 0 0 0 1 0 136 0 0 0 6 0 1 0 0 0 146 0 2 0 137 0 138 0 1 0 135 0 0 0 34 0 2 0 2 0 0 0 6 42 43 181 0 2 177 0 0 0 1 0 136 0 0 0 10 0 2 0 0 0 178 0 5 0 179 1 9 0 139 0 140 0 0 1 9 0 141 0 132 0 0 1 9 0 142 0 143 0 1 0 144 0 0 0 4 0 1 0 145 0 9 0 142 0 146 0 2 0 135 0 0 0 113 0 4 0 3 0 0 0 61 30 9 148 156 0 13 187 0 3 89 18 4 183 0 5 191 28 155 0 9 28 18 6 164 0 13 187 0 3 89 18 7 183 0 5 191 28 18 8 162 0 13 28 153 0 13 30 9 148 154 0 7 30 10 97 63 30 184 0 9 177 0 0 0 1 0 136 0 0 0 34 0 8 0 0 0 239 0 6 0 240 0 16 0 243 0 26 0 244 0 36 0 248 0 52 0 249 0 56 0 252 0 60 0 253 0 144 0 0 0 4 0 1 0 145 0 2 0 147 0 148 0 1 0 135 0 0 0 235 0 3 0 8 0 0 0 131 184 0 10 58 6 43 199 0 29 184 0 11 58 7 25 7 198 0 9 25 7 182 0 12 76 43 199 0 9 25 6 182 0 13 76 43 182 0 14 42 43 181 0 15 42 25 6 182 0 16 181 0 17 42 25 6 182 0 18 181 0 19 42 45 182 0 20 181 0 21 42 25 6 180 0 22 181 0 22 42 184 0 23 181 0 24 42 44 181 0 25 42 42 180 0 19 182 0 26 25 6 180 0 27 198 0 15 42 25 6 180 0 27 184 0 28 181 0 27 42 22 4 181 0 29 43 42 182 0 30 177 0 0 0 1 0 136 0 0 0 86 0 21 0 0 1 10 0 5 1 11 0 9 1 13 0 14 1 17 0 19 1 18 0 25 1 23 0 29 1 24 0 35 1 30 0 39 1 32 0 44 1 33 0 53 1 34 0 62 1 35 0 70 1 36 0 79 1 37 0 86 1 38 0 91 1 39 0 99 1 40 0 107 1 41 0 119 1 45 0 125 1 47 0 130 1 48 0 1 0 149 0 132 0 1 0 135 0 0 0 101 0 6 0 1 0 0 0 53 42 183 0 31 42 3 181 0 17 42 3 181 0 32 42 1 181 0 33 42 1 181 0 27 42 1 1 187 0 34 89 183 0 35 18 36 182 0 37 184 0 38 182 0 39 182 0 40 9 183 0 41 177 0 0 0 1 0 136 0 0 0 30 0 7 0 0 1 60 0 4 0 126 0 9 0 129 0 14 0 154 0 19 0 160 0 24 1 61 0 52 1 62 0 1 0 149 0 150 0 1 0 135 0 0 0 101 0 6 0 2 0 0 0 53 42 183 0 31 42 3 181 0 17 42 3 181 0 32 42 1 181 0 33 42 1 181 0 27 42 1 43 187 0 34 89 183 0 35 18 36 182 0 37 184 0 38 182 0 39 182 0 40 9 183 0 41 177 0 0 0 1 0 136 0 0 0 30 0 7 0 0 1 75 0 4 0 126 0 9 0 129 0 14 0 154 0 19 0 160 0 24 1 76 0 52 1 77 0 1 0 149 0 151 0 1 0 135 0 0 0 101 0 6 0 3 0 0 0 53 42 183 0 31 42 3 181 0 17 42 3 181 0 32 42 1 181 0 33 42 1 181 0 27 42 43 44 187 0 34 89 183 0 35 18 36 182 0 37 184 0 38 182 0 39 182 0 40 9 183 0 41 177 0 0 0 1 0 136 0 0 0 30 0 7 0 0 1 93 0 4 0 126 0 9 0 129 0 14 0 154 0 19 0 160 0 24 1 94 0 52 1 95 0 1 0 149 0 152 0 1 0 135 0 0 0 81 0 6 0 2 0 0 0 33 42 183 0 31 42 3 181 0 17 42 3 181 0 32 42 1 181 0 33 42 1 181 0 27 42 1 1 43 9 183 0 41 177 0 0 0 1 0 136 0 0 0 30 0 7 0 0 1 105 0 4 0 126 0 9 0 129 0 14 0 154 0 19 0 160 0 24 1 106 0 32 1 107 0 1 0 149 0 153 0 1 0 135 0 0 0 81 0 6 0 3 0 0 0 33 42 183 0 31 42 3 181 0 17 42 3 181 0 32 42 1 181 0 33 42 1 181 0 27 42 43 1 44 9 183 0 41 177 0 0 0 1 0 136 0 0 0 30 0 7 0 0 1 120 0 4 0 126 0 9 0 129 0 14 0 154 0 19 0 160 0 24 1 121 0 32 1 122 0 1 0 149 0 154 0 1 0 135 0 0 0 81 0 6 0 3 0 0 0 33 42 183 0 31 42 3 181 0 17 42 3 181 0 32 42 1 181 0 33 42 1 181 0 27 42 1 43 44 9 183 0 41 177 0 0 0 1 0 136 0 0 0 30 0 7 0 0 1 133 0 4 0 126 0 9 0 129 0 14 0 154 0 19 0 160 0 24 1 134 0 32 1 135 0 1 0 149 0 155 0 1 0 135 0 0 0 81 0 6 0 4 0 0 0 33 42 183 0 31 42 3 181 0 17 42 3 181 0 32 42 1 181 0 33 42 1 181 0 27 42 43 44 45 9 183 0 41 177 0 0 0 1 0 136 0 0 0 30 0 7 0 0 1 183 0 4 0 126 0 9 0 129 0 14 0 154 0 19 0 160 0 24 1 184 0 32 1 185 0 1 0 149 0 148 0 1 0 135 0 0 0 82 0 6 0 6 0 0 0 34 42 183 0 31 42 3 181 0 17 42 3 181 0 32 42 1 181 0 33 42 1 181 0 27 42 43 44 45 22 4 183 0 41 177 0 0 0 1 0 136 0 0 0 30 0 7 0 0 1 244 0 4 0 126 0 9 0 129 0 14 0 154 0 19 0 160 0 24 1 245 0 33 1 246 1 33 0 156 0 132 0 0 0 1 0 157 0 132 0 1 0 135 0 0 0 49 0 1 0 1 0 0 0 17 42 180 0 25 198 0 12 42 180 0 25 185 0 42 1 0 177 0 0 0 1 0 136 0 0 0 14 0 3 0 0 2 23 0 7 2 24 0 16 2 26 0 2 0 158 0 132 0 1 0 135 0 0 0 66 0 2 0 1 0 0 0 26 42 180 0 15 198 0 16 42 180 0 15 42 182 0 43 42 1 181 0 15 42 1 181 0 25 177 0 0 0 1 0 136 0 0 0 22 0 5 0 0 2 33 0 7 2 34 0 15 2 35 0 20 2 38 0 25 2 39 0 17 0 159 0 132 0 2 0 135 0 0 0 180 0 3 0 4 0 0 0 84 42 89 76 194 42 182 0 44 154 0 6 43 195 177 184 0 11 77 44 198 0 39 42 182 0 45 42 184 0 10 165 0 28 178 0 46 199 0 15 187 0 47 89 18 48 183 0 49 179 0 46 44 178 0 46 182 0 50 42 182 0 51 42 187 0 52 89 183 0 53 183 0 54 43 195 167 0 8 78 43 195 45 191 177 0 3 0 4 0 13 0 78 0 0 0 14 0 75 0 78 0 0 0 78 0 81 0 78 0 0 0 1 0 136 0 0 0 54 0 13 0 0 2 109 0 4 2 111 0 14 2 112 0 18 2 113 0 22 2 114 0 26 2 115 0 33 2 116 0 39 2 117 0 51 2 119 0 58 2 122 0 62 2 123 0 73 2 124 0 83 2 125 0 160 0 0 0 0 0 49 0 159 0 161 0 2 0 135 0 0 0 121 0 3 0 3 0 0 0 61 184 0 11 77 44 198 0 46 42 182 0 45 42 184 0 10 166 0 10 43 193 0 52 154 0 28 178 0 46 199 0 15 187 0 47 89 18 48 183 0 49 179 0 46 44 178 0 46 182 0 50 42 182 0 51 42 43 183 0 54 177 0 0 0 1 0 136 0 0 0 42 0 10 0 0 2 176 0 4 2 177 0 8 2 178 0 12 2 179 0 26 2 181 0 32 2 182 0 44 2 183 0 51 2 186 0 55 2 187 0 60 2 188 0 160 0 0 0 0 0 1 0 162 0 132 0 1 0 135 0 0 0 68 0 1 0 2 0 0 0 24 42 182 0 45 42 180 0 2 76 43 198 0 9 43 185 0 55 1 0 42 183 0 56 177 0 0 0 1 0 136 0 0 0 26 0 6 0 0 2 226 0 4 2 227 0 9 2 228 0 13 2 229 0 19 2 231 0 23 2 232 0 9 0 163 0 164 0 1 0 135 0 0 0 32 0 2 0 0 0 0 0 8 184 0 10 4 183 0 57 172 0 0 0 1 0 136 0 0 0 6 0 1 0 0 2 247 0 1 0 165 0 164 0 1 0 135 0 0 0 30 0 2 0 1 0 0 0 6 42 3 183 0 57 172 0 0 0 1 0 136 0 0 0 6 0 1 0 0 3 3 1 2 0 165 0 166 0 0 0 1 0 167 0 132 0 1 0 135 0 0 0 32 0 2 0 1 0 0 0 8 187 0 58 89 183 0 59 191 0 0 0 1 0 136 0 0 0 6 0 1 0 0 3 18 1 17 0 168 0 164 0 0 0 17 0 169 0 132 0 2 0 135 0 0 0 41 0 1 0 1 0 0 0 9 42 182 0 45 42 183 0 60 177 0 0 0 1 0 136 0 0 0 14 0 3 0 0 3 55 0 4 3 56 0 8 3 57 0 160 0 0 0 0 0 17 0 170 0 132 0 2 0 135 0 0 0 41 0 1 0 1 0 0 0 9 42 182 0 45 42 183 0 61 177 0 0 0 1 0 136 0 0 0 14 0 3 0 0 3 80 0 4 3 81 0 8 3 82 0 160 0 0 0 0 0 17 0 171 0 172 0 1 0 135 0 0 0 101 0 4 0 2 0 0 0 53 42 182 0 45 27 16 10 163 0 8 27 4 162 0 11 187 0 3 89 183 0 62 191 27 42 180 0 15 182 0 63 164 0 11 42 180 0 15 182 0 63 60 42 42 27 90 181 0 19 183 0 64 177 0 0 0 1 0 136 0 0 0 30 0 7 0 0 3 110 0 4 3 111 0 15 3 112 0 23 3 114 0 34 3 115 0 42 3 117 0 52 3 118 0 17 0 173 0 134 0 1 0 135 0 0 0 29 0 1 0 1 0 0 0 5 42 180 0 19 172 0 0 0 1 0 136 0 0 0 6 0 1 0 0 3 128 0 17 0 174 0 152 0 1 0 135 0 0 0 45 0 2 0 2 0 0 0 13 42 182 0 45 42 43 182 0 20 181 0 21 177 0 0 0 1 0 136 0 0 0 14 0 3 0 0 3 147 0 4 3 148 0 12 3 149 0 17 0 175 0 176 0 1 0 135 0 0 0 32 0 1 0 1 0 0 0 8 42 180 0 21 184 0 65 176 0 0 0 1 0 136 0 0 0 6 0 1 0 0 3 159 0 17 0 177 0 178 0 1 0 135 0 0 0 29 0 1 0 1 0 0 0 5 42 180 0 15 176 0 0 0 1 0 136 0 0 0 6 0 1 0 0 3 170 0 9 0 179 0 134 0 1 0 135 0 0 0 34 0 1 0 0 0 0 0 10 184 0 10 182 0 13 182 0 66 172 0 0 0 1 0 136 0 0 0 6 0 1 0 0 3 181 0 9 0 180 0 181 0 1 0 135 0 0 0 35 0 2 0 1 0 0 0 11 184 0 10 182 0 13 42 182 0 67 172 0 0 0 1 0 136 0 0 0 6 0 1 0 0 3 204 1 1 0 182 0 134 0 1 0 160 0 0 0 0 0 49 0 183 0 143 0 2 0 135 0 0 0 164 0 4 0 9 0 0 0 84 184 0 68 66 9 55 5 31 9 148 156 0 13 187 0 3 89 18 4 183 0 5 191 31 9 148 154 0 50 167 0 8 42 9 182 0 69 42 182 0 44 154 255 247 167 0 39 31 22 5 101 55 7 22 7 9 148 157 0 6 167 0 23 42 22 7 182 0 69 184 0 68 33 101 55 5 42 182 0 44 154 255 223 177 0 0 0 1 0 136 0 0 0 62 0 15 0 0 3 231 0 4 3 232 0 7 3 234 0 13 3 235 0 23 3 238 0 29 3 239 0 32 3 240 0 37 3 239 0 47 3 244 0 53 3 245 0 60 3 246 0 63 3 248 0 69 3 249 0 76 3 243 0 83 3 252 0 144 0 0 0 4 0 1 0 145 0 49 0 183 0 146 0 2 0 135 0 0 0 114 0 4 0 4 0 0 0 62 31 9 148 156 0 13 187 0 3 89 18 4 183 0 5 191 29 155 0 9 29 18 6 164 0 13 187 0 3 89 18 7 183 0 5 191 29 18 8 162 0 13 29 153 0 13 31 9 148 154 0 7 31 10 97 64 42 31 182 0 70 177 0 0 0 1 0 136 0 0 0 34 0 8 0 0 4 13 0 6 4 14 0 16 4 17 0 26 4 18 0 36 4 22 0 52 4 23 0 56 4 26 0 61 4 27 0 144 0 0 0 4 0 1 0 145 0 17 0 183 0 132 0 2 0 135 0 0 0 34 0 3 0 1 0 0 0 6 42 9 182 0 70 177 0 0 0 1 0 136 0 0 0 10 0 2 0 0 4 37 0 5 4 38 0 144 0 0 0 4 0 1 0 145 0 9 0 184 0 132 0 1 0 135 0 0 0 41 0 3 0 0 0 0 0 13 187 0 71 89 18 72 183 0 73 182 0 74 177 0 0 0 1 0 136 0 0 0 10 0 2 0 0 4 47 0 12 4 48 0 17 0 185 0 186 0 1 0 135 0 0 0 65 0 2 0 2 0 0 0 25 42 182 0 45 42 182 0 44 153 0 11 187 0 75 89 183 0 76 191 42 27 181 0 17 177 0 0 0 1 0 136 0 0 0 22 0 5 0 0 4 71 0 4 4 72 0 11 4 73 0 19 4 75 0 24 4 76 0 17 0 187 0 164 0 1 0 135 0 0 0 29 0 1 0 1 0 0 0 5 42 180 0 17 172 0 0 0 1 0 136 0 0 0 6 0 1 0 0 4 86 0 17 0 188 0 132 0 1 0 135 0 0 0 50 0 2 0 2 0 0 0 14 184 0 11 76 43 198 0 8 43 42 182 0 77 177 0 0 0 1 0 136 0 0 0 18 0 4 0 0 4 105 0 4 4 106 0 8 4 107 0 13 4 109 0 1 0 189 0 176 0 1 0 135 0 0 0 147 0 2 0 2 0 0 0 111 42 182 0 13 76 43 198 0 55 187 0 34 89 183 0 35 18 78 182 0 37 42 182 0 79 182 0 37 18 80 182 0 37 42 182 0 18 182 0 39 18 80 182 0 37 43 182 0 81 182 0 37 18 82 182 0 37 182 0 40 176 187 0 34 89 183 0 35 18 78 182 0 37 42 182 0 79 182 0 37 18 80 182 0 37 42 182 0 18 182 0 39 18 80 182 0 37 18 83 182 0 37 18 82 182 0 37 182 0 40 176 0 0 0 1 0 136 0 0 0 18 0 4 0 0 4 118 0 5 4 119 0 9 4 120 0 61 4 123 0 1 0 190 0 191 0 1 0 135 0 0 0 108 0 2 0 3 0 0 0 56 42 180 0 22 199 0 5 1 176 184 0 11 76 43 198 0 37 184 0 84 77 44 198 0 29 44 42 180 0 22 165 0 21 42 180 0 22 44 182 0 85 154 0 10 43 184 0 86 182 0 50 42 180 0 22 176 0 0 0 1 0 136 0 0 0 34 0 8 0 0 4 158 0 7 4 159 0 9 4 160 0 13 4 161 0 17 4 162 0 21 4 163 0 44 4 165 0 51 4 168 0 1 0 192 0 193 0 1 0 135 0 0 0 67 0 4 0 3 0 0 0 27 184 0 11 77 44 198 0 16 44 187 0 47 89 18 87 183 0 49 182 0 50 42 43 181 0 22 177 0 0 0 1 0 136 0 0 0 22 0 5 0 0 4 193 0 4 4 194 0 8 4 195 0 21 4 197 0 26 4 198 1 9 0 194 0 195 0 0 1 2 0 196 0 172 0 0 1 2 0 197 0 198 0 0 1 2 0 199 0 132 0 0 1 2 0 200 0 132 0 0 1 2 0 201 0 132 0 0 0 8 0 202 0 132 0 1 0 135 0 0 0 32 0 0 0 0 0 0 0 4 184 0 88 177 0 0 0 1 0 136 0 0 0 10 0 2 0 0 0 114 0 3 0 115 0 2 0 203 0 0 0 2 0 204 0 118 0 0 0 10 0 1 0 116 0 234 0 117 0 8) asByteArray! !

!JavaClassDefLoaderTestCase methodsFor: 'data' stamp: 'btb 8/25/2004 21:00'!
expectedGetUTF8StringDisassembly

	^'   0: 03 //iconst0
   1: 3E //istore3
   2: 1B //iload1
   3: 1C //iload2
   4: 60 //iadd
   5: 36 04 //istore 4
   7: 1B //iload1
   8: 36 05 //istore 5
  10: A7 00 BB //goto  197
  13: 2A //aload0
  14: 15 05 //iload 5
  16: 84 05 01 //iinc 5 +1
  19: 33 //baload
  20: 11 00 FF //sipush 255
  23: 7E //iand
  24: 36 06 //istore 6
  26: 15 06 //iload 6
  28: 07 //iconst4
  29: 7A //ishr
  30: AA 00 00 00 00 9F 00 00 00 00 00 00 00 0E 00 00 00 4A 00 00 00 4A 00 00 00 4A 00 00 00 4A 00 00 00 4A 00 00 00 4A 00 00 00 4A 00 00 00 4A 00 00 00 9F 00 00 00 9F 00 00 00 9F 00 00 00 9F 00 00 00 50 00 00 00 50 00 00 00 6F //tableswitch
	default:  189
	0:  104
	1:  104
	2:  104
	3:  104
	4:  104
	5:  104
	6:  104
	7:  104
	8:  189
	9:  189
	10:  189
	11:  189
	12:  110
	13:  110
	14:  141
 104: 84 03 01 //iinc 3 +1
 107: A7 00 5A //goto  197
 110: 2A //aload0
 111: 15 05 //iload 5
 113: 84 05 01 //iinc 5 +1
 116: 33 //baload
 117: 11 00 C0 //sipush 192
 120: 7E //iand
 121: 11 00 80 //sipush 128
 124: 9F 00 0B //ifIcmpeq  135
 127: BB 00 2C //newobject ClassInfo:java.lang.IllegalArgumentException
 130: 59 //dup
 131: B7 00 44 //invokespecial java.lang.IllegalArgumentException>>void <init>()
 134: BF //athrow
 135: 84 03 01 //iinc 3 +1
 138: A7 00 3B //goto  197
 141: 2A //aload0
 142: 15 05 //iload 5
 144: 84 05 01 //iinc 5 +1
 147: 33 //baload
 148: 11 00 C0 //sipush 192
 151: 7E //iand
 152: 11 00 80 //sipush 128
 155: A0 00 14 //ifIcmpne  175
 158: 2A //aload0
 159: 15 05 //iload 5
 161: 84 05 01 //iinc 5 +1
 164: 33 //baload
 165: 11 00 C0 //sipush 192
 168: 7E //iand
 169: 11 00 80 //sipush 128
 172: 9F 00 0B //ifIcmpeq  183
 175: BB 00 2C //newobject ClassInfo:java.lang.IllegalArgumentException
 178: 59 //dup
 179: B7 00 44 //invokespecial java.lang.IllegalArgumentException>>void <init>()
 182: BF //athrow
 183: 84 03 01 //iinc 3 +1
 186: A7 00 0B //goto  197
 189: BB 00 2C //newobject ClassInfo:java.lang.IllegalArgumentException
 192: 59 //dup
 193: B7 00 44 //invokespecial java.lang.IllegalArgumentException>>void <init>()
 196: BF //athrow
 197: 15 05 //iload 5
 199: 15 04 //iload 4
 201: A1 FF 44 //ifIcmplt   13
 204: 15 05 //iload 5
 206: 15 04 //iload 4
 208: 9F 00 0B //ifIcmpeq  219
 211: BB 00 2C //newobject ClassInfo:java.lang.IllegalArgumentException
 214: 59 //dup
 215: B7 00 44 //invokespecial java.lang.IllegalArgumentException>>void <init>()
 218: BF //athrow
 219: 1D //iload3
 220: BC 05 //newarray char
 222: 3A 06 //astore 6
 224: 03 //iconst0
 225: 36 05 //istore 5
 227: A7 00 C0 //goto  419
 230: 2A //aload0
 231: 1B //iload1
 232: 84 01 01 //iinc 1 +1
 235: 33 //baload
 236: 11 00 FF //sipush 255
 239: 7E //iand
 240: 36 07 //istore 7
 242: 15 07 //iload 7
 244: 07 //iconst4
 245: 7A //ishr
 246: AA 00 00 00 00 A5 00 00 00 00 00 00 00 0E 00 00 00 4A 00 00 00 4A 00 00 00 4A 00 00 00 4A 00 00 00 4A 00 00 00 4A 00 00 00 4A 00 00 00 4A 00 00 00 A5 00 00 00 A5 00 00 00 A5 00 00 00 A5 00 00 00 58 00 00 00 58 00 00 00 76 //tableswitch
	default:  411
	0:  320
	1:  320
	2:  320
	3:  320
	4:  320
	5:  320
	6:  320
	7:  320
	8:  411
	9:  411
	10:  411
	11:  411
	12:  334
	13:  334
	14:  364
 320: 19 06 //aload 6
 322: 15 05 //iload 5
 324: 84 05 01 //iinc 5 +1
 327: 15 07 //iload 7
 329: 92 //i2c
 330: 55 //castore
 331: A7 00 58 //goto  419
 334: 19 06 //aload 6
 336: 15 05 //iload 5
 338: 84 05 01 //iinc 5 +1
 341: 15 07 //iload 7
 343: 10 1F //bipush 31
 345: 7E //iand
 346: 10 06 //bipush 6
 348: 78 //ishl
 349: 2A //aload0
 350: 1B //iload1
 351: 84 01 01 //iinc 1 +1
 354: 33 //baload
 355: 10 3F //bipush 63
 357: 7E //iand
 358: 80 //ior
 359: 92 //i2c
 360: 55 //castore
 361: A7 00 3A //goto  419
 364: 2A //aload0
 365: 1B //iload1
 366: 84 01 01 //iinc 1 +1
 369: 33 //baload
 370: 10 3F //bipush 63
 372: 7E //iand
 373: 10 06 //bipush 6
 375: 78 //ishl
 376: 36 08 //istore 8
 378: 19 06 //aload 6
 380: 15 05 //iload 5
 382: 84 05 01 //iinc 5 +1
 385: 15 07 //iload 7
 387: 10 0F //bipush 15
 389: 7E //iand
 390: 10 0C //bipush 12
 392: 78 //ishl
 393: 15 08 //iload 8
 395: 80 //ior
 396: 2A //aload0
 397: 1B //iload1
 398: 84 01 01 //iinc 1 +1
 401: 33 //baload
 402: 10 3F //bipush 63
 404: 7E //iand
 405: 80 //ior
 406: 92 //i2c
 407: 55 //castore
 408: A7 00 0B //goto  419
 411: BB 00 2C //newobject ClassInfo:java.lang.IllegalArgumentException
 414: 59 //dup
 415: B7 00 44 //invokespecial java.lang.IllegalArgumentException>>void <init>()
 418: BF //athrow
 419: 1B //iload1
 420: 15 04 //iload 4
 422: A1 FF 40 //ifIcmplt  230
 425: BB 00 45 //newobject ClassInfo:java.lang.String
 428: 59 //dup
 429: 19 06 //aload 6
 431: 03 //iconst0
 432: 1D //iload3
 433: B7 00 46 //invokespecial java.lang.String>>void <init>(char[], int, int)
 436: B0 //areturn'! !

!JavaClassDefLoaderTestCase methodsFor: 'test' stamp: 'btb 8/25/2004 20:21'!
testReadZipOutputStreamClass

	| readStream aClassDefLoader methodsInfo |
	readStream := ReadStream on: self zipOutputStreamClassBytes.
	aClassDefLoader := JavaClassDefLoader loadFrom: readStream.
	methodsInfo :=aClassDefLoader methodsInfo.
	methodsInfo do: [:each | each disassemblyString]
! !

!JavaClassDefLoaderTestCase methodsFor: 'data' stamp: 'btb 8/16/2004 19:22'!
expectedInterruptedMethodDisassembly
	^'   0: B8 00 0A //invokestatic java.lang.Thread>>java.lang.Thread currentThread()
   3: 04 //iconst1
   4: B7 00 39 //invokespecial java.lang.Thread>>boolean isInterrupted(boolean)
   7: AC //ireturn'! !

TestCase subclass: #JavaSerFullTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Java-Serialization-Tests'!

!JavaSerFullTest methodsFor: 'tests' stamp: 'btb 2/28/2004 12:53'!
checkSerializedData1: aString

	| input allObjects objectStream |
	input := JavaSerReadStream onStream: (ReadStream on: aString).
	allObjects:=input readObjects.
	self should: [allObjects size == 7].
	objectStream:=ReadStream on: allObjects.
	self 
		checkJavaTest1Object1: (objectStream next);
		checkJavaTest1Object2: (objectStream next);
		checkJavaTest1Object3: (objectStream next);
		checkJavaTest1Object4: (objectStream next);
		checkJavaTest1Object5: (objectStream next);
		checkJavaTest1Object6: (objectStream next);
		checkJavaTest1Object7: (objectStream next)! !

!JavaSerFullTest methodsFor: 'tests' stamp: 'btb 3/5/2004 11:00'!
checkJavaTest1Object6: aJavaObject

	| classDesc |
	classDesc := aJavaObject classDescription.
	self should: [classDesc name = 'testPkg.Test6'].
	"more custom serializable code"! !

!JavaSerFullTest methodsFor: 'tests' stamp: 'btb 8/25/2004 21:01'!
checkJavaTest1Object1: aJavaObject 
	| classDesc aFloat aDouble |
	classDesc := aJavaObject classDescription.
	self should: [classDesc name = 'testPkg.Test1'].
	self should: [classDesc superClassDescription isNil].
	self should: [(aJavaObject atField: #aByte) = 255].
	self should: [aJavaObject atField: #aBoolean].
	self should: [(aJavaObject atField: #aShort) = -3].
	self should: [(aJavaObject atField: #aLong) = 65536].
	self should: [(aJavaObject atField: #anInt) = 356].
	aFloat := aJavaObject atField: #aFloat.
	self should: [(aFloat at: 1) = 1078384328].
	self should: [(aFloat at: 2) = 3221225472].
	aDouble := aJavaObject atField: #aDouble.
	self should: [(aDouble at: 1) = 1078020014].
	self should: [(aDouble at: 2) = 343597384].
	self should: 
			[(aJavaObject atField: #someObject) classDescription name = 'testPkg.Test2']! !

!JavaSerFullTest methodsFor: 'tests' stamp: 'btb 2/28/2004 12:54'!
testSerializedData1

	self checkSerializedData1: self serializedByteArrayTestData1! !

!JavaSerFullTest methodsFor: 'tests' stamp: 'btb 10/28/2003 20:33'!
testSerializedData2

	| input allObjects classDesc |
	input := JavaSerReadStream onStream: (ReadStream on: self serializedByteArrayTestData2).
	allObjects:=input readObjects.
	self should: [allObjects size == 1].
	classDesc := (allObjects at: 1) classDescription.
	self should: [classDesc name asString = 'testPkg.Test3'].! !

!JavaSerFullTest methodsFor: 'tests' stamp: 'btb 2/27/2004 20:10'!
setUp
	super setUp.
	JavaClassCache reset! !

!JavaSerFullTest methodsFor: 'data' stamp: 'btb 10/28/2003 19:07'!
serializedByteArrayTestData1

	^#(172 237 0 5 115 114 0 13 116 101 115 116 80 107 103 46 84 101 115 116 49 159 148 236 21 78 60 214 253 2 0 8 90 0 8 97 66 111 111 108 101 97 110 66 0 5 97 66 121 116 101 68 0 7 97 68 111 117 98 108 101 70 0 6 97 70 108 111 97 116 74 0 5 97 76 111 110 103 83 0 6 97 83 104 111 114 116 73 0 5 97 110 73 110 116 76 0 10 115 111 109 101 79 98 106 101 99 116 116 0 18 76 106 97 118 97 47 108 97 110 103 47 79 98 106 101 99 116 59 120 112 1 255 64 65 71 174 20 122 225 72 66 54 182 70 0 0 0 0 0 1 0 0 255 253 0 0 1 100 115 114 0 13 116 101 115 116 80 107 103 46 84 101 115 116 50 14 178 27 29 36 52 229 121 2 0 1 91 0 6 115 105 109 112 108 101 116 0 22 91 76 116 101 115 116 80 107 103 47 84 101 115 116 50 36 73 110 110 101 114 59 120 112 117 114 0 22 91 76 116 101 115 116 80 107 103 46 84 101 115 116 50 36 73 110 110 101 114 59 168 113 23 79 37 172 174 94 2 0 0 120 112 0 0 0 3 115 114 0 19 116 101 115 116 80 107 103 46 84 101 115 116 50 36 73 110 110 101 114 252 7 110 126 183 149 179 131 2 0 2 73 0 5 118 97 108 117 101 76 0 6 116 104 105 115 36 48 116 0 15 76 116 101 115 116 80 107 103 47 84 101 115 116 50 59 120 112 0 0 0 1 113 0 126 0 5 115 113 0 126 0 8 0 0 0 23 113 0 126 0 5 115 113 0 126 0 8 0 0 0 24 113 0 126 0 5 115 114 0 13 116 101 115 116 80 107 103 46 84 101 115 116 51 220 36 174 138 0 110 34 208 3 0 1 76 0 8 115 111 109 101 84 101 115 116 116 0 18 76 106 97 118 97 47 108 97 110 103 47 83 116 114 105 110 103 59 120 113 0 126 0 3 117 113 0 126 0 6 0 0 0 3 115 113 0 126 0 8 0 0 0 1 113 0 126 0 15 115 113 0 126 0 8 0 0 0 23 113 0 126 0 15 115 113 0 126 0 8 0 0 0 24 113 0 126 0 15 116 0 8 83 111 109 101 84 101 115 116 119 13 0 11 115 111 109 101 32 115 116 114 105 110 103 120 118 113 0 126 0 0 115 114 0 13 116 101 115 116 80 107 103 46 84 101 115 116 52 34 80 6 253 178 12 111 195 12 0 0 120 113 0 126 0 0 119 4 0 0 3 9 120 115 114 0 13 116 101 115 116 80 107 103 46 84 101 115 116 53 183 106 128 56 39 239 22 172 12 0 0 120 113 0 126 0 22 119 4 0 0 3 9 120 115 114 0 13 116 101 115 116 80 107 103 46 84 101 115 116 54 246 167 149 232 117 143 116 67 3 0 1 76 0 3 115 116 114 113 0 126 0 14 120 113 0 126 0 13 117 113 0 126 0 6 0 0 0 3 115 113 0 126 0 8 0 0 0 1 113 0 126 0 27 115 113 0 126 0 8 0 0 0 23 113 0 126 0 27 115 113 0 126 0 8 0 0 0 24 113 0 126 0 27 113 0 126 0 20 119 13 0 11 115 111 109 101 32 115 116 114 105 110 103 120 120 118 113 0 126 0 3) asByteArray! !

!JavaSerFullTest methodsFor: 'tests' stamp: 'btb 3/5/2004 11:00'!
checkJavaTest1Object3: aJavaObject

	| classDesc |
	classDesc := aJavaObject description.
	self should: [classDesc name = 'testPkg.Test1'].! !

!JavaSerFullTest methodsFor: 'data' stamp: 'btb 10/28/2003 19:07'!
serializedByteArrayTestData2

	^#(172 237 0 5 115 114 0 13 116 101 115 116 80 107 103 46 84 101 115 116 51 35 179 113 164 104 89 127 70 3 0 0 120 114 0 13 116 101 115 116 80 107 103 46 84 101 115 116 50 14 178 27 29 36 52 229 121 2 0 1 91 0 6 115 105 109 112 108 101 116 0 22 91 76 116 101 115 116 80 107 103 47 84 101 115 116 50 36 73 110 110 101 114 59 120 112 117 114 0 22 91 76 116 101 115 116 80 107 103 46 84 101 115 116 50 36 73 110 110 101 114 59 168 113 23 79 37 172 174 94 2 0 0 120 112 0 0 0 3 115 114 0 19 116 101 115 116 80 107 103 46 84 101 115 116 50 36 73 110 110 101 114 252 7 110 126 183 149 179 131 2 0 2 73 0 5 118 97 108 117 101 76 0 6 116 104 105 115 36 48 116 0 15 76 116 101 115 116 80 107 103 47 84 101 115 116 50 59 120 112 0 0 0 1 113 0 126 0 3 115 113 0 126 0 6 0 0 0 23 113 0 126 0 3 115 113 0 126 0 6 0 0 0 24 113 0 126 0 3 119 13 0 11 115 111 109 101 32 115 116 114 105 110 103 120) asByteArray! !

!JavaSerFullTest methodsFor: 'tests' stamp: 'btb 3/5/2004 11:00'!
checkJavaTest1Object4: aJavaObject

	| classDesc |
	classDesc := aJavaObject classDescription.
	self should: [classDesc name = 'testPkg.Test4'].
	"this is an externalizable...it has a byte array in extra"! !

!JavaSerFullTest methodsFor: 'tests' stamp: 'btb 3/5/2004 11:00'!
checkJavaTest1Object7: aJavaObject

	| classDesc |
	classDesc := aJavaObject description.
	self should: [classDesc name  = 'testPkg.Test2'].! !

!JavaSerFullTest methodsFor: 'tests' stamp: 'btb 2/28/2004 12:54'!
testWriteSerializedData1

	| input allObjects writeStream javaStream result |
	input := JavaSerReadStream onStream: (ReadStream on: self serializedByteArrayTestData1).
	allObjects:=input readObjects.
	"input cache inspect."
	writeStream := WriteStream on: ByteArray new.
	javaStream:=JavaSerWriteStream onStream: writeStream.
	javaStream writeContents: allObjects.
	"javaStream cache inspect."
	javaStream flush.
	result := writeStream contents.
	self checkSerializedData1: result.
	! !

!JavaSerFullTest methodsFor: 'tests' stamp: 'btb 3/5/2004 11:00'!
checkJavaTest1Object2: aJavaObject

	| classDesc innerArray inner1 inner2 inner3|
	classDesc := aJavaObject classDescription.
	self should: [classDesc name = 'testPkg.Test3'].
	self should: [classDesc superClassDescription name = 'testPkg.Test2'].
	self should: [(aJavaObject atField: #someTest) asString = 'SomeTest'].
	innerArray := (aJavaObject atField: #simple).
	self should: [innerArray class == JavaSerArray].
	self should: [innerArray type type name = 'testPkg.Test2$Inner'].
	self should: [innerArray size = 3].
	inner1:=innerArray at: 1.
	self should: [(inner1 atField: #value) = 1].
	inner2:=innerArray at: 2.
	self should: [(inner2 atField: #value) = 23].
	inner3:=innerArray at: 3.
	self should: [(inner3 atField: #value) = 24].
	! !

!JavaSerFullTest methodsFor: 'tests' stamp: 'btb 3/5/2004 11:00'!
checkJavaTest1Object5: aJavaObject

	| classDesc |
	classDesc := aJavaObject classDescription.
	self should: [classDesc name = 'testPkg.Test5'].! !
JavaAttributeInfo initialize!
JavaType initialize!
JavaByteCodeInterpreter initialize!
